{-# LANGUAGE FlexibleContexts #-}

module Sites.Hell.Events.Construction
	( (/)
	, (^)
	) where

import Prelude hiding (Fractional((/)), (^))

import Data.Convertible

import Sites.Hell.Events.GameEvent as Scene (EventReel)

infixl 1 /
(/) :: (Convertible a EventReel, Convertible b EventReel) => a -> b -> EventReel
a / b = convert a <> convert b

infixl 6 ^
(^) :: (Convertible r EventReel) => a -> (a -> b -> r) -> b -> EventReel
(^) a f = convert . f a
