{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE FlexibleInstances #-}
module Sites.Hell.Events.Hubur.HoundKnight
	( HoundKnight(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

{-

TODO:

* parametrics for the new body types in the sex scenes

# TIER 1:
	* floating head could use the 'make out' / 'suck off' branches i think, just w/ its own tweaks
	* floating dick could use the 'fuck it' branch (with several tweaks and jumps (no rimming, no jerking it off, etc))
	* formless orb needs a special puncture-fuck scene a la lesser hellhounds
	* dialog 'by yr leave' gag + flags
	* do we let centaurs(/snakes) rim the hound? the rim branch is currently hidden under the biped/naga "fuck it" branch and assumes some biped-ish body blocking, and it branches back to that scene at the end

-}

import Prelude hiding ((/), (^))

import Data.Maybe (catMaybes)

import Server.JSON
import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((^), (/))

import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..))

name :: String
name = "houndknight"

data HoundKnight = HoundKnight
	{ flame :: Body
	}
	deriving (Eq, Ord, Show, Read)

_flame :: HoundKnightEncounter -> Body
_flame = flame . _body

data Body = ShadowFire | BlackWhite | Skull
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance Random HoundKnight where
	randomR _ = random
	random = getRand $ HoundKnight
		<$> genRandom

instance ToJSON HoundKnight where
	toJSON (HoundKnight b) = toJSON [fromEnum b]

instance FromJSON HoundKnight where
	parseJSON v = case fromJSON v of
		Success [b] -> case HoundKnight
			<$> safeToEnum b of
				Just h -> return h
				_ -> mzero
		_ -> mzero

data Mind = Hunter | Guard | Traitor
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance ToJSON Mind where
	toJSON v = toJSON [fromEnum v]

instance FromJSON Mind where
	parseJSON v = case fromJSON v of
		Success [m] -> case safeToEnum m of
				Just h -> return h
				_ -> mzero
		_ -> mzero

allNames :: [String]
allNames =
	[ "Albrecht", "Aethelred", "Adelbrand"
	, "Baudigisil", "Baudegund", "Byrhtnoth"
	, "Conroicht"
	, "Dagaulf", "Dagaperht", "Droctbold"
	, "Ebirmuot", "Eparfrid", "Erligar"
	, "Faolan"
	, "Gundiflat"
	, "Hadufuns"
	, "Irmgard"
	, "Lantgildis"
	, "Santrieste"
	, "Wolfgelt"
	, "Vuldargoza"
	]

deck :: RandomGen g => Rand g (Enumerable HoundKnightEncounter)
deck = do
	body <- liftRand $ shuffle [ShadowFire, BlackWhite, Skull]
	mind <- liftRand $ shuffle [Hunter, Guard, Traitor]
	name <- liftRand $ shuffle allNames
	return $ EncGlob
		<$> (HoundKnight
			<$> from body)
		<*> (Mental
			<$> from name
			<*> pure False
			<*> (from mind))

instance EncounterEncoding HoundKnight Mind where
	encEncode (EncGlob b m) = name `withData` toJSON [toJSON b, toJSON m]
	encDecode v = case extractRaws v of
		Just (pName, [b, m], _)
			| pName == name -> EncGlob <$> parseJSON b <*> parseJSON m
		_ -> mzero

-- uh not 100% if this is correct :/
bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= [ Null , Null ]
	]

variants :: [(MapZone, ())]
variants =
	[ (Badland, ())
	, (Field, ())
	]


data Index
	= Talk TalkOption
	| FuckConfirm | FuckReject
	| MakeOut | SuckOff MakeoutPath
	| ItMounts MakeoutPath | MountIt
	| FuckIt | WindFuck | Rim | RimFinish | FuckAnal RimPath
	| JerkItOff | HandsFree
	| LeaveAfterSex SexMethod
	deriving (Eq, Ord, Show, Read)

data TalkOption
	= Nope | Gate | Refuse
	| RefuseNope | RefuseGate
	| Waiting | ByYrLeave
	| FeralHounds | LesserHounds
	| WannaFuck
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data MakeoutPath = MadeOutFirst | DirectlyIn
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data RimPath = RimmedItFirst | DirectlyAnal
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data SexMethod = ItTops | YouTop | RimOnly | BlowjobOnly
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

type HoundKnightEncounter = EncGlob HoundKnight Mind

instance Scene Index () HoundKnightEncounter where
	link f = case f of
		Talk t -> talk t
		FuckConfirm -> letsFuck
		FuckReject -> fuckReject
		MakeOut -> makeOut
		ItMounts path -> itMounts path
		SuckOff path -> suckItOff path
		MountIt -> mountIt
		WindFuck -> windFuck
		FuckIt -> fuckIt
		Rim -> rim
		RimFinish -> rimFinish
		FuckAnal path -> fuckAnal path
		JerkItOff -> jerkItOff
		HandsFree -> handsFree
		LeaveAfterSex sex -> leaveAfterSexClose sex

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () HoundKnightEncounter
scene b k = SetFlag (Global MetHoundKnight) 1 : describe b k <> opening b k

dialog :: HoundKnightEncounter -> EventReel -> Event m a b
dialog _ = Dialog2 "/static/img/icon.png" "Hellhound Knight"


describe :: Encounter Index () HoundKnightEncounter
describe _ k =
	[ Narration2 $ "It's a hellhound knight. Bigger again by half the size of the lesser hellhounds, about the size of a pony. It has a hulking, hyenalike shape."
	/ Paragraph / case _flame k of
		ShadowFire -> "It's a mess of bulky shadow and crackling fire"
		BlackWhite -> "It's a mass of white flames, burning with a strange ethereal energy"
		Skull -> "It's a mass of pitch-black substance that peels back around its head and spine to reveal fresh white bone"
	/ ", but on top of that it wears shining armor: silver, folded into complex ridges. There's a clasp worn as a peytral around its chest, which connects to a set of segmented plates that spans down the back of its neck"
	/ case _flame k of
		ShadowFire -> ", fire spilling out between them like a mane"
		BlackWhite -> ", with a crest of dingy white flame bursting out like a mane"
		Skull -> ", with the segmented bones of its neck visible between the slats"
	/ ". It's wearing a crest across its head that covers its forehead and the top of its muzzle. It has a crown of horns, curved forwards like a bulls but branching like a deer's: they look like nothing so much as burnt tree branches. Its eyes are like coals: four of them,"
	/ case _flame k of
		BlackWhite -> c "red flames amid the pale white of its head"
		x -> "set into" / case x of
				ShadowFire -> "the darkness of its head"
				Skull -> "its bare skull"
				_ -> error "unreachable"
			/ ", burning flames that streak up over its plating"
	/ "."
	]


opening :: Encounter Index () HoundKnightEncounter
opening _ k =
	[ dialog k $ open "Ho there, soul!"
		// Paragraph // "I'm down from the mountains, to hunt after those feral hounds."
		// Paragraph // "Would perchance they have alighted upon your path?"
	, Choices2
		[ ("uh no sorry, haven't seen any", Talk Nope, Nothing)
		, ("uh only the ones at cerberus' gate", Talk Gate, Just $ C (Global VisitedHellGate) IsSet)
		, ("why should i tell you?", Talk Refuse, Nothing)
		]
	]

talk :: TalkOption -> Encounter Index () HoundKnightEncounter
talk t b k = case t of
	Nope ->
		[ dialog k $
			open "Hm, I suppose a single soul's eyes can only see so far."
			// Paragraph // "I will warn you, the feral hounds are treacherous beasts, and one such as you may be blind to their manipulations."
		, Choices
			[("sure w/e", Talk Waiting)
			]
		]
	Gate ->
		[ dialog k $
			open "Ah, that rabble! They are regrettably well-defended against our incursion."
			// Paragraph // "Nevertheless, it is commendable that you aid the royal cause with your intelligence."
		, Choices
			[("sure w/e", Talk Waiting)
			]
		]
	Refuse ->
		[ Narration2 $ open "The hound peers down at you, eyes fuming."
		, dialog k $
			open "You may not realize, but the feral hounds seek to unweave the world that you perceive."
			// Paragraph // "It would be utterly unwise for you to act in their aid."
			// Paragraph // "So I ask you again: have you seen any feral hounds?"
		, Choices2
			[ ("nope not any", Talk RefuseNope, Nothing)
			, ("well only the ones at cerberus' gate", Talk RefuseGate, Just $ C (Global VisitedHellGate) IsSet)
			]
		]
	RefuseNope ->
		[ Narration2 $ open "The hellhound snorts, blowing a plume of fire from its nose."
		, dialog k $
			open "Well then."
			// Paragraph // "Thank you for your aid, then."
		, Narration2 $ open "And then it turns and twists and is away."
		, DeactivateSelf
		]
	RefuseGate ->
		[ dialog k $
			open "Hmph. That rabble is well-defended against the royal forces."
			// Paragraph // "But thank you for your aid."
		, Narration2 $ open "And then it turns and twists and is away."
		, DeactivateSelf
		]
	Waiting ->
		[ Narration2 $ open "The hound stamps its paws on the ground, as if eager to resume its hunt. But it waits for a moment, to see if you have anything more to say:"
		, Choices2
			[ ("so what's w/ those feral hounds anyway?", Talk FeralHounds, Nothing)
			, ("so hey you wanna fuck", Talk WannaFuck, Nothing)
			-- so getting the 'byyrleave' thing should flip a global flag and then that should replace this one with like 'yah you got determination to depart' or something like that. b/c jokes. the hinge is the new option should be something more punchy than "determination to depart"
			, ("hey don't wait up on my account, by yr leave, etc", Talk ByYrLeave, Just $ C (Global HoundKnightLeave) NotSet)
			-- FIXME: by yr leave gag!!
			, ("hey don't wait up on my account, by yr leave, etc", Talk ByYrLeave,  Just $ C (Global HoundKnightLeave) IsSet)
			]
		]
	ByYrLeave ->
		[ Narration2 $ open "The hound turns away from you, looking up towards its path. But before it goes:"
		, dialog k $
			open "Just so you know, that's not actually what that means. 'By your leave' is a request for permission, not to grant a determination to depart."
			// Paragraph // "Regardless, I am on my way."
		, SetFlag (Global HoundKnightLeave) 1
		, DeactivateSelf
		]
	FeralHounds ->
		[ dialog k $
			open "Traitors to the crown, and Cerberus the worst of them. We were charged with shepherding you souls; of building a world in this place of nightmares. But through vanity and selfishness some hounds have gone astray and spurned their obligation, and now work only to satisfy their own corrupted desires."
			// Paragraph // "Does that clarify things for you?"
		, Choices
			[ ("sure okay", Talk Waiting)
			, ("i mean those lesser hounds don't seem that great either", Talk LesserHounds)
			]
		]
	LesserHounds ->
		[ dialog k $
			open "Yes, well."
			// Paragraph // "It is... a phase, that many hounds go through. We are obligated to know our charges, and we do not have minds like yours. The allure of the mortal mind can be very tempting: tempting enough to construct our minds in mimicry of yours, and become nothing more than an impulsive beast."
			// Paragraph // "...They do not mean ill."
		, Choices
			[ ("sure okay", Talk Waiting)
			]
		]
	WannaFuck -> wannaFuck b k

wannaFuck :: Encounter Index () HoundKnightEncounter
wannaFuck b k =
	[ Narration2 $ open "It snorts."
	, dialog k $ open "You're aware I'm not one of those common hounds? The ones who've tied themselves tight to their animal urges, unable to think beyond fighting and fucking."
	, FauxChoice "yea i got that"
	, dialog k $ open "In that case..."
	, Narration2 $ open "It shuffles, paws digging into the ground."
	] <> case locoplan b of
		x | x `elem` [Spec Orb, Spec FloatingDick, Spec FloatingHead, Basic Formless, Basic Complex] ->
			[ dialog k $ open "It is not that I... lack those urges. Just that, um,"
			, Narration2 $ open "It paws the ground a little anxiously."
			, dialog k $ open "Your body! It is, uh, very-- unique. And I would not know how to, um operate, under such conditions. So I would be unable to aid you in such fulfillment."
				// Paragraph // "My apologies. But, if you have no further need of me, then I will be off"
			, Narration2 $ open "And with that, it sets off."
			, DeactivateSelf
			]
		_ ->
			[ dialog k $ open "It is not that I... lack those urges. Just, it is a matter of not being-- overwhelmed. By their intensity."
			, Narration2 $ open "As it's saying this, though, its flanks are quivering. It's with an audible slurp that its cock unsheathes, nubby tip glowing like hot iron, length drizzling fuming black pre across the ground."
			, dialog k $ open "And, of course, we hounds are eager to -- provide for the souls under our charge. So, therefore, if you have any such desire, I would be... eager to aid in its fulfillment."
			, Choices
				[ ("nah yknow what i think i'm good", FuckReject)
				, ("yeah lets do this", FuckConfirm)
				]
			]

fuckReject :: Encounter Index () HoundKnightEncounter
fuckReject b k =
	[ dialog k $ open "Ah. Uh. C-certainly."
	, Narration2 $ open "Its cock is still drooling, unsheathing out across its underbelly and smearing black pre everywhere."
	, dialog k $ open "If you have no further need of me, then, I will, um, be off."
	, Narration2 $ open "It sets off with an awkward gait, bowlegged around the bulk of its unsheathed cock."
	, DeactivateSelf
	]

letsFuck :: Encounter Index () HoundKnightEncounter
letsFuck b k =
	[ Narration2 $ open "The hound is huffing, fire licking out from its open mouth, flaming drool spilling from its lips as its tongue darts out. Its cock spills from its sheath, squelching, shaft encrusted with thick gummy tar: old pre and come, smeared across the shaft and cooked down to a crusted, gritty paste. It whimpers, cock shuddering, and spurts a rope of fresh pre onto the churned-up dirt. Thick cords spill down the fat underside, hissing and smoking as it burns away into a tarry crust."
	, dialog k $ open "Then shall we-- let us begin. Please."
	-- this IS missing 'oral top' scenes. shove yr dick in its mouth etc
	, case locoplan b of
		Spec FloatingHead -> Choices
			-- TODO: MakeOut & SuckOff scenes should permit floating heads
			[ ("make out", MakeOut)
			, ("suck it off", SuckOff DirectlyIn)
			]
		-- TODO: should have a puncture-fuck scene a la lesser hellhounds
		Spec Orb -> bodyFail "letsFuck" $ Spec Orb
		Spec FloatingDick -> Choices
			-- TODO: FuckIt scene should permit floating dicks
			[ ("fuck it", FuckIt)
			]
		_ -> Choices $ catMaybes $
			[ if bodyCount Head b == 0
				then Nothing
				else Just ("make out", MakeOut)
			, if bodyCount Head b == 0
				then Nothing
				else Just ("suck it off", SuckOff DirectlyIn)
			, case locoplan b of
				Basic Slithering -> Nothing -- is there an equivalent for snakes? like. this is getting into size/traction territory again; how big does a snake have to be before it's reasonable to fuck it
				Basic Formless -> Nothing
				Basic _ -> Just ("let it mount you", ItMounts DirectlyIn)
				_ -> Nothing
			, topOpt b
			]
		]

makeOut :: Encounter Index () HoundKnightEncounter
makeOut b k =
	[ Narration2 $
		case locoplan b of
			Basic Biped -> open "You kneel down in front of the hound"
			Basic Centaur -> open "You fold your legs underneath you and settle to the ground" // case dickLocation b of
					Just x -> open ", sharply aware of the pressure"
						// case x of
							DickSheathed -> open "of your sheath squeezed tight as it's pinned beneath your" // hips
							DickExternal -> open "of your" // Cock^s // "squashed under your hindquarters"
							_ -> open "of your" // Cock^s // "pressing against the rim of your" // sheath // ", pinned under your bulk"
					Nothing -> mempty
			Basic Naga -> open "You slither close in front of it, and sit back on your own wide tail"
			Basic Slithering -> open "You slither close in front of it, head held erect like you're about to strike"
			Basic Quadruped -> (case bodyHeight b of
					SmallAnimal -> open "You step closer and tip your head up,"
					_ -> open "You step closer,")
				// "butting your"
				// case mouthType b of
					Mouth -> open "face"
					_ -> open muzzle
				// "against its shoulder,"
				// case mouthType b of
					Muzzle -> "sliding your muzzles together"
					Mouth -> "pressing your lips against its muzzle"
					Snout -> "pressing your snout against its muzzle"
			-- TODO: orb? floating head? floating dick??
			f -> bodyFail "makeOut" f
		// ". It leans in, eagerly lapping across your face, and you open wide, letting its dragging tongue shove into your mouth and bloat your cheeks with drool. It huffs and pants,"
		// case bodyMat_ Head b of
			Solid (FMat _ x) | x `elem` [Fur, Coat] -> open "drool soaking your" // matword x
			_ -> open "spitting drool"
		// "all across your face as it sloppily kisses you."
		// case locoplan b of
			Basic Quadruped -> open "You lean in to match, body pressing against its."
			Basic Slithering -> open "You slide your body closer, keeping your face pressed against its as your coils spill across its forelegs and chest."
			_ -> open "You cup its neck and shoulders," // fingers // "digging into the slats of its armor, and press yourself closer."
		// Paragraph // "Your"
		// case mouthType b of
			Mouth -> open "lips drag"
			_ -> open muzzle // "drags"
		// "across its muzzle, fiery drool spilling across your cheek, and it pants out a plume of flame"
		// case bodyMat_ Head b of
			Solid (FMat _ Skin) -> open ", bursting across your skin"
			Solid (FMat _ Fur) -> open ", coiling over your fur"
			Solid (FMat _ Coat) -> open ", coiling across your coat"
			_ -> mempty
		// ". Its tongue laps over your lips again, pressure tingling, and you kiss back, slurping its tongue back into your mouth, shoving down your throat, its muzzle opening so wide its teeth dig into the sides of your face, half your head swallowed up in its mouth as it slavers and drools, lashing tongue shoveling slimy dog spit down your throat."
		// Paragraph // "It whines, and a hot splatter of slime"
		// case locoplan b of
			Basic Quadruped -> open "sprays across your" // forelegs
			Basic Slithering -> open "sprays over your coils"
			_ -> open "hits your stomach"
		// ": its cock is wholly unsheathed and trembling, gushing blackened pre all the way between its forelegs, smoking droplets"
		// case locoplan b of
			Basic Quadruped -> "drenching your chest and forelegs"
			Basic Slithering -> case bodyMat_ Chest b of
				Solid (FMat _ Scales) -> "spilling all over your scales"
				_ -> "spilling down your coils"
			_ -> case bodyMat_ Chest b of
				Solid (FMat _ Fur) -> "clinging to your shaggy fur"
				Solid (FMat _ Coat) -> "clinging in pearly drops all through your coat"
				_ -> "hitting your stomach"
		// ". You break the kiss, tongue lurching back up your throat, and it jerks from your mouth, a huge black tentacle wrapping across the side of your head, leaving your" // muzzle // "flooded with boiling drool."
	, Choices $ catMaybes $
		[ Just ("suck it off", SuckOff MadeOutFirst)
		, case locoplan b of
			Basic Slithering -> Nothing
			Basic Formless -> Nothing
			Basic _ -> Just ("let it mount you", ItMounts MadeOutFirst)
			_ -> Nothing
		, topOpt b -- should these have different blocking or does it not really matter?
		]
	]

topOpt :: BodyGlob -> Maybe (String, Index)
topOpt b = if hasDick b
	then case locoplan b of
		Basic x | x `elem` [Centaur, Quadruped] -> Just ("mount it", MountIt)
		Basic Slithering -> Just ("wind around it & fuck it", WindFuck) -- see also "slither up inside it", maybe
		Basic Formless -> Nothing
		Basic _ -> Just ("fuck it", FuckIt)
		_ -> Nothing
	else Nothing

itMounts :: MakeoutPath -> Encounter Index () HoundKnightEncounter
itMounts path b k =
	[ Narration2 $
		case path of
			MadeOutFirst -> open "Its cock is utterly drenched in pre, the ruddy glow of its shaft nearly entirely quenched by the layers of black slime coating its length, steaming and bubbling as the heat of its cock cooks it into thicker and thicker tar."
			DirectlyIn -> open "Its cock is drooling with pre, thick black cords smeared over its length, dissolving some of the old gummy tar stuck to it."
		// case locoplan b of
			Basic Naga -> open "You lay back across your tail, showing it"
				// hasCloaca ? "your spread cloaca" ?: "the narrow slit of your asshole"
				// ", and it's immediately on you: it bounds forward, cock smearing a gritty line all across the underside of your tail, overshooting and"
				// hasDick ? (open "glancing across your own" // Cock^s // ",")
				// "smearing across your stomach. It stands over you, cock throbbing and gushing all across your front, goopy black pre sluggishly bubbling as it ruts back and forth."
			Basic x | x `elem` [Centaur, Quadruped, Biped] ->
				case x of
					x' | x' `elem` [Centaur, Quadruped] -> open "You twist around and show the hound your ass, and it's immediately on it: it leaps up, paws clutching you around"
						// case x of
							Quadruped -> "your shoulders"
							Centaur -> "the waist of your upper body"
							_ -> bodyFail "itMounts (a)" x
						// "; the impact makes your" // forelegs // "buckle and drives you downward onto your knees."
					Biped -> open "You twist around and show the hound your ass, and it's immediately on you: it leaps up, so big it goes nearly bipedal trying to wrap its paws around your hips. It slides forward, giant paws pressing against your shoulders, and the weight slams you down into the dust, shoulders pinned, ass up."
					f -> bodyFail "itMounts (b)" f
				// "It wildly ruts against your ass: cock skewing in all directions, over your hip, between your legs to jar against your"
				// hasExternalBalls ? "hanging balls" ?: (case dickLocation b of
					Just DickSheathed -> open "unsheathed" // Cock^s
					Just DickExternal -> open "half-hard" // Cock^s
					Just _ -> open "fat vent"
					_ -> open "crotch")
				// ", up across your back"
				// case bodyMat_ Back b of
					Solid (FMat _ Skin) -> ", smearing your skin in slimy, sluggishly-boiling trails of black pre"
					Solid (FMat _ Fur) -> ", sticking your already-sodden fur to your skin in thick, greasy whorls"
					Solid (FMat _ Coat) -> ", flattening your coat into a sodden mess"
					_ -> "drenching you in hot, boiling pre"
				// "."
			f -> bodyFail "itMounts (c)" f
		// Paragraph // "The hound finally finds its mark, though through no help of yours. It hunches more,"
		// case locoplan b of
			Basic Biped -> open "cock sliding up and down the crack of your ass, between your thick cheeks, smearing old pre and gushing new, and finally the sharp tip hits the clenched furl of your hole and catches."
			Basic Naga -> if hasCloaca b
				then open "cock sliding back and forth over your flushed lips,"
					// hasDick ? (open "jarring against your" // Cock^s // "and coating" // "it"^p "them" // "with thick, clotted pre,")
					// "before finally the sharp tip hits the inner curve of your spread cloaca and catches."
				else open "cock sliding back and forth over your underbelly, "
					// hasDick ? (open "jarring against the base of your" // Cock^s // "and coating" // "it"^p "them" // "with thick, clotted pre,")
					// "before finally the sharp tip hits the thin divot of your asshole and catches, spreading it just-barely around the tip."
			Basic x | x `elem` [Centaur, Quadruped] -> open "cock sliding against your" // hips // ", over your" //
				case bodySpecies Legs b of
					Just Unicorn -> "fat horse ass"
					Just Bull -> "thick, meaty bull ass"
					Just Wolf -> "lean ass"
					_ -> "fat ass"
				// ". It's smearing old pre all over and gushing new,"
				// case bodyMat_ (Waist Hind) b of
					Solid (FMat _ x) | x `elem` [Fur, Coat] -> open "soaking your" // matword x // "in gritty slime"
					_ -> open "soaking your hips and ass in gritty slime"
				// ". Finally the sharp cocktip catches against the furl of your hole and sticks."
			f -> bodyFail "itMounts (d)" f
		// "It freezes for a second,"
		// case locoplan b of
			Basic Naga -> "body trembling above you"
			Basic Centaur -> "paws wrapped around your waist"
			Basic x | x `elem` [Biped, Quadruped] -> "paws clenching on your shoulders"
			f -> bodyFail "itMounts (e)" f
		// ", and then jerks forward, hips slamming against your body as it crams most of its cock into you in a single thrust."
		// (hasLocotype Naga &*& hasCloaca) ? (open "Its cock shoves into your cloaca, heat burning along the root of your" // Cock^s // ", gritty pre smearing all over your sensitive inner flesh.")
		// "The hound howls, yammering as it drags back and thrusts again, the force nearly burying you in the dirt. Its cock is burning hot, the pre sheathing it boiling all around its flesh, and the heat blossoms sharply as it sinks into you, leaving a hot afterimage in your guts, outlining the exact path of its thrust."
		// Paragraph
		// case locoplan b of
			Basic x | x `elem` [Biped, Quadruped] -> open "Its hips smack against your ass, the weight of its paws the only thing keeping you from"
				// case x of
					Biped -> "sprawling forward"
					Quadruped -> "being fucked to the ground"
					_ -> bodyFail "itMounts (f)" x
				// ". The hound bays again,"
				// case x of
					Biped -> case bodySpecies Head b of
						Just Human -> "flaming spit drooling all across your hair, down the back of your neck,"
						_ -> "flaming spit drooling all across your head, down the back of your neck,"
					Quadruped -> "flaming spit drooling down all across your back"
					_ -> bodyFail "itMounts (g)" x
				// "and tries to stuff yet more of its cock inside, sheath grinding against your stretched hole, balls slapping hard against your cheeks. You're enveloped under the hound, black muscle and flaming fur pressed tight all across your sides and back, vanished under the bulk of its body."
			Basic Centaur -> open "Its hips smack against your ass, driving your" // feet // "a half-step forward. The hound bays again, mouth open and drooling, flaming spit"
				// case bodyMat_ (Waist Fore) b of
					Trans (FMat _ Skin) (FMat _ x) -> open "splattering all down your back -- your upper back -- and then drenching your" // matword x
					Trans (FMat _ t) (FMat _ b) | t `elem` [Fur, Coat] -> open "soaking your" // matword t // "and then drooling down to your waist"
						// if b == t
								then open "in sloppy streams of matted" // (if b == Fur then "fur" else "hair")
								else open "to soak your" // matword b
					_ -> open "splattering down your back -- your upper back -- and then spilling over your waist"
				// ". You twist back, letting it lap up your" // partAdjective Chest // "chest to your head, shoving its drooling tongue into your mouth. The hound thrusts wildly, yapping into your mouth, trying to stuff yet more of its cock inside you, sheath grinding against your stretched hole, balls slapping hard against your cheeks."
			Basic Naga -> open "Its hips smack against your front,"
				// hasDick ? (open "pinning your" // Cock^s // "against its underbelly and")
				// "shoving your entire body back from the force of it. Its sheath throbs,"
				// hasCloaca
					? "wetly kissing your gaping, splayed-open cloaca"
					?: "shoved up tight in a wrinkled mess against your broken-open asshole"
				// ". The hound bays again, mouth open and drooling fiery spit, and it tips its head down to lap all across your face, shoving its sloppy tongue into your mouth,"
				// case bodyMat_ Head b of
					Solid (FMat _ x) | x `elem` [Skin, Scales] -> open "hot breath billowing across your spit-slathered face"
					Solid (FMat _ x) | x `elem` [Fur, Coat] -> open "hot breath ruffling your spit-soaked" // matword x
					_ -> open "hot breath rippling over your face"
				// ". The hound thrusts wildly, your body bouncing against its thrusts, trying to stuff yet more of its cock inside, balls smacking hard against your underbelly."
			f -> bodyFail "itMounts (h)" f
		// Paragraph // "Its cock throbs, spreading your"
		// (hasLocotype Naga &*& hasCloaca)
			? "splayed cloaca"
			?:"aching hole"
		// "wider, tip erupting in spurt after spurt of boiling pre, hosing down your insides until each of its thrusts shove into you with a wet" // em "slap" // ", pre"
		// (hasLocotype Naga &*& hasCloaca)
			? "squirting" // (hasDick
				? (manyCocks
					? "from between your cocks"
					?: "out around yours and its shafts")
				?: "around its shaft")
			?: "gushing out around its shaft"
		// ", smearing across the formless black matter of its body, giving it a messy drooling fringe as it piles up with each hammering thrust. Its hips buck forward, punching its cock back and forth through"
		// (hasLocotype Naga &*& hasCloaca)
			? "your splayed lips"
			?: "your slack hole"
		// "."
		// case locoplan b of
			Basic Centaur -> "Its chest rumbles as it growls and pants, lapping eagerly across your face. It clamps its muzzle across your head, steadily feeling you burning drool, the excess gushing from your mouth, pouring over its shadow-fangs and spilling down your chest."
			Basic Naga -> "Its chest rumbles against yours as it growls and pants, muzzle clamped around your face, steadily feeding you burning drool, excess gushing from your mouth and sheening your face, spilling down your neck."
			_ -> "Its chest rumbles above you as it growls and pants, yipping when it hilts and tries to grind deeper"
		// ", the wrinkled flesh of its sheath sloppily kissing up and down your"
		// hasLocotype Naga &*& hasCloaca ? "cloaca" ?: "hole"
		// "as it stirs its cock around inside your flooded guts."
		// Paragraph // "Its cock shudders with each pulse of pre, but slowly the flesh of its shaft gets firmer, less rubbery, and you can feel its knot start to swell. It knocks against your"
		// hasLocotype Naga &*& hasCloaca ? "bruised lips" ?: "bloated ring"
		// ", slurping inside and yanking out with a slobbery" // em "slurp" //". But the knot swells larger, stuck inside you as a burning lump or bearing down against your"
		// hasLocotype Naga &*& hasCloaca ? "lips" ?: "hole"
		// "longer before it punches through, and each sharp yank -- force overwhelming your"
		// hasLocotype Naga &*& hasCloaca ? "splayed-wide lips" ?: "spread asshole"
		// "-- nearly takes your guts with it."
		// (hasLocotype Naga &*& hasCloaca)
			? (open "The flesh under your cloaca bulges, "
				// hasDick ? (open "your" // Cock^s // "angling out as the knot crushes" // "it"^p "them" // ",")
				// "and your lips gape wider and wider before it pops out with a gush of slime, ooze spilling out over your bruised, swollen lips all over your underbelly.")
			?: (open "The flesh under your hole bulges before your ring parts wider, into a fat crater, and it pops out with a gush of slime, ooze spilling out over the suddenly-gaping ring and all down your"
				// hasLocotype Naga ? "underbelly" ?: "thighs" // ".")
		// Paragraph // "The hound struggles, bloated knot mashing against your"
		// (hasLocotype Naga &*& hasCloaca) ? "cloaca" ?: "ass"
		// ", bearing down only to slurp back out, thickly webbed with cords of pre: again and again it shoves forward, knot a giant fat ember"
		// (hasLocotype Naga &*& hasCloaca) ? "lodged shallowly into your vent" ?: "between your cheeks"
		// ", burning hot where it grinds it hard against your bruised"
		// (hasLocotype Naga &*& hasCloaca) ? "lips" ?: "rim"
		// ", before finally"
		// (hasLocotype Naga &*& hasCloaca) ? "your cloaca" ?: "your hole"
		// "gives up, warping under the pressure and admits it back"
		// (hasLocotype Naga &*& hasCloaca) ? "inside" ?: "into your ass"
		// "with a wet gurgle. The hound tips its head back and howls, breaking off into yapping as it keeps trying to thrust: its struggle now to yank it back out, but as its knot swells and swells it's far too huge to pull out. You flutter around it,"
		// (hasLocotype Naga &*& hasCloaca) ? "bloated lips" ?: "asshole"
		// "spasmodically clenching around the very base of its shaft, guts wetly sucking on the tip, entire body feeling stabbed through by the heft of its mammoth cock."
		// Paragraph // "The sludgy flow of pre stutters as its cock begins to pulse, and it comes in streamers, all the fight going out of the hound as it nearly collapses right on top of you,"
		// hasLocotype Centaur ? "head draped over your waist" ?: "head draped over your neck"
		// ", panting."
		// (not . hasLocotype Centaur) ? "Drool spills all over your cheek, and you tip your head to the side, letting it drag its tongue all over your face."
		// Paragraph // "Its cock unloads, knotted tight into your ass. Heat burns through you, spilling higher, guts gurgling as its thick, slimy come floods inside, slowly mixing with the flood of pre already clinging to your insides. Its hips jerk and twitch, cock lurching as it erupts, squirt after squirt of come turning into a continual steady flow, like it's pissing come into you, more and more until your stomach sloshes and bulges,"
		// case locoplan b of
			Basic Naga -> "achingly full pressed against its underbelly"
			Basic Biped -> "achingly full pinned to the ground"
			Basic x | x `elem` [Centaur, Quadruped] -> "bloating out beneath you"
			f -> bodyFail "itMounts (i)" f
		// ", the pressure only increasing as it sprays more and more acrid come into your flooded guts."
		// Paragraph // case locoplan b of
			Basic Naga -> open "The hellhound pants on top of you, knotted tight, and only slowly rolls to the side -- dragging you with it -- when you elbow its side. The motion jostles you,"
				// hasCloaca ? "cloaca" ?: "asshole"
				// "still locked tight around its fat knot,"
				// hasDick ? (open "your" // Cock^s // "sluggishly oozing come"
					// hasBalls &*& (not . hasExternalBalls)
						? "from the sheer pressure against your internal balls"
						?: "from the pressure of its knot shoved up against them")
				// ". Its cock is still gushing, pumping you with more and more come"
				// hasCloaca ? ", forming aching, bloated passages deep within your cloaca"
				// ". It lays there, panting, cock twitching as it erupts, slowly bloating you more."
			Basic Biped -> open "The hellhound pants on top of you, knotted tight, and only slowly rolls to the side -- dragging you with it -- when you elbow its side. Your gut immediately bulges out, some of the pressure relieved, but its cock is still gushing, pumping you with more and more come. It lays there, panting, cock twitching as it erupts, slowly bloating you more."
			Basic a | a `elem` [Centaur, Quadruped] -> open "The hellhound pants across your back, knotted tight. Each gush of come lurches through you, bloating your straining belly fractionally more"
				// hasDick ? (open ", your swollen flesh digging down against the spar of your" // Cock^s)
				// ". It just lays there, no sign of stopping anytime soon, cock twitching inside you."
			f -> bodyFail "itMounts (j)" f
		// Paragraph // "The reservoir of come inside you keeps growing, pressure burning up and down your body, bearing back against its knot too. You lie there in a daze, aware only of the heat and pressure, mind focused on the runnels of come slowly bearing down against its knot and streaking backwards, peeling your already-stretched flesh apart from its knot. Its knot throbs, perhaps deflating, or perhaps pushing you to your limit, and you can feel the cords of come spill all the way back around its knot, erupting from your gaping"
		// (hasLocotype Naga &*& hasCloaca) ? "cloaca" ?: "ass"
		// "in a slobbery squirt of boiling tar, gushing between your bodies. Even with that, the hound keeps flooding your guts, lumpy globs of coagulating come squirming around in your guts as more and more spills out around the knot, turning the dust beneath you into a thick, grimy mess."
		// Paragraph // case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> open "Slowly, with a sigh, the hound gets back on its feet -- dragging you with it, again -- and slowly pulls back, a giant paw"
				// hasLocotype Naga ? "on your chest" ?: "between your shoulderblades"
				// "as it drags back, knot wedging against your"
				// hasLocotype Naga &*& hasCloaca
					? "straining lips and slowly slurping out, leaving your cloaca gaping wide, your bloated inner passages sluggishly shuddering and spitting out huge burbles of black steaming come."
					?: "broken asshole and slowly slurping out, leaving your hole cratered and gaping, clenching and flexing as its half-hard length spills out, absolutely drenched in a gummy cocoon of congealed come."
			Basic x | x `elem` [Centaur, Quadruped] -> open "Slowly, with a sigh, the hound dismounts, twisting around backwards so that you're briefly pressed together ass-to-ass, its giant knot dragging the flesh of your guts with it. It bears down, taking a half-step forward, and its knot lurches out of you with a soggy" // em "slurp" // ", cock spilling out drenched in a gummy cocoon of congealed come, leaving your asshole cratered and gaping."
			f -> bodyFail "itMounts (k)" f
	, Jump $ LeaveAfterSex ItTops
	]

leaveAfterSexClose :: SexMethod -> Encounter Index () HoundKnightEncounter
leaveAfterSexClose sex b k =
	[ Narration2 $ open "The hound huffs, still panting."
	, dialog k $ open "Yes, I am sated."
	, Narration2 $ case sex of
		YouTop -> open "And them, looking at your disheveled form," // Cock^s // "jutting out half-hard from your body, still dribbling your load:"
		ItTops -> open "And then, looking at your drenched and disheveled form, the lip of your broken ass bulging out in a big bruised ridge:"
		RimOnly -> open "And then, looking at you"
			// case locoplan b of
				Basic Biped -> "kneeling"
				_ -> "sprawled"
			// "in the morass of its load, bubbling black come painted halfway up your body:"
		BlowjobOnly -> open "And then, looking at your drenched and disheveled form, your" // muzzle // "hanging open, cords of boiling, steaming come spilling over your lips and painting your front in a coagulated black mess:"
	, dialog k $ open "And, um, you as well, one hopes."
	, FauxChoice "yeah i'm good"
	, Narration2 $ open "The hound's cock lolls between its thighs, only barely glowing now, still sluggishly dripping come. The hound rises up and steps back, cock audibly slapping against its belly as it does, and it tries to regain some of its composure, becoming again a stern knight rather than the beast wildly rutting against you it was moments ago."
	, dialog k $ open "In that case, I had best be off."
		// Paragraph // "If we, um, happen to cross paths again, I would be... I mean, it would be, uh, acceptable. For me to aid you. In this. Again."
	, Narration2 $ open "It takes a few steps back, eyes leaving a burning flame in their wake for a moment. It nods in your direction, and is off."
	, DeactivateSelf
	]

suckItOff :: MakeoutPath -> Encounter Index () HoundKnightEncounter
suckItOff path b k =
	[ Narration2 $
		case locoplan b of
			Basic Quadruped -> open "You step around its massive body, nosing up beneath its muscled belly."
				// case path of
					MadeOutFirst -> "Its cock is absolutely drenched in black pre, its red-hot glow muted. Tarry chunks of congealed pre smear down its shaft, forming a lumpy mess along the underside."
					DirectlyIn -> "Its cock juts out hard between its flanks, drooling black pre in erratic spurts."
				// "It settles down, halfway lying on its side, with its cock jutting out between its legs, spanning halfway up its underbelly. You lean in, cock glancing off your" // muzzle // ", and it shudders and squirts out a heavy, hot rope of black pre all over your face"
				// case bodyMat_ Head b of
					Solid (FMat _ Fur) -> open ", smearing across your fur"
					Solid (FMat _ Coat) -> open ", splattering over your coat and leaving a dribbling trail"
					_ -> mempty
				//". The shaft is grimy, tar pudding-thick and gritty, and it shudders and spurts again and again, gushing out steaming lines all across your head and shoulders"
				// case bodyMat_ Head b of
					Solid (FMat _ x) | x `elem` [Fur, Coat] -> open ", until your" // matword x // "is entirely soaked"
					_ -> mempty
				// "."
			Basic Slithering -> open "You coil over its body, looping around its neck and body until you're entirely draped on top of it. You spill down its side, head curling back to loop in front of its fat, unsheathed cock."
				// case path of
					MadeOutFirst -> open "Its cock is absolutely drenched in black pre, its redhot glow muted. Tarry chunks of congealed pre smear down its shaft, forming a lumpy mess along the underside. It shudders and gushes a sloppy string of fuming pre, splattering all across your"
						// case bodyMat_ Head b of
							Solid (FMat _ x) -> matword x
							f -> bodyFail "suckItOff" f
						// "."
					DirectlyIn -> open "Its cock juts out hard in front of your face, drooling black pre in erratic spurts."
			Basic _ -> case path of
{- FIXME:
maximumloftdesign: You run a hand down its chest, between its forelegs.

You lean in and press your lips to the tip, open mouth pressed against the underside.
maximumloftdesign: that's kind of a jarring transition
-}
				MadeOutFirst -> open "You run a" // hand // "down its chest, between its forelegs."
				DirectlyIn ->
					case locoplan b of
						Basic Centaur -> open "You lean down, and it tips its head up, eagerly lapping across your face and chest, sloppily kissing you."
						Basic Naga -> open "You slither up to the hound, and it leans in, eagerly lapping across your face, sloppily kissing you."
						Basic Biped -> open "You kneel down in front of the hound, and it leans in, eagerly lapping across your face, sloppily kissing you."
						f -> bodyFail "suckItOff" f
					// "It whines, hunching forward, cock audibly smacking across its underbelly, and you run a" // hand // "down its chest, between its forelegs."
					// Paragraph // "Its cock spans halfway across its underbelly, and your" // fingers // "clash against the head, smearing bubbling black pre across your" // fingertips // ". The hound howls, jerking forward and toppling you back beneath it, shoving its cock all across your chest"
					// case bodyMat_ Chest b of
						Solid (FMat _ x) | x `elem` [Fur, Coat] -> open "and smearing a thick line of clotted pre through your" // matword x
						_ -> mempty
					// ". You wrap your" // fingers // "more tightly around the tip, tugging, and its howl breaks off into sharp yipping. The shaft is grimy, tar pudding-thick and gritty under your palms, squelching and smearing in a dense cream as you stroke it, fresh pre gushing out in steaming lines across your chest."
			f -> bodyFail "suckItOff" f
		// Paragraph // case locoplan b of
			Basic Biped -> "You lean in and"
			Basic Naga -> "You lean in and"
			Basic Centaur -> "You settle down at its side, face pressed against its side, and tug its cock out to"
			Basic Quadruped -> "You"
			Basic Slithering -> "You"
			f -> bodyFail "suckItOff" f
		// "press your lips to the tip, open mouth pressed against the underside. It tastes burnt, unsurprisingly, like charcoal. The cock pulses against your lips, spurting an acrid, fuming mess of black pre across your"
		// case mouthType b of
			Mouth -> open "face"
			_ -> open muzzle
		// ", and you let its cock sag down minutely, tip pushing into your mouth: you sloppily suck the tip"
		// hasArms ? (open ", stroking the fat, heavy shaft with"
			// (not . armCountMatching 4) ? "both"
			// hands // ",")
		// armCountMatching 4 ? "two others braced against its haunches to control its erratic jerks and thrusts,"
		// "as the hound hunches and jerks, erratically fucking your face."
		// Paragraph // case locoplan b of
			Basic x | x `elem` [Quadruped, Slithering] -> open "You open wide, tongue lolling from your mouth, and take its shaft into your mouth. Drool spills from your" // muzzle // ", smearing down its shaft and thinning its dense, cooked-down pre into something sloppier. Its hips jerk, mouth open and panting, and its cock lurches across the roof of your mouth, scraping hard and leaving behind a clotted mess of burnt slime stuck to the inside of your mouth."
				// Paragraph // case bodySpecies Head b of
					Just Snake -> "Your tongue flits out, wrapping around its shaft as you idly bob back and forth, letting it fuck your throat."
					Just Wolf -> "You slobber, lapping and sucking on its shaft, nose nearly pressed against its sheath."
					Just Human -> "You suck on the tip, slowly swallowing more, lips spread wide around its girth."
					_ -> "You lap along its cock, slowly sucking more into your mouth."
				// "Its shaft is thickest in the middle, narrowing slightly at the base in anticipation of its knot: currently submerged into the flesh of the hound's shaft, just two oval ridges of flesh on the side, just peeking out of its sheath."
			_ -> open "Your hands slide down the fat shaft, to where it narrows in anticipation of its knot: currently submerged into the flesh of the hound's shaft, just two oval ridges of flesh on the side, just peeking out of its sheath."
		// "You"
		// hasArms ? "stroke it as you"
		// "suckle on the tip,"
		// armCountMatching 4
			? "playing with its fat balls with your other hands as you gulp"
			?: "gulping"
		// "down the steady drizzle of fuming pre. Above you the hound's body rocks, hips jerking forward to grind its sheath against your"
		// hasArms ? "hand" ?: "mouth"
		// "on the downstroke, cock erupting thick gushes of"
		// (not . hasArms) ? "charcoal-tasting"
		// "pre when your"
		// hasArms ? "fingers" ?: "lips" // "roll over the ridge of its knot. Your"
		// hasArms ? "strokes" ?: "sucks"
		// "grow wetter, fuming pre spilling from your" // muzzle // "and sliding down its shaft, forming a chunky black foam lathering its cock as you keep"
		// hasArms ? "stroking" ?: "slurping" // ", thick dollops of ooze sliding down the fat curves of its shaft and splattering"
		// case bodyMat_ Chest b of
			Solid (FMat _ Fur) -> "into the sodden fur across your chest"
			Solid (FMat _ Coat) -> "into the sodden hair across your chest"
			Solid (FMat _ Scales) -> "across your chest, winding down across your scales"
			_ -> "across your chest"
		// "."
		// Paragraph // case locoplan b of
			Basic x | x `elem` [Quadruped, Slithering] -> open "The hellhound slavers, fiery drool spilling from its lips like miniature comets, and it jerks forward, cock shoving further into your mouth, shoving your" // muzzle // "flush against its slimy sheath. Its knot shudders against your lips, the ruddy heat of its flesh growing hotter and hotter, dull red grow becoming brighter and brighter as its knot swells. You dip forward, cock shoving down your throat, knot beating against your tongue as you lodge it behind your teeth. Your mouth is full of steam, black pre and your spit boiling as its knot hardens, glowing nearly white-hot now."
			_ -> open "The hellhound slavers, fiery drool forming flashes of heat as it spills to the ground behind your head, and its paws thud in the dust around you, scrabbling as it rocks into your thrusts, snarling now. His knot shudders in your" // hands // ", the ruddy heat of its flesh growing hotter and hotter, dull red grow becoming brighter and brighter as its knot swells. It thrusts hard, your knuckles grinding against the swollen flesh of its knot, and you let it faux-knot your hands, slowly spreading them under its assault until you let its knot slap between your palms, glowing nearly white-hot now."
		// Paragraph // "The hound throws its head back and bays, the sludgy stream of pre wavering as its cock throbs hard and then erupts, come instantly flooding your mouth, bulging your cheeks, erupting from your lips. You drag in a watery breath, spitting out a mouthful of boiling black come around its cock. The hound absolutely drenches you in a tarry layer of come: gush after gush spilling over your lips, smacking across your skin, forming thick cords that sluggishly drizzle down your chest."
		// case locoplan b of
			Basic x | x `elem` [Quadruped, Slithering] -> open "The hound huffs and snarls, knot throbbing in your mouth, black come spilling over your lips and drooling from your nose. Its cockhead drags up and down, scraping across your throat, stirring the mass of come flooding your mouth and throat. Its knot throbs, locked-but-not-tightly in your mouth, beating against your tongue."
				// Paragraph // case x of
					Quadruped -> "The hound pulls back, knot tearing from your mouth with an immense wave of gummy slime, leaving your face webbed thickly with cords laced back and forth, rubbery and stretching but not snapping as it gets to its feet."
					Slithering -> "The hound gets to its feet -- seemingly forgetting your coils draped over its body, just pulling your head with it, mouth still stretched around its knot as it keeps gushing boiling come into your throat."
					f -> bodyFail "suckItOff" f
			_ -> open "The hound huffs and snarls, panting out plumes of fire, and grinds its spurting cock across your face, heavy and hot and implacable. Its sharp cockhead drags up and down, tip cutting through the thick mess of slime, leaving behind trenches and crests. Your hands are squeezing automatically, milking its knot,"
				// armCountMatching 4 ? "squeezing its balls,"
				// "come bubbling and boiling where it's slathered across your palms and between your fingers, gummy clots and grimy sheets forming as it boils down thicker and thicker."
				// Paragraph // "When the hound pulls back, your face is webbed thickly with cords lacing back and forth, rubbery and stretching but not snapping as it paces back, knot popping out from between your hands."
		// case locoplan b of
			Basic Slithering -> open "You spit out its knot, thick black come gushing out around its knot, spilling from your jaw in heavy, swaying coils. You sluggishly spill off the hound's body, falling to the ground -- and into the slimy mess of shed come -- with a" // em "thump" // ", your head and body drenched in thick black lines"
				// case bodyMat_ Neck b of
						Solid (FMat _ Scales) -> open ", smearing all over your scales"
						Trans (FMat _ Fur) (FMat _ Scales) -> open ", clinging tight to the fur across your head, the mess having only spilled down across your scales once your head was entirely soaked and sodden"
						Trans (FMat _ Skin) (FMat _ Scales) -> open ", skin and scales alike drenched and smeared in thick slimy layers of come"
						_ -> mempty
				// "."
			_ -> open "Its final few pulses just glide down the cords, sending them swaying and hanging in lower arcs, wishbone tendrils forming as they slowly start to snap apart and crash down across your disheveled body."
		// "Its cock throbs a few more times, knot visibly pulsing, but only a drizzle of come dribbles from the tip and spills through the smeared, slathered mess across its shaft. Already its load is starting to bake down, adding a fresh layer to the gritty, crusted ooze coating its length as it starts to retract into its sheath."
	, Jump $ LeaveAfterSex BlowjobOnly
	]

fuckIt :: Encounter Index () HoundKnightEncounter
fuckIt b k =
	[ Narration2 $
		open "You"
		// case locoplan b of
			Basic Biped -> "kneel behind it"
			Basic Naga -> "fold yourself over your tail"
			f -> bodyFail "fuckIt" f
		// "," // Cockhead^s // "arching up"
		// case locoplan b of
			Basic Biped -> "between your thighs"
			Basic Naga -> "from your underbelly"
			f -> bodyFail "fuckIt" f
		// ", pressing against the meaty muscles of its haunches. It spreads its legs, bracing them -- and between its hind legs you can see its balls, hanging down low, and its cock, mostly hidden save for the ruddy glow that doesn't quite reflect off its flat skin. Black pre patters to the ground beneath it."
		// Paragraph // "Its tail jerks up, lashing to the side -- it doesn't have an" // em "asshole" // ", precisely, just the same blank black shadow-flesh as the rest of its body, but you slide your fingers over the flesh of its rump and find a clenched divot that opens when you dig your fingers in, opening into a mass of churning fire and shadow. So mostly like an asshole."
		// Paragraph // "It jerks its head to the side, looking back at you with burning ember eyes, erratically blinking."
	, dialog k $ open "Please,"
	, Narration2 $ open "it groans, legs working up and down, grinding its haunches against your" // Cock^s // "."
	, Choices
		[ ("make out w/ its asshole", Rim)
		, ("shove yr dick in", FuckAnal DirectlyAnal)
		]
	]


rim :: Encounter Index () HoundKnightEncounter
rim b k =
	[ Narration2 $ open "Its asshole clenches and puckers when you draw your hand away, and so you lean in and replace your fingers with your tongue, leaning in and lapping across its haunches before you drag your tongue over its rim, shoving inside. The hound makes a hoarse kind of bark, huffing more as you lap inside, drooling freely as you work your tongue inside its tight asshole. Its pucker clenches around your tongue and it grinds back, tail slapping across your face as you open it up."
	// Paragraph // "You lap over the furrowed ridge of its hole, back and forth before pushing in, tongue-fucking it in short motions. The hound whines and shoves back, nearly bowling you over backwards, and you have to wrap your" // hands // "around its haunches to steady yourself, nose buried under its tail, tongue shoved past the spasming rim of its asshole."
	// Paragraph // "Your hands clench on its thighs, and it whines again, cock audibly spurting a mess of pre into the growing puddle beneath. You reach forward, past its balls, and wrap your hand around its shaft -- completely drenched now in fuming black pre, congealed in gummy clots all up and down its shaft. You tug it back, between its thighs, so each squirt shoots straight down between its hind legs. The motion tugs its sheath up, wrinkling it up so it can twist, and its half-inflated knot pops out in a sudden gush of slime, spilling down its shaft and drenching your" // hands // "."
	// Paragraph // "The hound yowls, maybe trying to say something, but whatever it is is lost."
	, Choices
		[ ("NOW fuck it", FuckAnal RimmedItFirst)
		, ("keep going like this", RimFinish)
		]
	]


rimFinish :: Encounter Index () HoundKnightEncounter
rimFinish b k =
	[ Narration2 $ open "The hound's asshole is parted, spread in a fat circle, and the rim is swollen and heavy, pouting out under its tail as you nip and tug at its shadow-flesh. Its knot brushes against your" // hands // ", beating like a heart, each spurt of pre shooting straight down between its hind legs and splattering into the growing puddle beneath."
	// Paragraph // "You dig back in, tongue swiping over its bloated lips before you slide in, spit hissing up into steam as you touch its glowing guts. The hound is warbling and baying, just the rimming and the light touches of your" // hands // "not enough to bring it off, not yet. It yowls, trying to fuck your hands, trying to fuck itself on your tongue, but -- so far -- not quite there. Its cock throbs, gushing and drooling, each squirt a slimy rope of boiling black ooze, splattering into the churned-up morass of sand and slime beneath you, smearing muck all across its paws as it whines and pleads."
	// Paragraph // "You start sloppily sucking on its flushed, pouting asshole, the hound's squirming shudders grinding its asshole back and forth across your lips, teeth nipping at its swollen flesh. You open wider as it pushes back, tongue spearing deeper, and its muscles flutter and clench against your tongue, letting you feel the spasms that are pumping its endless shots of pre onto the ground."
	// Paragraph // "The hound is hunched down, forepaws on the ground, ass shoved back into your face, and when it comes you can feel it approach: muscles inside clenching, a new kind of throb picking up, until finally it spasms hard, fully-inflated knot a giant lump of gnarled flesh smacking between its haunches, shooting a constant string of come down into the morass below."
	// Paragraph // "It howls, ass clenching around your mouth, dumping its watery load in an continual spill, just pissing out boiling black come as you keep dragging your tongue across its now-bruised, pouting lips, its internal muscles spasming hard."
	// Paragraph // "You keep its knot pinned back behind its thighs, tongue-fucking it until the continual spill dies down to a slow drizzle, its cock crunchy and flaking of thick sheets of burnt-down ooze, revealing the nearly white-hot flesh. The rest of it -- and most of you -- is completely drenched in its load, with an inches-thick morass of swampy, sandy come the both of you are sitting in."
	, Jump $ LeaveAfterSex RimOnly
	]

fuckAnal :: RimPath -> Encounter Index () HoundKnightEncounter
fuckAnal path b k =
	[ Narration2 $ open "You rise up,"
		// case bodySpecies Genitals b of
			Just Unicorn -> "flat cockhead dragging"
			Just Bull -> "gnarled cockhead dragging"
			Just x | ridgedCockhead x -> "sharp cockhead sliding"
			Nothing -> "sharp cockhead sliding"
			_ -> "cockhead dragging"
		// "over its haunches until it slides into place just under its tail, pressing against the clenching furl of its asshole. You bear down, hole opening slowly -- the hound huffs out a long plume of flame -- and your cock sinks inside, into a heat like a furnace, coils of rippling heat massaging up and down your shaft."
	// Paragraph // "The hound groans, head down, panting on the ground, and you can feel the clench and spasm as its cock spurts pre, big cords of muscle bunching along the underside of its ass. You thrust back and forth, hands grabbing its haunches, letting you sink the full length of your cock inside with a" // em "slap" // ", "
	// (hasExternalBalls
		? open "balls slapping against its own"
		?: case dickLocation b of
			Just DickExternal -> mempty
			Just _ -> open sheath // "slapping against its hole"
			x -> bodyFail "fuckAnal" x)
	// ". You draw back, its stretched hole clinging to your shaft as, spread wide enough a ring of glowing internal flesh encircles your cock, vanishing when you thrust forward and hilt again."
	// Paragraph // "It's not" // em "wet" // "inside, so hot your pre bubbles and boils away instantly, but it's" // em "slick" // ", ass all smooth muscle and frictionless shadow-substance. Its muscle wraps around your cock, suckling and tugging"
	// case firstOf [Medial, Barbs] dickAttrs b of
		Just Medial -> ", clenching tight around the ridge of your cockhead, teasing your medial ring as they lurch back and forth through tight clenching holes deeper inside"
		Just Barbs -> ", letting your barbs rake along its inner flesh"
		_ -> case bodySpecies Genitals b of
			Just x | ridgedCockhead x -> ", clenching tight around the ridge of your cockhead "
			_ -> ", as your sharp cockhead sinks in effortlessly"
	// ". Your hips smack against its, thrusts punctuated by the wet spatter of its pre drenching the ground, cock audibly smacking up across its underbelly when you thrust hard, and it whines, muscles twisting along your cock, clamping down as it ruts back against you, trying to fuck itself on your cock."
	, Choices
		[ ("jerk it off also", JerkItOff) -- nagas and bipeds only; doesn't make sense for centaurs
		, ("nah make it come just from getting fucked", HandsFree)
		]
	]

jerkItOff :: Encounter Index () HoundKnightEncounter
jerkItOff b k =
	[ Narration2 $ open "You reach over its hip to find its cock, a fat hard spike straining tight across its underbelly. It's completely drenched in its own pre, cooked down into a slimy, clotted paste, oozing tar-thick over your fingers. It bays at the touch, hips rutting through your hand -- fucking itself on your cock at the same time -- and gushes out a thicker squirt of pre, splattering across its sodden underbelly and spraying in all directions."
	// Paragraph // houndComes ViaJerk b k 
	// Paragraph // if hasKnot b
		then open "In time, your knot lurches and swells, spanking harder against its ass as you rut into it, until you jerk forward harder and shove the entire thing in, locking it in place. You" // groan // ", knot swelling fatter inside the hound, and your cock erupts, flooding its guts with your load, hissing and boiling as it spills all up along its burning flesh."
		// Paragraph // "With the both of you knotted -- well, the hound knotted well-enough against your hand -- you sprawl out on top of it, just enjoying the throb of your knot, the tight clench of its ass, the hissing gurgle as your load bursts inside it with no end in sight, even as its black, boiling come saturates the ground beneath you and spreads out from under its belly in a fuming puddle."
		// Paragraph // "It's a while before either of your knots go down -- your hand is slathered in a thick, goopy crust of come, and the hound's ass is flooded with your superheated load, bubbles rippling along your shaft. You squeeze down on its knot one last time before you let go -- it's gone rubbery, squishing in your hand, and the hound yaps and gushes a few more squirts of black ooze all over, just adding a little bit more to the flooded mess beneath you. You pull back, knot catching on its rim before you pull out with a messy" // em "slurp" // ", streamers of boiling come bursting out of the hound's overfilled ass and splattering all over. Its hole gapes, glowing guts exposed, its cratered hole a mess as your now-superheated load spills out, boiling away into a thick crust even as more come spills overtop that, winding down its haunches in thick cords."
		else open "You jerk forward a few final times, angle different with the hound collapsed and panting, jabbing your cock down along the bulge of its prostate, and then you come with a" // groan // ", load spurting inside in squirts, bubbling out around your shaft in a boiling, steaming mess as you keep thrusting."
	, Jump $ LeaveAfterSex YouTop
	]

handsFree :: Encounter Index () HoundKnightEncounter
handsFree b k =
	[ Narration2 $ open (hasKnot ? (open "Your knot"
		// case dickLocation b of
			Just DickExternal -> open "swells at the base of your cock"
			Just _ -> open "surfaces from your" // sheath // "with a slurp"
			f -> bodyFail "handsFree" f
		// ", and your next thrust smacks it hard against the hound's clenching asshole, sending a pulse of heat bursting up through your entire body."))
	// Paragraph // "You tilt your hips back and angle your cock up, ramming harder against its prostate, and it whines, sharp and breaking, its cock audibly gushing pre in slaps all across its underbelly"
	// hasKnot ? "as you hammer your knot again and again against its ass"
	// ". Pre squirts from its ass"
	// hasKnot ? ", curling around the half-inflated bulk of your knot,"
	// "and webs between you in thick, gooey ribbons, stretching and being smushed back together between you with each of your thrusts. The hound bows down, forelegs and shoulder on the ground, hunching its ass back to meet your thrusts. You hammer into it, hips meeting its haunches with a sharper" // em "crack" // "."
	// Paragraph // houndComes ViaHandsfree b k
	// Paragraph
	// (hasKnot
		? open "It's that that finally pushes the hound off the edge: your knot crams inside and it howls and comes all over itself, ass clamping down hard as"
		?: (open "You come with a" // groan // ", load spurting inside it in bursts and then spilling out in a boiling froth, and it's maybe that that finally pushes the hound off the edge: it ruts back against you, baying wildly, and"))
	// "its cock erupts across its underbelly, shooting so hard come streaks between its forelegs and splatters across the ground a ways before it. It howls,"
	// (hasKnot
		? (open "slavering and whining as your knot bulges thicker and thicker inside it, your pre piling up against its bulk, bubbling and boiling from the heat of its body but with nowhere to go. You" // groan // ", jerking back and forth -- uselessly just stirring your cock around -- and finally come, and tight clench of its ass finally bringing you off. Your load pours in, sharp spurts emptied into it in useless thrusts that only yank your knot around. You grip the meat of its ass hard"
			// case handType b of
				Hand -> mempty
				_ -> open ", " // fingers // "digging into its shadow-flesh"
			// ", balls jerking as you empty your load in pulse after pulse into the hellhound's ass."
			// Paragraph // "You stay knotted for a while, limping lying on top of it," // Cock^s // "shuddering and pulsing as you flood its ass with come, more and more. Your load boils around your" // Cock^s //", churning the currents inside it as your load builds up, until finally, eventually, your" // Knot^s // Softens^s // "and" // Pulls^s // "out with a rubbery" // em "pop" // ", leaving its asshole spread and leaking your load in boiling streams all down its haunches.")
		?: open "fucking itself on your spurting cock, asshole spasming and sucking, each clench matched by a lewd splatter of come gushing from its cock, spraying all across its underbelly. You keep coming: load building up inside it, spilling down your shaft, spilling from its clenching asshole to drip down the backs of its balls, dripping down into the morass of blackened come beneath you.")
	, Jump $ LeaveAfterSex YouTop
	]

data Via = ViaJerk | ViaHandsfree

houndComes :: Via -> BodyGlob -> HoundKnightEncounter -> EventReel
houndComes via b k =
	open "You fuck it harder, other hand on its hip, tugging it back into your thrusts"
	// hasExternalBalls ? ", balls smacking hard across its ass"
	// "."
	// hasKnot ? ((case dickLocation b of
		Just DickExternal -> open "Your knot jolts hard as it swells, lodged at the base of your cock,"
		Just _ -> open "Your knot surfaces from your" // sheath
		Nothing -> bodyFail "houndComes" $ (Nothing :: Maybe DickLocation)) // ", smacking hard against its stretched asshole, sending a pulse of heat bursting up through your entire body.")
	// "You thrust faster, short and hard, only an inch or so of your cock pulling back through the hound's asshole."
	// hasFlare ? "Your flare throbs, fighting against the clenching tightness of the hound's guts, shuddering back and forth as the muscle under the head bunches and starts to clench."
	// Paragraph // "The hound yowls, cock spurting and gushing, and you"
		// case via of
			ViaJerk -> open "cup your" // hand // "lower, around the fat, slimy flesh of its knot. You wrap your hand around it and squeeze, and the hound's entire body shudders and jerks. It practically collapses, bringing you down with it, and pinned between its underbelly and the swampy, pre-soaked ground, with your hand wrapped tight around its knot, it starts to come, spraying gush after gush of come up across its underbelly."
			ViaHandsfree -> open "make a final few sharp thrusts, the tension of orgasm already coiling up your body, inevitable even as you ram your cock through its clenching asshole."
				// hasKnot ? "Your half-inflated knot bears down hard before it rams in, and then jams behind its clenching ring, bulging its entire ass outward until it bursts out with an equally lewd slurp. You saw back and forth, knot-fucking it, slower and slower as your knot catches more and more, until finally you shove inside and can't get it out, knot stuck swelling and swelling locked inside the hound's ass."



mountIt :: Encounter Index () HoundKnightEncounter
mountIt b k =
	[ Narration2 $
		case bodyHeight b of
			SmallAnimal -> open "You rear up behind it, hardly able to wrap your" // forelegs // "around its haunches. You hop around on two legs, awkwardly, cock slapping against its thighs before it lowers itself slightly, bowing down so you can flop on top of it, cock shoving past its tail, "
				// case dickLocation b of
					Just DickExternal -> open "base of your shaft pressing"
					Just _ -> open sheath // "grinding"
					x -> bodyFail "mountIt" x
				// "against its asshole. You jerkily draw back, cock skidding down the outside of its flank, smearing pre over the shining plates of its armor, before you both manage to line things up right. You thrust,"
				// partAdjective Cockhead
				// "cockhead jabbing against its asshole, the pressure rippling back through your shaft once, twice, before you shove inside."
			_ -> open "You rear up behind it, cock slapping back and forth across its haunches, leaving big splatters of pre all across its shining armor. You come down on top of it, its muscular bulk carrying your weight with only a single bracing motion, and you buck jerkily, cock pinned against its outer flank, thrusting between you. You both have to shift against each other before you cock tugs free and lolls down, tip nestling just under its tail. Your"
				// partAdjective Cockhead // "cockhead digs against the pucker of its asshole, pressure rippling back through your shaft, and you thrust forward, shoving the tip of your cock into its burning depths."
		// Paragraph // "You jerk forward, burying"
			// hasMedial ? "your cock to the medial ring" ?: "half your cock"
			// "in a single thrust. The hellhound is burning hot inside, rippling heat washing across the length of your cock, soaking down"
			// hasBaculum ? "to the bone" ?: "to the core"
			// "and spilling down your shaft, heating up even the length still outside its ass. You shift your weight on top of the hound, getting better footing. Your cock slides back and forth minutely, and a mess of boiling pre drips down your shaft, steaming hot."
		// Paragraph // "Your" // feet // "dig against the sand and you hunch forward, driving the rest of your cock into the hound's ass with a" // em "smack" // ", "
		// case dickLocation b of
			Just DickExternal -> mempty
			Just _ -> open sheath // "kissing its spread hole and pulling back webbed with your pre,"
			x -> bodyFail "mountIt" x
		// "shaft pulling back sheened in a layer of pre that almost immediately boils away into a matte crust. The hound whines, hole clenching as you pull out,"
		// hasBarbs ? "your barbs flexing back and tearing across its insides,"
		// "its own cock spitting out cords of grimy black pre all across its underbelly."
		// Paragraph
		// hasMedial ? (open "Your medial ring lurches out of its hole with a wet" // em "slurp" // ", scummy with half-congealed pre and then easily slurps back inside, half of the broad band shoving inside before the other half sinks in past the hound's clenching asshole, and the big gristled band throbs inside it, adding an extra tension to the hound's boiling guts, pulling them tight around your fat horse dick.")
		// "You thrust back and forth, the hound's guts yielding around your cock, its entire body shuddering as you build up a rhythm: thrusts uneven at first, your" // feet // "shifting on the sand, but then you find a stable spot, thrusts coming fast and hard."
		// hasKnot ? (open "Your"
			// case dickLocation b of
				Just DickExternal -> open "hips smack against the hound's hole, and your knot shudders in the tight confines, swelling and bloating"
				Just x -> open (case x of
						DickSheathed -> open "sheath"
						_ -> open "swollen" // sheath)
					// "smacks against the hound's hole again, and this time your knot bursts out"
					// case x of
						DickSheathed -> ", sheath flesh folding back over its half-swollen bulk"
						_-> "with a spray of fluid"
				x -> bodyFail "mountIt" x
			// ", lodged between your bodies, throbbing against its spread asshole. You grind forward, squeezing it, and the pressure makes your cock shudder within the hound, gushing a squirt of pre that boils all around your shaft.")
		// "You fuck it hard,"
		// case (hasKnot b, dickLocation b `elem` [Just DickCloaca, Just DickVent], hasExternalBalls b) of
				(True, _, _) -> open "knot smacking against its cheeks,"
				(_, True, _) -> open sheath // "smacking against its cheeks,"
				(_, _, True) -> open "balls smacking against its cheeks,"
				_ -> mempty
		// case bodyHeight b of
			SmallAnimal -> "each thrust nearly dislodging you from your perch mounted across its ass."
			_ -> "each thrust making the hound's entire body jolt forward, its paws spreading in the sand to brace itself."
		// Paragraph // "The hound howls, rutting back into your thrusts -- there's a watery splatter that comes after each" // em "smack" // "of your hips against its ass; its cock spurting out pre when it clenches around your cock -- "
		// hasKnot
			? (open "and its hole nearly blossoms open to accept your knot, the half-swollen ball of flesh sinking into its open depths with a" // em "slurp" // "; the hound bears down afterwards, panting eagerly as it locks your cock into its ass, knot throbbing hard inside.")
			?: open "and comes on its own, cock erupting below it in gush after gush of black, bubbling come, drenching the sand beneath in tarry slime."
		// Paragraph // if hasKnot b
			then open "The hound's guts massage your knot, strong planes of muscle wrapping around its fattening girth and squeezing; that more than its gaping asshole locking you inside. You rut against it, the buzz of your orgasm getting closer and closer -- your knot only lurches back and forth within its tight, grasping confines, and each solid knock against the hound's insides sends a hot pulse of pleasure across your cock, zipping up through your body."
				// Paragraph // case (hasBalls b, hasExternalBalls b) of
					(True, True) -> "Your balls pull it tight against your shaft, beating roughly against the hound's ass as you still struggle to thrust"
					(True, False) -> "Your balls squeeze and pulse inside your body, on the edge"
					(False, _) -> "You get ready to come"
				// ", and then your cock erupts. Your knot strains against the hound's ass, load shooting into its ass in a thick, slimy wash, and it builds up, boiling come churning all up and down your shaft, trapped inside the hellhound by your swollen knot."
				// Paragraph // "You" // groan // ", sprawled atop the hound, its flames lapping across your underbelly and sides. Your cock keeps erupting, your come thinner and watery as it floods the hound's ass. It boils furiously but with nowhere to go, bubbles rippling up and down your spurting length and coaxing out spurt after spurt."
				// Paragraph // "Your knot softens, after a while, and you dismount, cock pulling free with a rubbery pang, drawing out a final gush that splatters all across the hound's flanks. Its hole gapes, glowing guts exposed, its cratered hole a mess as your now-superheated load spills out, boiling away into a thick crust even as more come spills overtop that, winding down its haunches in thick cords."
			else open "You" // groan // "and thrust a few more times, aware of how each thrust makes the hound's entire body ripple around your shaft. It's panting, head low, cock gushing and gushing, its bloated knot locked around nothing, making its entire shaft droop lower and knock against its thighs. Your cock shudders"
				// case firstOf [Flaring, Twisting] climaxAttrs b of
					Just Flaring -> open ", tip lurching hard and then bowing out into a brutally-wide flare,"
					Just Twisting -> open ", tip lurching hard to the side and twisting up, forming your gnarled flesh into a fat, rubbery corkscrew,"
					_ -> mempty
				// "and then erupts, the first blast ripping through you before it erupts deep in the hound's depths. Your load starts boiling almost instantly, even as your cock shudders and sprays the second shot. A frothing, bubbling mess gushes out around your cock, smearing down the hellhound's ass, splattering between your flanks as you keep thrusting."
	, Jump $ LeaveAfterSex YouTop
	]

windFuck :: Encounter Index () HoundKnightEncounter
windFuck b k =
	[ Narration2 $ open "You pull yourself up over the hound's shoulders, making a heavy, hanging loop around its neck before slithering back across its body. Its shadow-flesh is hot, with a minute amount of give."
		// Paragraph // "Its cock juts out between its hind legs, shaft encrusted with grimy layers of blackened pre, steadily leaking more. Your coils brush against it, and its body shudders. Each touch makes it tremble, cock gushing thick bursts of pre, splattering down onto the ground and soaking it. You wind your body thickly all back and forth across its haunches and ass, forming a messy coil between its legs and over its hips, your body sliding over its fat, mounded balls and drooling, spurting cock."
		// Paragraph // "Your" // Cock^s // case dickLocation b of
			Just DickExternal -> open "drag against"
			Just DickSheathed -> open "unsheath, dragging against"
			Just _ -> open "spill from your" // sheath // ", digging against"
			f -> bodyFail "windFuck" f
		// "the muscled curve of its ass. Your" // Cock^s // "rut against its ass, slowly slipping down between its cheeks to dig into its tight, puckered asshole. You rut back and forth"
		// case bodySpecies Genitals b of
			Just Snake -> open ", the thick spines of your cocks bearing down against its hole as you smear your own pre, slicking up its hole"
			Just Wolf -> open ", your sharply-tapered" // Cockhead^s // "catching and dragging over its asshole"
			Just Unicorn -> open ", the fat, rubbery" // Tip^s // "of your" // Cock^s // "catching and dragging over its asshole"
			_ -> mempty
		// "before pushing inside."
		// Paragraph // "The hound bays, a tremor running through its body, and it ruts back -- forgetting you're wrapped around it; it ruts back against nothing. It pants as you thrust into it, body tensing and coiling, your thrusts slow and rolling. Your" // Cock^s // "is"^p "are" // "sunk inside a roaring inferno, the hound's flesh clenching and fluttering all around you."
		// Paragraph // "You go slow, just sliding back and forth, body bunching and relaxing as you slowly sink your entire length into it, until"
		// case dickLocation b of
			Just DickExternal -> open "the" // manyCocks ? "conjoined" // "root of your" // Cock^s // "is pressed tight against the rim of its hole"
			Just _ -> open "your" // sheath // "is pressed flush against its spread hole"
			f -> bodyFail "windFuck" f
		// ". Boiling pre leaks out around your" // Cock^s // ", smearing across your underbelly and dribbling down its trembling haunches."
		// Paragraph // "It bays again, pawing at the ground, yapping and yipping as it tries to hunch back, fuck itself on your cock. Its cock is continually gushing, trembling on the edge of orgasm -- its knot throbs hard against your sliding coils -- but never quite there, never quite enough. Your orgasm builds slowly, even as the hound empties pulse after pulse of black pre all over your coils, until nearly your entire body is drenched in its issue. Your" // Cock^s // Thrums^s // ", pleasure building and building as you drag your" // Cock^s // "from its spread, quivering hole, until finally the spark hits, zipping up and down your spine. You" // groan // ", " // sheath // "meeting its ass with a soft" // em "plap" // "as you hilt inside, cocks tensing and then firing hard, pumping your load into its ass."
		// Paragraph // "Its cock, untouched save the continual glide of your"
		// case bodyMat_ Tail b of
			Solid (FMat _ Scales) -> "scales"
			Solid (FMat _ Protoplasm) -> "slimy protoplasm-body"
			_ -> "tail"
		// "over its clotted, encrusted length, fires off finally, the erratic gush of pre giving way to sharp, hard spurts of thick, black-tar come, spraying forward between its forelegs, sinking into bubbling pools in the churned-up sand below."
		// Paragraph // "Your load drools out around your" // Cock^s // ", come heated to boiling, spilling down over the fat, churning bulge of its heavy balls. You keep thrusting, slow, coils pulling tighter around its hips and haunches. Slowly, eventually, you pull out," // Cock^s // "emerging with a" // em "slurp" // "and a fresh pulse of come, the dregs of your load spilling across its ass as you slowly slide off it, slithering down into the murky morass of sand and black come below."
	, Jump $ LeaveAfterSex YouTop
	]
