"use strict";

window.addEventListener ('load', function () {
	var descriptionFrame = document.querySelector ("#descriptionText");
	var builder = document.querySelector ("#builder");
	var body = new Body.Part ("animum", []);
	var pronoun = "you";
	var bodyPronoun = "it";
	var nodes =
		[ "arms", "legs", "head", "tail", "horns", "halo", "eyes"
		, "size", "more", "more"
		, "metal", "metal", "storm", "storm", "fire", "fire", "ice", "ice"
		, "ichor", "ichor", "ichor", "spines", "veins", "pustules"
		, "sword", "chain"
		, "human", "goat", "goat", "goat", "unicorn", "bull", "snake", "scorpion"
		, "mouth", "tongue", "cock", "cock", "balls", "knot"
		];

	Editor.setBody (body, pronoun, bodyPronoun);
	Editor.updateDescription (descriptionFrame);

	_.map (document.querySelectorAll ("#pronoun .pradios input"), function (r) {
		r.addEventListener ('change', function () {
			bodyPronoun = this.value;
			if (!document.querySelector ("#you").checked) {
				pronoun = bodyPronoun;
			}
			Editor.setBody (null, pronoun, bodyPronoun);
			Editor.updateDescription (descriptionFrame);
		}, false);
	});
	(function (r) {
		r.addEventListener ('change', function () {
			if (this.checked) {
				pronoun = this.value;
			} else {
				pronoun = bodyPronoun;
			}
			Editor.setBody (null, pronoun, bodyPronoun);
			Editor.updateDescription (descriptionFrame);
		}, false);
	}(document.querySelector ("#you")));

	builder.appendChild (Editor.renderBodyTree (body, "#parts"));
	Editor.renderNodeCollection ("#parts", nodes, true);
}, false);
