this builds the webserver for HELL GAME

the game has a fairly extensive javascript 'client', and when running most events in-game it will query the webserver to generate event text. this is because the event code (w.r.t. PC bodies) is very complicated and i really did not want to try to write & maintain it in javascript. so the webserver provides a few access points to query, given the PC body tree + gender, to output a big data dump of event pages to selectively run client-side.

this version is ahead of the 'live' version (at [http://tzaphiriron.sidemoon.net/hell](http://tzaphiriron.sidemoon.net/hell) as of this writing), in that it contains a bunch of half-finished body code updates and a new body-building interface. other than that, all content in the game (as well as some unfinished event files) are available.

theoretically, to build and run successfully:
1. install a modern haskell platform (from [https://www.haskell.org/platform/](https://www.haskell.org/platform/) or your distro's package manager)
2. download or clone this repo
3. change the path in `source/Executable/Server.hs` to point to wherever you've put the source (the config file specifically)
4. run the `deploy` script (or just run `cabal v2-build hell` yourself)
4a. have the deploy script fail to correctly move the built 'hell' executable so you have to do that yourself (it'll be somewhere in `dist-newstyle/`, many directories deep)
5. run `hell` in the same directory you specified in 3. (that's the `web/` dir here)
6. go to `localhost:8000/hell` in your web browser to play the game
