import System.Posix.Daemonize
import Server.Webserver (server, loadConfig, Config(..))

import Happstack.Server (bindPort, Conf(Conf))

main :: IO ()
main = do
	cfg <- loadConfig "/home/xax/hell/web/config"
	if asDaemon cfg
		then serviced $ simpleDaemon
			{ privilegedAction = do
				socket <- bindPort $ Conf (port cfg) Nothing Nothing 30 Nothing
				print socket
				return socket
			, program = (\socket -> server (Just socket) cfg)
			, user = Just "hellgame"
			, group = Just "hellgame"
			}
		else server Nothing cfg
