module Sites.Hell.Events.Hubur
	( MapZone (..)
	, mapLabel
	) where

data MapZone
	= FactoryProcessing
	| FactoryProcessingPlant
	| FactoryGrotto

	| FactoryQuarry
	| FactoryMineTunnels
	| FactoryTarpit

	| FactoryResearch
	| FactoryStacks
	| FactoryPulpit

	| Field
	| SwampZombie
	| SwampSobek
	| Glade
	| Badland
	| Shallows

	| Mudfield
	| Sand
	deriving (Eq, Ord, Show, Read)

mapLabel :: MapZone -> String
mapLabel h = case h of
	FactoryProcessing -> "factory-processing"
	FactoryProcessingPlant -> "factory-plant"
	FactoryGrotto -> "factory-grotto"

	FactoryQuarry -> "factory-quarry"
	FactoryMineTunnels -> "factory-tunnels"
	FactoryTarpit -> "factory-tarpit"

	FactoryResearch -> "factory-research"
	FactoryStacks -> "factory-stacks"
	FactoryPulpit -> "factory-pulpit"

	Field -> "field"
	SwampSobek -> "swamp-sobek"
	SwampZombie -> "swamp-zombie"
	Glade -> "glade"
	Badland -> "badland"
	Shallows -> "shallows"

	Mudfield -> "mudfield"
	Sand -> "sand"
