{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.Gargoyle
	( Gargoyle
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Control.Monad
import Data.Maybe

import Server.JSON
import Utility.Rand
import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/), (^))

import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..))
import Description.Build
import Description.Body.Sample hiding ((?), hand, hands)

{- todo:
* deal with like... prostate -> g-spot for getting fucked in the cloaca w/o a prostate
* figure out the limits of that fucking scene. there are (now) coherent versions of this scene for
	1. anybody with an ass and dick
	2. anybody with a fuckable cloaca (so, nagas and snakes)
	which should cover most bodies. i'm really not sure what to do w/ the rest; they're things like
	* human w/ balls but no dick
		(everybody but humans has sheaths/vents that can leak come; humans don't rly have that)
	* anybody with no genitalia whatsoever

* write a little paragraph for the two directions you can get to 'shove' from


* code up mounting scene and give a read-over for parameters
* either use all "it" pronouns or all "he" pronouns (i've been leaning towards 'it')
-}

{- scene expansion: bj/oral scene.
-}

name :: String
name = "gargoyle"

-- no variants :V
data Gargoyle = Gargoyle
	{ g_dickSize :: DickSize
	}
	deriving (Eq, Ord, Show, Read)

data DickSize = Prong | Tentacle
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance ToJSON Gargoyle where
	toJSON (Gargoyle d) = object
		[ pack "name" .= name
		, pack "data" .= [fromEnum d]
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= [Null]
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryProcessing, ())
	, (FactoryProcessingPlant, ())
	, (FactoryResearch, ())
	, (FactoryQuarry, ())
	]

instance FromJSON Gargoyle where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [d])
				| pName == name ->
				case Gargoyle
					<$> safeToEnum d of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Gargoyle)
deck = do
	dickSize <- liftRand $ shuffle [Prong, Tentacle]
	return $ Gargoyle
		<$> from dickSize

data Subject = SonOfHamarTabal | FlameDemon | GanzerWorker | Gargoyles | LesserHellhound | SwampEncounter
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data Index = OpeningOptions | Talk | TalkAbout Subject | Leave | FuckOpening | JerkOff | JerkClimax | Shove ShoveFrom | TurnDown
	deriving (Eq, Ord, Show)

data ShoveFrom = ShoveDirectly | ShoveJerk
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance Scene Index () Gargoyle where
	link x = case x of
		OpeningOptions -> openingOptions
		Talk -> talk
		TalkAbout subj -> talkOn subj
		Leave -> leave
		FuckOpening -> fuckOpening
		JerkOff -> jerkOff
		JerkClimax -> keepStroking
		Shove from -> shove from
		TurnDown -> turnDown
	display = fmap toLower . show
	vardisplay = fmap toLower . show

description :: Gargoyle -> Event Gargoyle Index ()
description _ = Narration2 $ "There's a gargoyle-sculpture perched on top of the warehouse. It's a chimera; lizardlike and leonine at the same time, frozen in the moment of crawling over the lip of the roof. It moves: it stares down at you, shaking its haunches, then begins bounding back and forth down the wall, huge webbed hind paws resting on outcroppings for only a moment before it pushes off again until it lands on the ground with an earth-rattling thump."
	/ Paragraph / "It's a mess of concrete, rusted metal, and black rubber, with grey mesh strung over its inner workings in places as a kind of skin. Electricity bursts in blue arcs out from some power source behind its ribs, down the exposed knobs of its spine, filling the air with the scent of ozone. It's got a mane of rusted metal shards and six hollow eye sockets in its metal skull, thick welding lines across its face."

scene :: MarkedScene Index () Gargoyle
scene b g =
	[ SetFlag (Global MetGargoyle) 1
	, description g
	] <> openingDialog b g

openingDialog :: MarkedScene Index () Gargoyle
openingDialog b g =
	[ Dialog "/static/img/icon.png" "Gargoyle"
		[ "Hey, you're not from around here, huh?"
		, "Technically I guard the place, but you souls can't wreck anything even if you tried."
		, "So, uh, wander around if you want; I don't care."
		]
	] <> openingOptions b g

openingOptions :: MarkedScene Index () Gargoyle
openingOptions _ _ =
	[ Choices
		[ ("hey you wanna fuck", FuckOpening)
		, ("hey lemme ask you a thing", Talk)
		, ("well bye", Leave)
		]
	]

talk :: MarkedScene Index () Gargoyle
talk _ _ =
	[ Choices2
		[ ("gargoyles", TalkAbout Gargoyles, Nothing)
		, ("flame demons", TalkAbout FlameDemon, Just $ C (Global MetFlameDemon) IsSet)
		, ("ganzer workers", TalkAbout GanzerWorker, Just $ C (Global MetGanzerWorker) IsSet)
		, ("sons of hamar-tabal", TalkAbout SonOfHamarTabal, Just $ C (Global MetSonOfHamarTabal) IsSet)

		, ("dryads", TalkAbout SwampEncounter, Just $ C (Global MetDryad) IsSet)
		, ("clay men", TalkAbout SwampEncounter, Just $ C (Global MetClayMan) IsSet)
		, ("sobek sheut", TalkAbout SwampEncounter, Just $ C (Global MetSobekSheut) IsSet)

		, ("lesser hellhounds", TalkAbout LesserHellhound, Just $ C (Global MetLesserHellhound) IsSet)
		, ("<==", OpeningOptions, Nothing)
		]
	]

talkOn :: Subject -> MarkedScene Index () Gargoyle
talkOn subj _ _ = case subj of
	SonOfHamarTabal ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			[ "They keep things running. They're good for a repair if I bust a joint or anything like that, though they're pretty useless for any subtle problems."
			]
		]
	FlameDemon ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			[ "They're artificers. They're the ones that assembled me. They make most of the stuff that's around here."
			]
		]
	GanzerWorker ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			[ "They're the heavy-hitters. Not so much anymore, but they're good to have as backup if there's a particularly annoying unicorn around or anything like that."
			]
		]
	Gargoyles ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			[ "Yeah, what?"
			, "We're animated guards. I mean, I already said that. Mostly it's just the odd unicorn or zombie that comes around looking to stir up trouble, though."
			]
		]
	SwampEncounter ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			["Yeah, I don't know much about them. I don't really leave the factory grounds much, so I don't see much of the swamp."
			]
		]
	LesserHellhound ->
		[ Dialog "/static/img/icon.png" "Gargoyle"
			[ "Don't get me started. Stuck-up know-it-alls who can't keep their dicks in their sheaths for even a minute."
			]
		]


leave :: MarkedScene Index () Gargoyle
leave _ _ =
	[ Narration
		[ "You leave."
		]
	]

-- this needs bodyplan-specific blocking (for all the scenes after this)
fuckOpening :: MarkedScene Index () Gargoyle
fuckOpening b g = case planLocomotion . bodyplan $ b of
	Spec Orb -> orbRejection b g
	Spec FloatingDick -> orbRejection b g
	Spec FloatingHead -> orbRejection b g
	Basic Formless -> orbRejection b g
	_ ->
		[ Dialog2 "/static/img/icon.png" "Gargoyle" $ do
			"Hah, you're one of" / em "those" / "souls, huh?"
			/ Paragraph /"You know I'm made from metal and concrete, right?"
			/ Paragraph / "But..."
		, Narration ["The gargoyle leers."]
		, Dialog "/static/img/icon.png" "Gargoyle"
			[ "Turns out I got some attachments, so you're not wrong."
			]
		, Narration2 $
			"The gargoyle spreads his haunches, giving you a view behind its barrel chest, between its metal-and-rubber flanks."
			/ case g_dickSize g of
				Prong -> "There's a thick, stubby erection there, made from black rubber, permanently hard. It's short and thick: triangular, with slightly-rounded edges; bottom-heavy; with a slight upward curve."
				Tentacle -> "There's a fat, arcing erection there, made from black rubber, permanently hard. It's long and tapering: triangular, with slightly-rounded edges; bottom-heavy; with a sinuous arch that keeps it following the line of the gargoyle's body."
			/ "Its surface is covered with shiny half-spheres, metal balls of varying sizes embedded in his flesh in a complex latticework."
			/ case g_dickSize g of
				Prong -> mempty
				Tentacle -> "It ends with a larger metal ball at the very tip, and it's close enough to its constantly-erupting heart that it keeps catching arcs of electricity across the tip."
			/ "It looks much more like a sex toy than any kind of cock a living thing would have."
		, if hasArms b
			then Dialog "/static/img/icon.png" "Gargoyle" ["How about you crawl up here and start by jerking me off and we'll see where this goes."]
			else Dialog "/static/img/icon.png" "Gargoyle" ["It'd be a rough ride, but I could just shove it in you."]
		, Choices $ catMaybes
			[ guardC (hasArms b) ("go jerk him off", JerkOff)
			-- e-stim/prostate milking is such a big part of the scene that it's easier to just gate it behind a prostate. maybe reconsider this later. (this does introduce an inconsistency to the dialog if you don't, since he still mentions wanting to shove it in you. w/e)
			, guardC (hasProstate b || hasNagaCloaca b) ("just shove it in me", Shove ShoveDirectly)
			, pure ("nah thats not my thing", TurnDown)
			]
		]

orbRejection :: MarkedScene Index () Gargoyle
orbRejection b _ =
	[ Dialog2 "/static/img/icon.png" "Gargoyle" $ do
		"Hah, you're one of" / em "those" / "souls, huh?"
		/ Paragraph / "You got quite the aspirations, huh."
		/ Paragraph / "I'd be willing to accommodate you, but let's be honest:" / (case locoplan b of
				Spec FloatingHead -> "floating heads aren't"
				Spec FloatingDick -> "a big ol' floating dick isn't"
				_ -> "orbs aren't") / "my type."
		/ Paragraph / "Maybe get yourself some kinda body."
	, FauxChoice "well fine maybe i will"
	, Dialog "/static/img/icon.png" "Gargoyle"
		[ "Well see you when you do."
		]
	]

turnDown :: MarkedScene Index () Gargoyle
turnDown _ _ =
	[ Narration
		[ "It laughs."
		]
	, Dialog "/static/img/icon.png" "Gargoyle"
		[ "Picky too, huh. You're the one who brought it up."
		, "I'm sure you'll find somebody up to your exacting standards eventually."
		]
	]

jerkOff :: MarkedScene Index () Gargoyle
jerkOff b g =
	[ Narration2 $ "You"
		/ case locoplan b of
				Basic Naga -> "slither"
				-- CHECK: any others?
				_ -> case bodySpecies Legs b of
					Just Wolf -> "pad"
					_ -> "crawl"
		/ "up there, between its legs, and start jerking it off"
		/ case armCount b of
				2 -> mempty
				_ -> ", your other arms cupping the curves of its hips and haunches"
		/ "."
		/ Paragraph / "Its body is inhumanly still: no breath, utterly motionless until the gargoyle feels like moving. But its heart -- the electric burst crackling endlessly behind its ribs -- pulses and flares, like a second voice, buzzing sharper as you come close. Its cock jabs up from between its haunches, fat and thick, metal beads gleaming. You reach up between its haunches" 
		/ case handType b of
				Claw -> c ", thick talons curling around its cock"
				_ -> "," /  hand / "wrapping around its cock"
		/ Comma / "and its heart buzzes, arcs of electricity burning across its ribs, ringing its head in a brilliant halo for a fraction of a second."
		/ Paragraph / "Its cock is rubbery, or something like rubber: there's so much friction it's almost sticky; it heats up as you attempt to stroke, "
		/ case bodyMat_ Arms b of
			Solid (FMat _ Skin) -> "flesh catching on the rubbery surface"
			Solid (FMat _ Fur) -> "the fuzz of your fur making your thrusts glide easier if you hardly touch it at all"
			Solid (FMat _ Scales) -> "even your smooth scales scraping over its rubbery surface"
			-- ?? -> " / the sides of your claws catching on its surface "
			_ -> "catching against your hand"
		/ ". The gargoyle groans, hips pivoting forward, head twisting counterclockwise to look at you, jaw open like it's panting, drooling electric arcs."
		/ Paragraph / case bodyMat_ Arms b of
			Solid (FMat _ Fur) -> "Your loose grip catches at moments, " / fingertips / "sliding effortlessly over the bulges of the metal beads."
			_ -> c "You relax your grip, hardly even touching its shaft: fingers catching only on the edges of its rubber flesh, or sliding effortlessly over the bulges of the metal beads."
		/ "The gargoyle purrs, voice and heart buzzing together in a low groan as you pick up the pace. You tug on its cockhead, squeezing on the rigid rubber, and its hips jerk forward: lighting bursts across its cock, a sharp sudden shock that jolts up your arm, arcs playing over the fat beads before the charge dissipates."
	] <> if hasProstate b || hasNagaCloaca b
		then
			[ Narration2 $ c "The gargoyle heaves, limbs shuddering to life, and you look up, still stroking its crackling cock as it speaks:"
			, Dialog "/static/img/icon.png" "Gargoyle"
				[ "You could keep this up."
				, "Or we can shove it in your ass, though no guarantees that'll be fun for you."
				]
			, Choices
				[ ("keep stroking", JerkClimax)
				, ("yeah shove it in me", Shove ShoveJerk)
				]
			]
		else keepStroking b g

-- this one is pretty scene-specific
cockAndBalls :: BodyGlob -> String
cockAndBalls b = case (dickLocation b, hasExternalBalls b) of
	(Just DickExternal, True) -> "cock and balls"
	(Just DickSheathed, True) -> "sheath and balls"
	(Just DickSheathed, False) -> "aching sheath"
	(_, False) -> "internal balls"
	(Just DickCloaca, _) -> "swollen cloaca"
	(Just DickVent, _) -> "swollen cloaca"
	(Nothing, True) -> "balls"

-- you can get here from two different places & they should have very slightly different openings, like just one or two lines
{-
this scene is reachable directly from the start OR by picking >> yeah shove it in me in the jerkoff scene, & should maybe have different intros or smth
-}
shove :: ShoveFrom -> MarkedScene Index () Gargoyle
shove from b g =
	[ Narration2 $
		case locoplan b of
			Basic Slithering ->
				"You loop around the gargoyle's frame, and once your"
				/ hasAsshole ? "asshole" ?: "cloaca"
				/ "is lined up with its cock it brings a paw down on your body. Its electric charge burns through your body, tingling with every beat of its electric heart, the sensation more raw where it digs its cockhead against"
				/ hasCloaca ? "your cloacal lips" ?: "the rim of your asshole"
				/ "."
				/ hasDick &*& hasCloaca ? ("Your" / Cock^s / Burns^s / "as the charge earths itself against" / "it"^p "them" / ", jolting through the slick, wet flesh of your cloaca.")
				/ "The gargoyle's flesh sticks, friction burning hot as it shifts forward, the tip of its cock digging down against your hole."
				/ Paragraph / "You coil around its body and back again, tongue lapping, open mouth drooling venom, smearing at least some liquid across its rubbery cock; its cock is so rubbery that it clings tight to everything, and that paltry lube hardly eases the way when it bears down again, grinding its cockhead into your hole."
			Basic x ->
				"The gargoyle mounts you: "
				/ case x of
					Naga -> "he uses one paw to slap you to the side, as gingerly as one can do that, flipping you over onto your back, and then he stands astride you."
						/ case bodyMat_ Tail b of
							Solid (FMat _ Skin) -> "The pulse of its electric heart crackles just an inch from your skin"
							Solid (FMat _ Fur) -> "The pulse of its electric heart has all your fur poofing out, arcs crackling against the tips of your fur"
							Solid (FMat _ Coat) -> "The pulse of its electric heart has your coat sticking up, arcs crackling against the tips of your fur"
							Solid (FMat _ Scales) -> "The pulse of its electric heart crackles just an inch from you, the charge earthing in smooth shuddering jolts down between your scales"
							_ -> "The pulse of its electric heart burns against your body"
						/ ". His cock presses against your underbelly,"
						/ case bodyMat_ Tail b of
							Solid (FMat _ Scales) -> "gliding over your scales,"
							Solid (FMat _ Protoplasm) -> "sliding through your soft, dimly-wet protoplasm,"
							_ -> "sliding down"
						/ hasCloaca
							? "and sticks the second it presses against the softer, more pliable flesh of your flushed cloaca"
							?: "and digs into the divot of your asshole, cockhead sticking to the softer flesh of your inner body"
						/ ". Friction burns as he shifts forward, the tip of his cock digging down against your hole."
					Biped ->
						"you get on your" / hands / "and knees, and the gargoyle shifts. Only a fraction of its immense weight bears down on you; his ribs press against your back, the pulse of its electric heart earthing charge through your flesh in sudden shocky jolts. His cock presses against your thigh, "
						/ case bodyMat_ (Waist Hind) b of
							Solid (FMat _ Skin) -> c "sticking there and digging into the skin as he tries to shift upward"
							Solid (FMat _ x) | x `elem` [Fur, Coat] -> "carding through your " / matword x / ", shocks erupting like static "
							Solid (FMat _ Scales) -> c "scraping over your scales"
							Solid (FMat _ Bone) -> c "clattering on your bones"
							_ -> c "digging into your flesh"
						/ "; he pulls back and then his cock digs between your cheeks, friction burning as he shifts forward, the tip of his cock catching against your hole."
					x | x `elem` [Quadruped, Centaur] ->
						"he rears up, forepaws grabbing your" / hips / ", only a fraction of his weight actually bearing down. His ribs press against your back, the pulse of its electric heart earthing charge through you in shocky jolts. His cock presses against your" / side / ","
						/ case bodyMat_ (Waist Hind) b of
							Solid (FMat _ Skin) -> c "sticking there and digging into the skin as he tries to shift upward"
							Solid (FMat _ x) | x `elem` [Fur, Coat] -> "carding through your" / matword x / ", shocks erupting like static"
							Solid (FMat _ Scales) -> c "scraping over your scales"
							Solid (FMat _ Bone) -> c "clattering on your bones"
							_ -> c "digging into your flesh"
						/ "; he pulls back and then his cock digs between your cheeks, friction burning as he shifts forward, the tip of his cock catching against your hole."
						/ Paragraph / "His cock is so rubbery that it's hard for him to penetrate you at all; your ass is much more interested in clinging to the edges of his cock than opening around it, and he doesn't have any pre to ease the way at all. "
						/ hasLocotype Centaur
							? ("You lean back, twisting your upper body to reach your ass, licking your" / hand / "and smearing it into your hole.")
							?: ("You twist around, "
								/ case bodySpecies Head b of
									Just Wolf -> "lapping at"
									Just Snake -> "flitting your tongue across"
									_ -> "licking"
								/ "his cock for a moment -- it burns across your tongue, electric shocks buzzing through your throat, making your jaw go numb.")
						/ "It's not much, but at least lubed like that he's able to shove in fractionally."
					f -> bodyFail (Shove from) f
			f -> bodyFail (Shove from) f
		/ hasLocotype Biped |*| hasLocotype Naga
			? (Paragraph / hasDick
					? ("You lube his cock with your precome, smearing your" / hand / "across your" / unsheathed / Cock^s / "and then stroking his cock as much as you can; his shaft is so rubbery it clings tight to everything, and even that lube is paltry when he bears down again, grinding his cockhead into your hole.")
					?: ("You have to lick your" / hand / ", getting your" / fingers / "slick to lube yourself up before he can make any headway at all: cocktip digging against your hole, catching and catching and slipping minutely.")
				/ "The entire thing buzzes, an electric charge running just before the surface, the metal beads vibrating as they press against" / hasNagaCloaca ? "your opening" ?: "your rim" / ". His cock grinds inside, friction burning hot and slowly dissipating when he halts.")
		/ Paragraph / case locoplan b of
			Basic Biped ->
				"His cock erupts in a bolt of electricity, charge earthing itself in you in a sudden shock. Muscles spasm wildly"
				/ hasProstate ? ", prostate shuddering"
				/ ", and a messy gush of come-tinged pre"
				/ (case dickLocation b of
					Just DickExternal -> c "spurts from your half-hard cock"
					_ -> "drools from your" / sheath)
				/ ". You" / groan / ", going limp for a second, and the gargoyle bears down, cock angling fractionally different, the sharp tip grinding"
				/ hasProstate
					? "right against your prostate"
					?: "up against your anal walls"
				/ ". He lets out another bolt of electricity, your stomach shuddering and clenching, another spurt of come"
				/ (case dickLocation b of
					Just DickExternal -> c "erupting from your cock"
					Just _ -> "gushing out from your" / sheath / "in a sloppy flood"
					-- WHERE DOES YR CUM COME FROM IF YOU DON'T GOT A DICK
					Nothing -> "drooling"
						/ case bodySpecies Legs b of
							Nothing -> c "through the protoplasm of your crotch"
							Just x -> "from your"
								/ case animalDickLocation x of
									DickExternal -> "foreskin nub"
									DickSheathed -> "empty sheath"
									_ -> "empty vent")
				/ ", and you groan and stay down, shoulders on the ground and ass in the air."
				/ Paragraph / "His cock is too rubbery to thrust; it clings tight to the walls of your ass, friction burning every time he adjusts. But he lets out spurts of electricity, each one forcing an ejaculation out of you, " / cockAndBalls / "shuddering as his cock grinds against your ass. He ruts shallowly, electric bursts coming faster, "
				/ (case dickLocation b of
					Just DickExternal -> c "your cock spurting out"
					Just DickSheathed -> c "your sheath oozing"
					Just _ -> c "your vent oozing"
					Nothing ->
						"your"
						/ case bodySpecies Legs b of
							Nothing -> "crotch"
							Just x -> case animalDickLocation x of
								DickExternal -> "foreskin nub"
								DickSheathed -> "sheath"
								_ -> "vent"
						/ "oozing")
				/ "another gush of come all across the ground."
			Basic x
				| x `elem` [Naga, Slithering] ->
					"His cock is too rubbery to thrust; it clings tight to the walls of your "
					/ hasCloaca ? "cloaca" ?: "ass" / ", friction burning every time he adjusts. But he lets out spurts of electricity, each one burning up through your stomach, charge arcing directly"
					/ hasGSpot ? "across your g-spot" ?: "across your prostate"
					/ hasInternalBalls ? "and internal balls"
					/ ", making your body writhe under his bulk, tail lashing, shuddering moans ripped from your throat."
					/ hasDick
						? ("Your" / Cock^s / ","
							/ case dickLocation b of
								Just DickExternal -> "lying"
								Just _ -> "unsheathed and"
								f -> bodyFail (Shove from) x
							/ "mostly-limp across your"
							/ case x of
								Naga -> "stomach"
								Slithering -> "underbelly"
								f -> bodyFail (Shove from) x
							/ ", spasm and gush out slimy mixtures of pre and come with every bolt of electricity that erupts out of the gargoyle's cock.")
						?: ("Your cloaca spasms around the gargoyle's cock, muscles firing randomly with each bolt of electricity that earths inside you, and sloppy squirts of juices splatter across his undercarriage with each thrust.")
					/ Paragraph / "The gargoyle adjusts, cocktip nudging against"
					/ hasCloaca ? "the depth of your cloaca" ?: "the inner walls of your ass"
					/ ", its sharp tip grinding right against your"
					/ hasGSpot ? "g-spot" ?: "prostate"
					/ ". He tenses, cock bursting with another bolt of electricity, and the muscles across your stomach spasm and clench,"
					/ hasDick
						? ("another spurt of come erupting from your" / Cock^s / ",")
						?: ("a gush of juices erupting from your cloaca")
					/ "and you groan and go limp,"
					/ hasCloaca ? "vent" ?: "ass"
					/ "spread wide open for his cock. He ruts shallowly, electric bursts coming faster"
					/ hasDick
						? (", your" / Cock^s / "spurting out a nearly-continual dribble of come all over your stomach")
						?: (", your underbelly a mess from the mixture of pre and come oozing from your cloaca")
					/ "."
				| x `elem` [Quadruped, Centaur] -> "The entire thing buzzes, an electric charge running just before the surface, the metal beads vibrating as they press against the opening of your rim. It grinds inside, friction burning hot and slowly dissipating when he halts. His cock erupts in a bolt of electricity, charge earthing itself in you in a sudden shock. Muscles spasm wildly, prostate shuddering"
					/ hasDick ? (", and a messy gush of come-tinged pre spurts from your half-hard" / Cock^s)
					/ ". You groan, going limp for a second, and the gargoyle bears down, cock angling fractionally different, the sharp tip grinding right against your prostate. He lets out another bolt of electricity, your underbelly shuddering and clenching, "
					/ hasDick ? ("another spurt of come erupting from your" / Cock^s / ",")
					/ "and you groan and stay down, forelegs on the ground and ass in the air."
					/ Paragraph / "His cock is too rubbery to thrust; it clings tight to the walls of your ass, friction burning every time he adjusts. But he lets out spurts of electricity, each one forcing an ejaculation out of you, " / cockAndBalls / "shuddering as his cock grinds against your ass. He ruts shallowly, electric bursts coming faster"
					/ hasDick ? (", your" / Cock^s / "spurting out another gush of come all across the ground")
					/ c Period
			f -> bodyFail (Shove from) f
		/ Paragraph / "He finally comes with a groan, electric bursts growing into a burning climax, bolts of electricity earthing themselves"
		/ hasNagaCloaca ? "into your guts" ?: "in your ass"
		/ ", burning"
		/ hasGSpot ? "against your g-spot" ?: "through your prostate"
		/ hasDick ? "and dick"
		/ "in white-hot bursts, his orgasm mirrored with yours"
		/ hasDick
			? (", each shock forcing your" / Cock^s / "to pulse and spray a mess of come"
				/ case locoplan b of
					Basic Naga -> "all up your chest"
					Basic Slithering -> "all across your knotted coils"
					Basic _ -> "onto the ground below"
					f -> bodyFail "shove" f
				/ ", the droplets crackling with residual energy for a few seconds afterwards")
			?: (", sloppy squirts of juices spraying from your cloaca, pulsing rhythmically around his cock from the shocks, painting in streamers"
				/ case locoplan b of
					Basic Naga -> "all up your chest"
					Basic Slithering -> "across your underbelly"
					_ -> "over your skin")
		/ "."
		/ Paragraph / "He pulls out with a" / em "slop" / ", your"
		/ hasNagaCloaca ? "wrecked cloaca" ?: "gaping ass"
		/ "literally steaming from the discharge,"
		/ case locoplan b of
			Basic Slithering -> "flesh of your belly"
			Basic Naga -> "flesh all up and down your chest"
			Basic Biped -> "back all the way down to your ass"
			Basic x | x `elem` [Centaur, Quadruped] -> "flesh all across your haunches"
			f -> bodyFail (Shove from) f
		/ "tingling and red from electrical burns, muscles still spasming randomly as the last of the current works its way out of you, leaving you in a limp pile on the ground,"
		/ case locoplan b of
			Basic x | x `elem` [Naga, Slithering] ->
				hasLocotype Naga ? "chest and stomach" ?: "coils"
				/ "all smeared with your"
				/ hasDick ? "load" ?: "juices"
			_ -> "the slimy mess of your many forced ejaculations smearing across"
				/ hasLocotype Biped ? "your belly" ?: "your underbelly"
				/ "as you slump down"
		/ "."
	, Dialog "/static/img/icon.png" "Gargoyle"
		[ "Well."
		, "I did warn you, I guess. But it looks like you enjoyed that too."
		]
	]

keepStroking :: MarkedScene Index () Gargoyle
keepStroking b g =
	[ Narration2 $
		"You keep jerking him off. His hips jerk, the motion delineating through air sharp mathematically-perfect ovoid cycles. His cock barely-slides through your" / fingers / ", rubbery material clinging and gripping. His heart sparks, electric discharge erupting up through his bones to play across his face, or down his spine all the way to the tip of his lizard tail. Or, most relevantly, across his cock, metal beads crackling and buzzing, humming under your" / fingertips / "; charge building up until arcs burst between the spheres, coming a crackling river of electricity, drooling down the length of his shaft in bursts that arc between a half-dozen beads, the current path snapping back and forth between different beads as they heat up from the discharge."
		/ Paragraph / "It is, presumably, hot. If you're a metal gargoyle. He groans, humping your hand, the grunt of his voice and the buzz of his heart warbling as they rise and fall. The gargoyle's thrusts cycle faster, the curve of his thrusts expanding, friction burning for a second as the underside of his fat cock drags over your"
		/ case bodySpecies Arms b of
				Just Human -> mempty
				Just Goat -> "hairy"
				Just Bull -> "coarsely-haired"
				Just Snake -> "scaled"
				_ -> case bodyMat_ Arms b of
					Solid (FMat _ Fur) -> "furry"
					Solid (FMat _ Scales) -> "scaled"
					_ -> mempty
		/ "palm. He huffs, electricity now a constant crackle, spilling down his shaft and smearing across your arm in buzzing sparks before the current earths itself."
		/ Paragraph / "He roars, thrusting and holding, joints locking in place as solid as a terrestrial animal would bear down: the weight of his body does that for him. The base of his cock digs against your palm, electricity throbbing in spurts down his shaft. His heart burns, the glow a brilliant blue-white, leaving afterimages of his ribs behind your eyelids. Arcs pour down his belly, forming a brilliant cord of electricity burning across his underbelly, the tip of his cock a grounding point for a half-dozen arcs snapping between his ribs, hips, knees. Sharp ozone boils over you, like a hot summer storm, and then the gargoyle groans and sags forward, electricity vanishing in a sudden blinding burst that hits you like a full-body punch."
		/ Paragraph / "The gargoyle slumps forward, panting. Its electricity dulls and then fades, save for a restrained crackling still buzzing behind his ribs."
	, Dialog "/static/img/icon.png" "Gargoyle"
		[ "Yeah."
		, "That was pretty good."
		]
	, Narration
		[ "He sits back, cock pulling back from between your fingers; your entire arm buzzes and throbs with the charge earthed through it."
		]
	, Dialog "/static/img/icon.png" "Gargoyle"
		[ "Come back and next time we can do that again."
		]
	]


{-

- articulated gargoyle -- gargoyle made from concrete and metal and rubber. has a dick that's just like a triangular cone w/ rounded edges. also maybe has metal balls embedded in the underside that it can electrify. kind of lion-themed? so like, lion head, barbs, etc

	There is a reconstructed gargoyle here. It is made of stone and metal and rubber, imbued with life. Electricity crackles over its body, sharp bursts of blue lightning arcing between metal plates. It is leonine, stone bust of a lion for a head, roaring silently, stone mane spreading into rusted metal shards, crackling and clattering as it stirs. Its limbs are rusted iron, beaten thin and overlapped in complex plates, and hinged with thick pads of black rubber.



	There is a reconstructed gargoyle here.

	It has worked masonry and gearwork into its assemblage. It is leonine, moving on four legs, and thick-bodied, with the head of a stone lion, trapped in an eternal roar. Its mane is rusted metal shards, overlapping in a starburst behind its head, crackling with blue flashes of electricity. Its limbs are rusted iron, beaten thin and overlapped in complex plates, and hinged with thick pads of black rubber. 

-}
