{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleContexts #-}

module Sites.Hell.Events.Hubur.HamarTabal
	( HamarTabal(..)
	, Clothes(..)
	, Hair(..)
	, Piercings(..)
	, Tone(..)
	, Horns(..)
	, Location(..)
	, factoryDeck
	, description
	, scene

	, name
	, bits
	, variants
	) where

{-
FIXME:

* fisting scene has a quad/cent closer even tho it's reachable by everybody with arms now
	* (the closer doesn't actually have any body details in it, it's just the spirit of the thing)

TODO:

* this doesn't have any biped/naga oral (pc topping) scenes, which means they have to be selectively removed from certain choice flows.
	* there's also not a slithering (pc topping) scene; the only oral scenes are for quad/cent

* generally the flowchart is v. complex because only certain bodytypes have certain scenes. if it was more fleshed-out then a lot of this could be simplified i think. in adding some new choices i've probably just added in some new busted blocking.

-}

import Prelude hiding ((/), (^))

import Control.Monad
import Data.Maybe (catMaybes, fromMaybe)

import Server.JSON
import Sites.Hell.Events.SceneUtils hiding ((/), Dick(Dick))
import Sites.Hell.Events.Construction ((/), (^))

import Sites.Hell.Events.Hubur

import Description.Build hiding (Dick(Dick))
import Description.Body.Sample hiding (hand, hands, feet, foot, (?), Dick(Dick))
import Description.TfNode (Animal(..), TfNode(..), Sex(Balls))

import Utility.Tuple (thd_)

name :: String
name = "son of hamar-tabal"

-- what this needs is a bunch of 'mental' options -- dialog state, name, that kind of thing (& also an accompanying event to switch npc flags, which would just be like "flag name" "js value" but generally generated w/ a mob-specific function that takes an enum of the valid flags, which would be translated to strings inside the function to preserve a semblance of type-safety)
data HamarTabal = HamarTabal
	{ clothes :: Clothes
	, hair :: Hair
	, piercings :: Piercings
	, tone :: Tone
	, horns :: Horns
	, location :: Location
--, transformed :: Maybe Transformed
	}
	deriving (Eq, Ord, Show)
data Location = Processing | Plant | Quarry | Tunnels | Farm
	deriving (Eq, Ord, Enum, Bounded, Show)
data Clothes = Overalls | Hazmat | Welder | Skirt
	deriving (Eq, Ord, Enum, Bounded, Show)
data Hair = Shaved | Dreads
	deriving (Eq, Ord, Enum, Bounded, Show)
data Piercings = IsPierced | NotPierced
	deriving (Eq, Ord, Enum, Bounded, Show)
data Tone = Veiny | Hairy | Muscled
	deriving (Eq, Ord, Enum, Bounded, Show)
data Horns = NoHorns | Horns
	deriving (Eq, Ord, Enum, Bounded, Show)


{-
change IsPierced to `IsPierced (Set Piercing)` or smth

data Piercing
	= PA <Ring | Padlock>
	| Frenum <Shaft | ShaftAndBalls>
	| SeptumRing
	| TongueStud
	| Eyebrow <Stud | Ring>
	| Ear <Ring | Tag | Chain>
	| Nipple <Hook | Chain | Cross>
	deriving (Eq, Ord, Enum, Bounded, Show)

data PiercingType = Ring | Padlock | Stud | Tag | Chain | Hook | Cross
	deriving (Eq, Ord, Enum, Bounded, Show)

data PiercingLocation
	= Glans
	| Frenum
	| Septum
	| Tongue
	| Eyebrow
	| Earlobe
	| EarShell
	| Nipple

data Piercing = NotPierced | IsPierced [(PiercingLocation, PiercingType)]

where nipple&septum are required and the rest are randomly picked i guess

(or maybe just generalize this entirely, for all encounters. which would mostly just require slightly expanding the attachment points per encounter, so like, horn piercings, tail piercings, etc)

data CockSize
	= ShortFat
	| Big
	| Giant

(which also might be generalized to all encounters, tho ofc certain encounters may have different distributions & might have dick size be interpreted differently.)

where that might be like "incidentally under his pants you know he has ...", rather than explicitly stated to begin with.

something like uhhhhh

	ShortFat -> "His cock is stubby, but enormously fat; fully hard it's a short nub jutting out from his balls{, still wrapped in layers of wrinkled foreskin / the loop of his prince albert piercing spreading his wrinkled foreskin into a hungry mouth}."
	Big -> "His cock is thick and fat, dragged down from its own weight to jut out from his crotch at a downward angle. He's uncut {and pierced}, foreskin drawn back, his revealed cockhead a glossy grey-purple that fades into his usual greyish skin down his shaft."
	Giant -> "His cock is grossly oversized, hanging down between his thighs most of the way to his knees in a bloated, turgid mess. His shaft throbs, filling out slowly, with visible veins cording up its sides, fluttering with each pulse. His grey-purple cockhead peeks out from a too-small foreskin, only drawn back enough to reveal the fat gash of his cockslit, the flesh raised on either side in a pair of protrusions, like bruised lips."



hooves maybe? might be too furry.
data Hooves = NoHooves | Hooves


some kinda skintone variance could be nice but i can't really think of many options
data SkinTone = BlueBlack | Grey | Black | ???

(also: tattoos?)


-}

instance Random HamarTabal where
	randomR _ = random
	random = getRand $ HamarTabal
		<$> genRandom
		<*> genRandom
		<*> genRandom
		<*> genRandom
		<*> genRandom
		<*> genRandom
--		<*> pure Nothing

factoryDeck :: RandomGen g => Rand g (Enumerable HamarTabal)
factoryDeck = do
	clothes <- liftRand $ shuffle [Overalls, Hazmat, Welder]
	hair <- liftRand $ shuffle [Shaved, Dreads]
	pierced <- liftRand $ shuffle [IsPierced, NotPierced]
	tone <- liftRand $ shuffle [Veiny, Hairy, Muscled]
	horns <- liftRand $ shuffle [NoHorns, Horns]
	return $ HamarTabal
		<$> from clothes
		<*> from hair
		<*> from pierced
		<*> from tone
		<*> from horns
		<*> pure Processing

{-
-- not used yet. for bigger, specifically-triggered tfs
data Transformed = Transformed
	{ arms :: Arms
	, skin :: Skin
	}
	deriving (Eq, Ord, Show)
data Arms = Two | Four
	deriving (Eq, Ord, Enum, Bounded, Show)
data Skin = Normal | Crystal | OozingIchor
	deriving (Eq, Ord, Enum, Bounded, Show)

-- this can happily output no-op tfs, if it picks Two + Normal
instance Random Transformed where
	randomR _ = random
	random = getRand $ Transformed
		<$> genRandom
		<*> genRandom
-}

instance ToJSON HamarTabal where
	toJSON (HamarTabal c h p t ho l) = object
		[ pack "name" .= name
		, pack "data" .= [fromEnum c, fromEnum h, fromEnum p, fromEnum t, fromEnum ho, fromEnum l]
		]

bits :: Value -> Value
bits v = object
	[ pack "name" .= name
	, pack "data" .= [Null, Null, Null, Null, Null, v]
	]

instance FromJSON HamarTabal where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs) of
			(Success pName, Success [c, h, p, t, ho, l])
				| pName == name ->
				case HamarTabal
					<$> safeToEnum c
					<*> safeToEnum h
					<*> safeToEnum p
					<*> safeToEnum t
					<*> safeToEnum ho
					<*> safeToEnum l of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

variants :: [(MapZone, Location)]
variants =
	[ (FactoryProcessing, Processing)
	, (FactoryProcessingPlant, Plant)
	, (FactoryQuarry, Quarry)
	, (FactoryMineTunnels, Tunnels)
	]

data Index
	= PlatonicLeave
	| OpeningDialog
	| RevisitDialog
	| OpeningChoices
	| TalkOpening
	| Talk TalkOption
	| SexBranch
	| Sex SexScene
	deriving (Eq, Show)

data SexScene
	= SlitherOral -- pc blowing son of hamar-tabal, slithering only(?!)
	| SlitherAnalFullbody
	| SlitherNagaAnal
	| QuadCentaurOral -- son of hamar-tabal blowing pc, quad/cent only
	| QuadCentaurAnal
	| CentaurFist | QuadCentaurClose
	| QuadCentaurFrot
	| Fist
	| BipedAnal BipedAnalFrom
	| RejectBlowjob
	| QuadCentaurDickRefuse
	-- these are the only two 'son of hamar-tabal tops' scenes
	| OralBottom -- pc blowing son of hamar-tabal, everybody
	| QuadCentaurAnalBottom -- pc getting fucked by son of hamar-tabal, quad/cent only
	deriving (Eq, Show)

{-
THE SEX SCENE FLOWCHART:
	Orb, FloatingHead, Formless ~> rejection
	Biped ~>
		hasDick ~>
			"sure let's go for it" BipedAnal FromMain
			"how abt i fist you instead" Fist
		noDick ~>
			JUMP directly to Fist

	Slithering ~>
		"get up there and fuck him" SlitherNagaAnal (dick only)
		"slither all up inside his asshole"/"yea" SlitherAnalFullbody
		"how about you lemme blow you" SlitherOral

	Naga ~>
		"get up there and fuck him" SlitherNagaAnal
		"nah how abt i blow you" OralBottom
		"how abt i fist you instead" Fist

	Quadruped,Centaur ~>
		"sure, fuck him" QuadCentaurAnal (has-dick only)
		"how abt you wrap yr lips around it" QuadCentuarOral (has-dick only)
		"lets rub our dicks together" QuadCentaurFrot (has-dick only)
		"how abt i fist you to open you up first" Fist (centaur-only, obv)
		"listen i wanna do smth to _yr_ dick okay" (has-dick only; no-dick has these options collapsed directly into the first choice)
			"yeah cmon fuck my mouth" OralBottom
			"yeah cmon shove it in my ass" QuadCentaurAnalReceiving


	Fist
		"NOW fuck him", sexPostFistFuck b
			Basic Naga -> Sex SlitherNagaAnal
			Basic Biped -> Sex $ BipedAnal FromFist
			Basic Centaur -> Sex QuadCentaurAnal
		"nah i think we're done here" QuadCentaurClose -- ?!

	OralBottom
		Slithering ~> "yeah c'mon suck me off" SlitherOral
		Centaur,Quadruped ~> "yeah c'mon suck me off" QuadCentaurOral
		"nah leave it" RejectBlowjob
-}

data TalkOption = Factory | SonOfHamarTabal | GanzerWorker | Dryad | ClayMen | FlameDemon | LesserHellhound | Gargoyle | SobekSheut
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data BipedAnalFrom = FromMain | FromFist
	deriving (Eq, Ord, Show)

data Var = Met | Fucked | LastSeenNoDick | MetProtoplasmicSnake | AssumedHellhound | InvitedShoulderDeepFisting
	deriving (Eq, Ord, Enum, Bounded, Show, Read)


instance Scene Index Var HamarTabal where
	link x = case x of
		PlatonicLeave -> platonicLeave
		OpeningDialog -> dialogOpening
		RevisitDialog -> revisitDialog
		OpeningChoices -> openingChoices
		TalkOpening -> talkOpts
		Talk t -> talk t

		SexBranch -> sexBranch
		Sex sex -> case sex of
			SlitherOral -> sexSlitherOral
			SlitherAnalFullbody -> sexSlitherApproach <> sexSlitherFullbody
			SlitherNagaAnal -> sexSlitherApproach <> sexSlitherNagaAnal
			OralBottom -> sexOralBottom

			QuadCentaurOral -> sexQuadCentaurOral
			QuadCentaurAnal -> sexQuadCentaurAnal
			CentaurFist -> sexCentaurFist
			QuadCentaurClose -> sexQuadCentaurClose

			Fist -> sexFist
			RejectBlowjob -> sexRejectBlowjob
			QuadCentaurFrot -> sexQuadCentaurFrot
			QuadCentaurDickRefuse -> quadCentDickRefuse
			QuadCentaurAnalBottom -> sexQuadProtoplasmAnal
			BipedAnal from -> sexBipedAnal from

	display = fmap toLower . show
	vardisplay = fmap toLower . show
	varread "met" = Just Met
	varread _ = Nothing

dialog :: Convertible a EventReel => HamarTabal -> a -> Event HamarTabal Index Var
dialog _ = Dialog2 "/static/img/icon.png" "Son of Hamar-Tabal" . convert

cumflates :: BallProduction -> Bool
cumflates (Quant x) | x > 6 = True
cumflates _ = False


scene :: MarkedScene Index Var HamarTabal
scene b h =
	[ SetFlag (Global MetSonOfHamarTabal) 1
	, description h
	, Branch [(C (Local Met) IsSet, RevisitDialog)] OpeningDialog
	, SetFlag (Local Met) 1
	, Jump OpeningChoices
	]

description :: HamarTabal -> Event a b c
description b = Narration2 $ case location b of
		Processing -> "A son of Hamar-Tabal is working on the refinery."
		Plant -> "A son of Hamar-Tabal is working on the refinery."
		Tunnels -> "A son of Hamar-Tabal is mining ore."
		Quarry ->  "A son of Hamar-Tabal is mining ore."
		Farm -> "A son of Hamar-Tabal is working the plow, strapped in like a beast of burden himself."
	/ Paragraph / case tone b of
		Muscled -> "A hugely-muscled humanoid."
		_ -> "A well-muscled humanoid."
	/ "He is like rock. His body could be hewn from rough grey basalt, save for how it moves. His upper body is so muscled it looks humped: the yoke of his shoulders and neck like the crest of a bull, coarse with hair."
	/ case tone b of
		Muscled -> "His chest is the massive barrel-chest of an auroch, with his pectorals fat and heavy, biceps inhumanly bulky; entire body almost grotesquely top-heavy."
		Veiny -> "Ropy veins crawl up his arms, visible across his shoulders and chest, with more rippling to the surface across his stomach when he tenses his core."
		Hairy -> "He's covered in coarse hair, spreading from his shoulders all across his chest and back, bristling up across his forearms."
	/ case horns b of
		NoHorns -> mempty
		Horns -> "A pair of horns sprout from his head, rough black rock for most of their length, carved into points near the tip that shine purple-black and smooth."
	/ case clothes b of
		Hazmat -> "He wears a gasmask, the filter asymmetrical, the lenses black glass. Broad straps wrap around the back of his head, "
			/ case hair b of
				Shaved -> "fit snugly over his shaved-stubble head. "
				Dreads -> "sliding between his heavy dreads. "
			/ "He's wearing an unzipped jacket, high-collared and made of thick, tough material, with broad bands of reflective cloth across the breast. "
		Welder -> "He's barechested, and wearing a rectangular welder's mask over his head, his eyes completely obscured by black glass."
			/ case hair b of
				Dreads -> "A mess of heavy dreads spill out the back of the mask and drape down across his shoulders."
				Shaved -> mempty
			/ "He crosses his arms over his bare chest. His hands are dark, nails growing into curving black talons."
		x -> "His hands are dark, nails growing into curving black talons. His mouth is a mess of fangs, thick and large; ogreish. His eyes are slitted like a snake's. "
			/ case hair b of
				Shaved -> "His hair is shaved down to a quarter-inch of bristly blue-black stubble. "
				Dreads -> "His hair is mounded up in thick dreads, pulled back in a heavy bundle. "
			/ case x of
				Overalls -> "He's dressed in black overalls only, barefoot and shirtless, the apron and straps left hanging down across his thighs. "
				Skirt -> "He's dressed only in a reed hat and a muslin skirt, the fabric soaked nearly translucent with sweat, his feet and hands dark with dirt."
				f -> bodyFail "description" f
	/ case piercings b of
		IsPierced -> "Thick piercings hang from his fat nipples, black iron in a U-curve that narrows to triangular spikes at the tips. "
		_ -> mempty
	/ case clothes b of
		Overalls -> c "His overalls are drawn down at the back to under his tail, growing just above the cheeks of his ass: a tail in the form of a sinuous snake, red tongue tasting the air."
		Skirt -> c "He's got a tail in the form of a sinuous snake, its red tongue tasting the air, and his skirt is drawn down in the back to let it out; it twines and twists through the air as he moves."
		x -> case x of
				Hazmat -> "He's wearing heavy workpants, black with reflective piping, the thick suspender straps left hanging down his thighs."
				Welder -> "He's wearing heavy workpants, a dull, dark leather with heavy stitching."
				_ -> error "unreachable"
			/ "They rest low on his hips, a thick swath of pubes visible in the front, dragged down low in the back to let his tail out: tail the body of a sinuous snake, red tongue tasting the air. He's wearing heavy rubber workboots, black and shiny."

-- basically this is the first conversation
dialogOpening :: MarkedScene Index Var HamarTabal
dialogOpening _ h =
	[ dialog h "Hey,"
	, Narration2 $ "he says."
		/ case clothes h of
			Hazmat -> "His voice is muffled through the gasmask, but still clear enough."
			_ -> mempty
	, dialog h $ "Another one of you lonesome wandering souls, huh? Plenty of you all over the place; somebody isn't doing their jobs; hasn't been doing it for a while."
	, Narration $ ["He shrugs."]
	, dialog h "But it's none of my concern. Try to stay safe out there."
	]

revisitDialog :: MarkedScene Index Var HamarTabal
revisitDialog _ h =
	[ dialog h $ "Back again, little soul? How has Hell been treating you so far?"
	, InlineBranch (C (Local Fucked) IsSet)
		[ Narration ["There's a tone in his voice when he says"]
		, dialog h $ "And what drives you return here, then?"
		]
		[]
	]

openingChoices :: MarkedScene Index Var HamarTabal
openingChoices _ _ =
	[ Choices
		[ ("hey you wanna fuck around", SexBranch)
		, ("hey lemme ask you about...", TalkOpening)
		, ("leave", PlatonicLeave)
		]
	]

talkOpts :: MarkedScene Index Var HamarTabal
talkOpts _ _ =
	[ Choices2
		[ ("...the factory", Talk Factory, Nothing)
		, ("...the sons of hamar-tabal", Talk SonOfHamarTabal, Just $ C (Global MetSonOfHamarTabal) IsSet)
		, ("...the ganzer workers", Talk GanzerWorker, Just $ C (Global MetGanzerWorker) IsSet)
		, ("...the dryads", Talk Dryad, Just $ C (Global MetDryad) IsSet)
		, ("...the clay men", Talk ClayMen, Just $ C (Global MetClayMan) IsSet)
		, ("...the flame demons", Talk FlameDemon, Just $ C (Global MetFlameDemon) IsSet)
		, ("...the lesser hellhounds", Talk LesserHellhound, Just $ C (Global MetLesserHellhound) IsSet)
		, ("...the gargoyles", Talk Gargoyle, Just $ C (Global MetGargoyle) IsSet)
		, ("...the sobek sheuts", Talk SobekSheut, Just $ C (Global MetSobekSheut) IsSet)
		, ("<==", OpeningChoices, Nothing)
		]
	]

talk :: TalkOption -> MarkedScene Index Var HamarTabal
talk x b h = (case x of
	Factory -> pure $ dialog h $ c
		"Like what it does? Oh, uh. We pump up river water and burn it. For power. Plus you can cook the ashes into glow crystals, but that's mostly the flame demons' thing."
	SonOfHamarTabal -> pure $ dialog h $ c
		"What's there to say? We mostly stay here in Hubur; it's not too great to get too far from Hamar-Tabal itself. You might've seen it out there in the river. Well, parts of it, at least. We keep the factory running."
	GanzerWorker -> pure $ dialog h $ c
		"Hard workers. Not very talkative. They used to be uh, soldiers. The prison guards of Ganzer, before that whole thing collapsed. So they had to get a new trade. They're pretty good at it."
	ClayMen ->
		[ Narration ["He leers."]
		, dialog h $ c
			"You went walking along the clay banks, didn't you? Yeah, those clay men. They're good for a quick fuck, if you don't mind the mess."
		, Narration ["But then, with less groping his crotch:"]
		, dialog h $ c
			"The Hubur flows all the way from the living world -- its water has some fearsome powers. It brings things to life, you could say. So, the river banks, and the silt beneath... that stuff's soaked up a lot of the river's power. That's how it works."
		]
	FlameDemon -> pure $ dialog h $ c
		"They're all a bunch of nerds if you ask me. I mean, not that that's bad, just, there's only so much I can stand to have somebody talk about alchemical diagrams and signal strength, even if they're fucking me while they do it."
	LesserHellhound ->
		[ dialog h $
			"Ugh."
			/ Paragraph / "They're the worst. They all got delusions of grandeur, thinking they're gonna be next among the Annunaki or some shit. They come down from the mountains to stir shit up with Cerberus."
		]
	Gargoyle -> pure $ dialog h $
		"Oh yeah, those automata? We make 'em to guard the place. Well, that's what we made them" / em "for" / ", but that was a while ago. These days you just get a lot of souls and the occasional obnoxious unicorn; there's not much trouble."
	Dryad ->
		[ dialog h $
			"Yeah, there are dryads."
			/ Paragraph / "I mean, I guess the farmers care more about them; they don't really go into the factory much. For obvious reasons."
		]
	SobekSheut ->
		[ dialog h $
			"They live in the swamp and drink the river water to get all riled up."
			/ Paragraph / "I don't really give a shit about their whole cult, but hey if one of them wants to fuck me I ain't gonna say no."
		]
	) <> [Choices $ pure $ ("<==", TalkOpening)]

platonicLeave :: MarkedScene Index Var HamarTabal
platonicLeave _ h =
	[ Narration ["The son of Hamar-Tabal waves briefly."]
	, dialog h $ "See ya."
	, Narration ["The son of Hamar-Tabal turns back to his work as you leave."]
	]

sexBranch :: MarkedScene Index Var HamarTabal
sexBranch b h = case locoplan b of
	-- actually we do want to universally flag 'fucked' even when you don't actually fuck, b/c it's only used to trigger that one dialog thing which is more the propositoning than the actual fucking
	Spec Orb -> flag : emptyBodyRejection b h
	Spec FloatingDick -> flag : floatingDickRejection b h
	Spec FloatingHead -> flag : floatingHeadRejection b h
	Basic Formless -> flag : emptyBodyRejection b h
	Basic Biped -> flag : sexBipedOpening b h
	Basic Slithering -> flag : sexSlitherNagaDialogOpening b h
	Basic Naga -> flag : sexSlitherNagaDialogOpening b h
	Basic Quadruped -> flag : quadCentaurSexForeplay b h
	Basic Centaur -> flag : quadCentaurSexForeplay b h
	-- Plan _ (Basic Wyvern) -> undefined
	-- Plan _ (Basic Complex) -> ...
	f -> bodyFail SexBranch f
	where
		flag = SetFlag (Local Fucked) 1

-- emptybody rejection. probably can be extended to a bunch of formless-tagged bodies
emptyBodyRejection :: MarkedScene Index Var HamarTabal
emptyBodyRejection _ h =
	[ Narration ["He laughs."]
	, dialog h $ "Seems a little hasty."
		/ Paragraph / "You got ambition, but even I got some standards; I'm not gonna stick my dick in a pulsing orb and call it a day."
	, Narration ["He pats your orb like he's ruffling hair you don't have, and then wipes his protoplasm-coated hand on his overalls."]
	, dialog h $ "Come back when you got something like a body and we'll see what you can do."
	, SetFlag (Local LastSeenNoDick) 1
	]

-- let's be honest he would actually be okay w/ having a floating head blow him
floatingHeadRejection :: MarkedScene Index Var HamarTabal
floatingHeadRejection _ h =
	[ dialog h $
		"I mean-- I guess you could blow me. But c'mon, I'd rather blow you, and you definitely don't got anything for that."
		/ Paragraph / "You got some ambition; I gotta give you that."
		/ Paragraph / "But how about you come back when you got something like a body and we'll see what I can do."
	, SetFlag (Local LastSeenNoDick) 1
	]

{-
floatingDickOpening

He looks across your flopping length and grins.
> Man after my own heart. / > That's a sight for sore eyes.
> Yeah, let's see you blow a few loads in me.

-}
floatingDickRejection :: MarkedScene Index Var HamarTabal
floatingDickRejection b h =
	[ dialog h $ "Hate to say it, but I don't got time right now."
		/ Paragraph / "Come back later, maybe, and I'll show you a time."
	]

--	"He moves down your body, hand splayed across your side the whole time. His hand drags down your side, dipping under your flanks. He lets out a sharp groan when he gets to your ass, both his hands cupping your fat balls, eagerly rubbing your inner thighs, stroking along the root of your cock, bulging out as a fat line running from your balls almost to your asshole."
quadCentaurSexForeplay :: MarkedScene Index Var HamarTabal
quadCentaurSexForeplay b h =
	[ dialog h $ "Hey yeah, who wouldn't want to."
	, Narration2 $ c "He looks you over, eager."
	] <> 
		(case (bodySpecies Chest b, locoplan b) of
			(Just Wolf, Basic Quadruped) ->
				[ dialog h $ "And what are you trying to be? An imitation hellhound?"
					/ Paragraph / "Prey playing at being a predator, huh?"
					/ Paragraph / "Still, you'll do."
				]
			-- this should set a conversation flag; if you show up later as a non-wolf quadruped he mentions he assumed you were going for hellhound.
			(Nothing, Basic Quadruped) ->
				[ dialog h $ "You're an interesting one, aren't you? A soul in the shape of a hound."
					/ Paragraph / "Prey playing at being a predator, huh?"
					/ Paragraph / "Still, you'll do."
				, SetFlag (Local AssumedHellhound) 1
				]
			(Just a, Basic Quadruped) ->
				[ InlineBranch (C (Local AssumedHellhound) (Eq 1))
					[ dialog h $ "Oh, so not a hellhound after all?"
						/ Paragraph / case a of
							Deer -> c "Prey after all, huh?"
							Unicorn -> c "Going for something more ethereal, I guess?"
							Bull -> c "Got some nice bulk on you, huh?"
							Goat -> c "But I think I was close enough, black goat."
							Lion -> "Wanted to be" / case gender b of
									He -> "King"
									She -> "Queen"
									_ -> "royalty"
								/ ", I suppose? That's not quite how it works down here."
							Tiger -> c "I always did like stripes."
							_ -> c "All sorts of beasties around to imitate."
					, SetFlag (Local AssumedHellhound) 0
					]
					[ dialog h $ "Well you're an odd creature, aren't you?"
						/ Paragraph / "Still, you'll do."
					]
				]
			_ ->
				[ dialog h $ "Well you're an odd creature, aren't you?"
					/ Paragraph / "Still, you'll do."
				])
	<> [ FauxChoice "yea cmon lets fuck"
	, Narration2 $ "He leans in close, "
		/ case planLocomotion $ bodyplan b of
			Basic Centaur -> "stroking a hand down your chest, cupping the muscled plane"
				/ case specNoun b of
					Just (SplitTaur top bottom) -> "where your" / animalName top / "body meets the" / animalName bottom
					_ -> "of your stomach" / case bodyMat_ Legs b of
						Solid (FMat _ Fur) -> ", fur shaggy down between your" / forelegs
						_ -> mempty
				/ "."
			Basic Quadruped -> "stroking a hand over your" / muzzle
				/ case bodySpecies Head b of
					Just Bull -> ", up to the massive humped bulk of your shoulders"
					Just Lion -> ", up through your shaggy mane"
					_ -> mempty
				/ "."
			f -> bodyFail "quadCentaurSexForeplay" f
		/ "He"
		/ case bodyHeight b of
			SmallAnimal -> "kneels"
			HorsishAnimal -> "stoops"
			CentaurHeight -> "raises up"
			HumanHeight -> "raises up"
			TallerThanHuman -> "raises up"
			Floating -> bodyFail "quadCentaurSexForeplay" Floating
			_ -> "raises up"
		/ "to kiss you sloppily"
		/ case clothes h of
			Hazmat -> ", shoving his gasmask up over his lips with a jerk"
			_ -> mempty
		/ case bodySpecies Head b of
			Just Human -> c "and pressing his lips against yours"
			Just _ -> c ", moaning when you loll your tongue out, shoving it into his mouth, thick animal drool spilling over his lips"
			Nothing -> ", drooling into your protoplasmic mouth, tongue lapping over your rubbery" / teeth
		/ ". He sucks on your tongue, "
		/ case bodySpecies Head b of
			Just Lion -> "hands buried in your shaggy mane"
			Just Human -> "hands gripping your head"
			_ -> "hands wrapped around the side of your head"
		/ hasArms ? ", your arms grabbing his shoulders and sides and pulling him chest-to-chest"
		/ ", his hips pumping the air as he ruts against your" / forelegs / "."
		/ case dickLocation b of
			Just DickSheathed -> "Your cock spills from its sheath, drooling down on the ground between your hind legs. "
			Just DickExternal -> "Your cock lurches, shuddering as it flushes with blood and swells. "
			Just _ -> "Your cock spills from your vent, drooling down on the ground between your hind legs. "
			Nothing -> mempty
		/ "He breaks the kiss, wiping the back of his forearm over his mouth"
		/ case bodySpecies Head b of
			Just Human -> mempty
			_ -> ", smearing your drool up over his stubbled cheek"
		/ "."
		/ case clothes h of
			Hazmat -> "He showily licks his lips, thick fangs shining with drool, before he tugs again on the mask, settling it over his face again."
			_ -> mempty
	] <>
	if hasDick b
		then
			[ Narration2 $ "He jerks his head to the side, looking down the line of your body, groaning at the sight of your" / unsheathed / "cock."
			, dialog h $ "Cmon, you gotta fuck me!"
			, Choices $ catMaybes
				[ pure ("sure, fuck him", Sex QuadCentaurAnal)
				, pure ("how abt you wrap yr lips around it", Sex QuadCentaurOral)
				, pure ("lets rub our dicks together", Sex QuadCentaurFrot)
				, guardC (hasArms b) ("how abt i fist you to open you up first", Sex Fist)
					-- >> pin him down and make out w/ him until he blows all over himself
					-- >> fuck him w/ yr giant writhing mouth tentacle
				, pure ("listen i wanna do smth to _yr_ dick okay", Sex QuadCentaurDickRefuse)
				]
			]
		else
			[ Narration2 $ c "He jerks his head to the side, getting a look at your sexless crotch, but then just as fast drops a hand to his crotch and tugs the fabric taut, overtly showing the outline of his cock."
			, dialog h $ "If you don't got a dick we can use, I guess we'll have to stick mine somewhere."
			, SetFlag (Local LastSeenNoDick) 1
			, Choices $ catMaybes
				[ guardC (hasMouth b) ("yeah cmon fuck my mouth", Sex OralBottom)
				, pure ("yeah cmon shove it in my ass", Sex QuadCentaurAnalBottom)
				, guardC (hasArms b) ("how abt i fist you instead", Sex Fist)
				-- >> pin him down and make out w/ him until he blows all over himself
				-- >> fuck him w/ yr giant writhing mouth tentacle
				]
			]

quadCentDickRefuse :: MarkedScene Index Var HamarTabal
quadCentDickRefuse b h =
	[ Narration2 $ "He gives an almost envious look to your" / Dick^s / ", like he's disappointed he won't get fucked gaping by" / "it"^p "them" / ". But he rallies."
	, dialog h $ "Sure, we could do that."
	, Narration2 $ c "He drops a hand to his crotch and tugs the fabric taut, overtly showing the thick outline of his cock."
	, dialog h $ "So where do you want me to shove this, then?"
	, Choices $ catMaybes
		[ guardC (hasMouth b) ("yeah cmon fuck my mouth", Sex OralBottom)
		, pure ("yeah cmon shove it in my ass", Sex QuadCentaurAnalBottom)
		]
	]


sexBipedOpening :: MarkedScene Index Var HamarTabal
sexBipedOpening b h =
	[ Narration ["He looks you over."]
	] <> if hasDick b
		then
			[ dialog h $ "Yeah sure. How about you put your cock in my ass."
			, Narration2 $ "He leers at you and takes a step forward, reaching out to drag you closer, pressing your bodies together chest-to-chest. His hand roams down your body, cupping around your cock"
				/ hasExternalBalls ? "and balls"
				/ "."
			, dialog h $ "How about that, huh?"
			, Choices $ catMaybes
				[ Just ("sure let's go for it", Sex $ BipedAnal FromMain)
				, Just ("how abt i fist you instead", Sex Fist)
				, guardC (hasMouth b) ("how abt i blow you", Sex OralBottom)
				]
			]
		else
			-- TODO: tonguefuck
			[ dialog h $ "Listen, you better be able to put" / em "something" / "in my ass."
			, FauxChoice "how abt i fist you"
			, SetFlag (Local LastSeenNoDick) 1
			, Jump $ Sex Fist
			]

sexBipedAnal :: BipedAnalFrom -> MarkedScene Index Var HamarTabal
sexBipedAnal from b h =
	case from of
		FromMain ->
			[ Narration2 $ "He leans in closer"
				/ case clothes h of
					Hazmat -> "dense material of his mask"
						/ case bodyMat_ Head b of
							Solid (FMat _ Skin) -> "pressing against your skin"
							Solid (FMat _ Coat) -> "rasping your coat up the wrong way"
							_ -> "digging into your cheek"
					_ -> ", stubble"
						/ case bodyMat_ Head b of
							Solid (FMat _ Skin) -> "rasping against your skin"
							Solid (FMat _ Scales) -> "scratching over your scales"
							_ -> "scraping over your cheek"
				/ "."
			, dialog h $ "Well good,"
			, Narration2 $ "he says into your ear, voice husky and low"
				/ case clothes h of
					Hazmat -> ", buzzing through his mask,"
					_ -> mempty
				/ "as he tugs, slowly milking your hardening cock."
				/ Paragraph / "He settles across your legs, grinding his cock against"
				/ case dickLocation b of
					Just DickExternal -> "the base of your dick"
					Just DickSheathed -> "your swollen sheath"
					Just _ -> "your flushed vent"
					f -> bodyFail "sexBipedAnal" f
				/ hasExternalBalls ? ", undersides of his thighs dragging back and forth over the hairy flesh of your balls"
				/ ". He wraps both hands around the shaft, thick as one of his meaty thighs, and pumps up and down. You rut up into his touch, cock twitching, and gush out a messy spurt of pre, and he lets out a gusty groan and smears it all across the dome of your cockhead."
				/ Paragraph / "You pull him close, hands wrapping around his arms and pulling him flush against your chest, your" / Cock^s / "spurting and gushing between you, squishing runny lines of pre between your bodies. His coarse hair grinds wetly against your sensitive flesh, his hairy chest rubbing up and down the underside of your" / Shaft^s / "."
				/ Paragraph / "His cock digs against the underside of yours, steadily dripping pre as he strokes you off, pumping up and down, catching each gush of pre and smearing it across your shaft until it's gleaming"
				/ case bodySpecies Cock b of
					Just x | ridgedCockhead x -> c ", hands pursing tight just under the fat head, "
						| otherwise -> "hands wrapping around your" / partAdjective Cockhead / "cockhead"
					Nothing -> c "all along its needle-like surface"
				/ "coaxing out bursts with each squeeze, "
				{-
				case bodySize b of
					x
						| x <= 2 -> "spitting down on the tip and slathering the mess across your cockhead, "
						| x >= 3 -> "pressing his lips to the tip, tongue lapping across your cockhead, drooling steadily and "
						| otherwise -> error ":("
				-}
				/ "spitting down on the tip and slathering the mess across your cockhead, "
				/ "letting it run down to coat your shaft."
				/ Paragraph / "He rises up, knees digging into your" / sides / ", and lets your" / Cock^s / "slide down his chest. The mess of fluid smears over his skin, matting his hair to his stomach as he straddles the" / partAdjective Cockhead / "head, skin dimpling where the engorged flesh digs in. He settles on top of it, knees just barely hitching up your stomach, pressing his puckering hole against the tip, grinding back and forth, his drooling cock smearing across your stomach as he bears down on your cock, hole trying to wrap itself around the tip. His hole blossoms open, a hungry sucking mouth kissing your cockhead."
				/ case clothes h of
					Hazmat -> "He groans deeply"
					_ -> "His eyes roll back in his head"
				/ "as he pushes himself down, one hand held back to stabilize himself, the other pressed against his gut, the tension of his abs already pressing against your cockhead. He drags himself lower, asshole slurping lower down your cock, his gut bloating against his hand as your cockhead pushes against his skin from the inside."
			]
		FromFist ->
			[ Narration2 $ "You wrench your fist out with a sloppy" / em "shluck" / ", leaving his asshole cratered, his swollen ass lips fluttering as he clenches, slurping together and then peeling apart as he gapes open again."
				/ Paragraph / "You stroke your cock, coating it in slimy ooze, and press the" / partAdjective Cockhead / "tip against his hole. Not against the whole of it, he's spread too wide for that, but you rest your cockhead against the lower lip of his hole, bruised and swollen outward in a fat, rubbery pout. He groans, asshole fluttering again, trying and failing to clench tightly enough to wrap around your cockhead. You're already leaking, fast, and you spurt runny lines of pre all across the inner flesh of his ass, flooding him until it starts to gurgle out along the thick folds in his bloated flesh, spilling down his hairy crack. You thrust in, rutting back and forth slightly,"
				/ case bodySpecies Cock b of
					Just x | ridgedCockhead x -> partAdjective Cockhead / "cockhead catching on his rim and making it jolt and bulge, tugging his guts out into something ever-so-slightly closer to a prolapse with each thrust"
					_ -> partAdjective Cockhead / "cockhead stabbing inside and glancing against his inner walls, hosing squirts of pre deeper into his ass before you pull out with a gurgle and a flood of pre"
				/ ", over and over until he's groaning and squirming, flushed and sweating, untouched cock still dribbling come all across his stomach."
			]
	<> [ Narration2 $
		Paragraph / "You thrust up, hands wrapping around his hips and dragging him down, and his stomach bloats, surging around your cock. He presses both hands to his belly, practically stroking you off from the inside, shuddering each time a gush of pre makes his guts gurgle. You cram half your cock inside, rutting back and forth, his body swelling and hollowing as your cock drives into his guts. He clenches his belly hard, fingers blobby points of pressure against your cock, entire body convulsing and slurping around your shaft, asshole swollen to a puffy doughnut, pre gurgling from his overfilled ass and streaking down your shaft."
		/ Paragraph / "You come with a bellow, come flooding his bloated belly, audibly sloshing and gurgling as you fill him up in a single shot, and the second erupts from his ass, backflooding out in a messy explosion, spilling down your shaft, churning into a thick white lather as he fucks himself on your erupting cock, eyes fluttering closed, hand scraping down his hairy gut to clench around his cock, stroking himself off as he slumps forward, practically impaled on your cock."
		/ Paragraph / "He slowly skews to the side, still jerking off, in a boneless pile on the ground with your cock still embedded inside, his broken asshole squeezing around your shaft as he"
		/ case from of
			FromMain -> "finally brings himself off"
			FromFist -> "comes again with an almost-pained groan, balls pulled up into a tight lump just under his cock"
		/ ", gushing his load across his already-sodden body. You drag your shaft backward, his broken asshole slurping down your shaft, letting it emerge coated in your load, messy bubbles of come gushing out each time his hole clenches and gapes."
		/ case bodySpecies Cock b of
			Just x | ridgedCockhead x -> "Your head catches at the rim, distending his cratered ass out in a thick mound, and then finally bursts out with an explosion of come,"
			_ -> "Your cockhead tugs out, slurping from his wrecked ass and coming loose following by a sloppy waterfall of come,"
		/ "his swollen stomach finally starting to hollow as your massive load pours from his wrecked ass. He rolls onto his back,"
		/ case clothes h of
			Hazmat -> "breath buzzing through his gasmask,"
			_ -> "dazed smile on his face,"
		/ "gaping hole clenching and gaping, ring swollen into a huge mess of bloated flesh, crinkled and folded over itself, glazed with rivers of come."
	, dialog h "Fuck"
	, Narration ["He groans, slow, and lets his head hit the ground with a thump, fingers slowly inching down his body, catching at his hole, curling inside and pulling it out into a messy corridor, flushed purple-red and glazed white, steadily drooling come."]
	, dialog h "Fuck, that was really what I needed"
	]

-- TODO: this should branch on if the pc has fucked him by crawling all up inside him before. so more just like "you wanna use yr dick this time / you got a dick this time / you wanna crawl up inside me again?"
sexSlitherNagaDialogOpening :: MarkedScene Index Var HamarTabal
sexSlitherNagaDialogOpening b h =
	[ Narration ["He looks you over."]
	] <> case bodyplan b of
		Plan (Basic Slithering) _ limbs -> case thd_ . chest $ limbs of
			Nothing ->
				[ InlineBranch (C (Local MetProtoplasmicSnake) (Eq 1))
					[ dialog h $ "Still trying to be a snake, huh?"
					]
					[ dialog h $ "Serpents are classical. Or maybe you're more of a leech?"
					, SetFlag (Local MetProtoplasmicSnake) 1
					]
				]
			Just Snake ->
				[ InlineBranch (C (Local MetProtoplasmicSnake) (Eq 1))
					[ dialog h $ "That's a better snake impersonation, if I had to say."
						/ Paragraph / "Still up to fuck me with it?"
					]
					[ dialog h $ "Serpents are classical. But, y'know, I got cruder interests here; I hope you're snake enough to got two dicks."
					]
				]
			Just _ ->
				[ dialog h $ "Well, that's sure" / em "some" / "kinda monstrosity you built yourself into."
				, Narration2 $ c "He grins down at you."
				, dialog h $ "'S nice."
				]
		Plan (Basic Naga) _ _ ->
			[ dialog h $ "Sure. Y'know snakes got two dicks, right? And I'm really hoping you're snake enough to match."
				/ Paragraph / "I guess I'm about to find out, huh?"
			]
		f -> bodyFail "sexSlitherNagaDialogOpening" f
	-- this following bit should mostly by a first-time thing
	<> [ Narration2 $ "His snake-tail is looking at you. It arches closer and flicks its tongue out, as if trying to smell your shape. He gropes himself overtly, settling back on the bench, legs spread, "
		/ case clothes h of
			Overalls -> c "cock a thick lump in his overalls, skewing down one side"
			Skirt -> c "his half-hard cock arching out, overtly on display as the sweat-soaked fabric of his skirt drapes over it, doing nothing to hide its span"
			x -> case x of
					Hazmat -> "hazmat"
					_ -> mempty
				/ "pants nearly falling off his hips, coarse pubes curling up over the waist, cock tented fat under the heavy fabric"
	] <>
	if locoplan b == Basic Slithering
		then if hasDick b
			then
				[ dialog h $ "Well, don't just sit there like a lump."
					/ Paragraph / "Get up here and fuck me."
				, Choices
					[ ("get up there and fuck him", Sex SlitherNagaAnal)
					, ("slither all up inside his asshole", Sex SlitherAnalFullbody)
					, ("how about you lemme blow you", Sex SlitherOral)
					]
				]
			else
				[ InlineBranch (C (Local LastSeenNoDick) (Eq 1))
					[ dialog h $ "I was waiting to see if you'd get yourself a cock, but your whole body's good for what I want."
					]
					[ dialog h $ "Y'know, even without a dick -- hell, your whole body's one big dick. Just crawl right up inside me, fuck me that way."
					]
				, Narration2 $ "He slouches lower, back braced against the wall,"
					/ case clothes h of
						Overalls -> "and snaps the buttons on one side of his overalls, tugging the fabric diagonally back as he lifts his legs, showing off one of his huge muscled ass cheeks. His eyes are dark, slit pupils wider as he reaches back,"
						Skirt -> "and hikes his skirt up, showing off his fat, muscular ass cheeks. His eyes are dark, slit pupils wider as he reaches back,"
						x -> "and lifts his legs: hooking a claw against the rim of his pants, already pulled away from his skin, showing the top of his hairy ass, and tugs it down over his muscled ass cheeks,"
					/ "fingers digging between his cheeks to spread them just-so, the purple-grey flesh of his asshole visible between the dense curls of hair across his cheeks."
				, dialog h $ "Wanna give it a try?"
				, Choices
					[ ("yea", Sex SlitherAnalFullbody)
					, ("nah how abt i blow you", Sex SlitherOral)
					]
				]
		else
			[ dialog h $ "Well, don't just sit there like a lump."
				/ Paragraph / "Get up here and fuck me."
			, Choices $ catMaybes
				[ guardC (hasDick b) ("get up there and fuck him", Sex SlitherNagaAnal)
				, guardC (hasMouth b) ("nah how abt i blow you", Sex OralBottom)
				, pure ("how abt i fist you instead", Sex Fist)
				]
			]
{-
	 a leg, the curve of one cheek on display, covered in hair that converges to his crack, his hand dragging his cock to the side, balls lurching after. His eyes are dark, slit pupils wider."]

-}

sexSlitherOral :: MarkedScene Index Var HamarTabal
sexSlitherOral b h =
	[ Narration [ "He laughs."]
	, dialog h $ "Just dying for some dick? I guess you could blow me."
	, Narration2 $ "He gropes his cock again, a thickening lump"
		/ case clothes h of
			Skirt -> c "along the fold of his skirt, cock unfettered by the loose garb"
			x -> "down the side of his" / case x of
				Overalls -> "overalls"
				Hazmat -> "hazmat pants"
				Welder -> "pants"
				f -> bodyFail "sexSlitherOral" f
		/ "."
	, dialog h $ "Well, what are you waiting for? Get over here."
	, Narration2 $ "You coil up his right leg, his meaty muscles shifting under your weight, bunching and relaxing as you circle around and around. His snake tail watches."
		/ Paragraph / case clothes h of
			Overalls -> "His left hand settles on his hip, over the line of buttons keeping his overalls on. His thumb digs into the fabric, a slow clench of his fist popping the top botton, and then again, and again, each motion letting the apron hang lower, revealing more of his cock -- a thick swath of dark pubes, his shaft bulging against the fabric, fat base on display -- until it finally swings up and out, "
			Skirt -> "His left hand goes for the twist of fabric keeping his skirt together. He tugs it apart, skirt going slack immediately, falling apart into just a long span of fabric, draped across his thighs. He crumples it in his hands, revealing the hairy span of his inner thighs, the thick fan of his sweat-drenched pubes, and then tosses the fabric entirely aside, letting his cock loll out into the open, "
			x -> "He pops the button on his pants, clawed nail hooking onto the loop of the zipper and slowly dragging it down, revealing a thick swath of dark pubes, shaft a hard line down the side of his pants. He reaches in a tugs out his cock, jutting up from the spread zipper, and gives it a stroke: "
		/ "grey skin flushing a dull purple, his fleshy foreskin a thick ring of skin halfway down his fat cockhead, "
		/ case piercings h of
			NotPierced -> "half-retracted"
			IsPierced -> "bulging out around his thick PA piercing"
		/ ". He tugs the base of his shaft up,"
		/ case clothes h of
			Skirt -> c "letting the immense heavy flesh of his balls loll across his thighs, flesh bunching and relaxing slowly, making them churn up and down"
			x -> "slowly rolling his balls out in the open too, immense heavy flesh drooped against " / case x of
				Overalls -> "the fabric of his overalls"
				Hazmat -> "the rubbery material of his hazmat pants"
				Welder -> "the leathery material of his welding gear"
				f -> bodyFail "sexSlitherOral" f
		/ "."
		/ Paragraph / "You bump your" / muzzle / "against it, flesh shuddering from the touch. His flushed cockhead twitches, cockslit spreading as he oozes out a smear of pre. "
		/ case bodySpecies Head b of
			Just Snake -> "You flit your tongue out and taste it, forked tongue lapping at his cockhead, a thin strip of pressure."
			_ -> "You lap at the smear, catching it on your tongue and swallowing."
		/ "He groans and rubs the base of his cock, aiming it down to grind it against your open mouth, salt taste blossoming across your tongue."
		/ Paragraph / "He wraps his other hand around your body just under your head, his calloused fingers cupping the side of your thick"
		/ case bodySpecies Chest b of
			Just x -> c $ animalName x
			Nothing -> c "wormlike"
		/ "body. He half-guides, half-drags you forward, cockhead vanishing into your mouth. He groans, dragging you back and forth, the fat wedge of his cockhead lurching back and forth through your mouth, drooling a messy spill of pre down your throat and smearing it all down his shaft, until it shines dully."
		/ Paragraph / "You curl tighter around his leg, thigh flexing against your constriction, body shifting behind your head, a long arch of"
		/ case bodySpecies Chest b of
			Just Snake -> "serpentine"
			Nothing -> "wormlike"
			_ -> mempty
		/ "body between his thighs. He grabs at you, hands grasping a foot or so of your body, and he arches up to bury the full length of his cock down your throat, fingers digging at your throat to squeeze his cockhead."
		/ Paragraph / "He pulls back and thrusts again, building up a rhythm, your" / muzzle / "buried in his pubes, mouth opening until your"
		/ case bodyMat_ Head b of
			Solid (FMat _ Protoplasm) -> "protoplasmic"
			_ -> mempty
		/ "jaw is spread vertical when he buries his cock in you, pre sloppily oozing out around his shaft, spilling down his fat balls. He uses you as a slick, tight sheath, hips jerking up to fuck down your throat, groaning at your swallowing muscles wrapping tight around his cock, hand covering your head, using your spread jaws as a base as he thrusts up, sloppily fucking your throat."
		/ Paragraph / "He comes with a groan, shaft throbbing in your mouth, balls lurching against your spread jaw. He grunts with each spurt, a heavy flood of come squirting down your throat, hot and potently alive, pouring down your throat or just spilling out past his pumping shaft, calloused fingertips digging down hard against your underbelly, playing with his cockhead through your sheathing flesh."
		/ Paragraph / "He keeps thrusting until he's half-hard, most of his load drooling out of your sloppy mouth, spilling in thick rivers down his shaft, before he tugs you off with a pop, cock skewing to the side, slapping his thigh with a wet" / em "crack" / ". He's breathing hard, hairy chest dark with sweat, and he gives you a lopsided grin, catching a thick cord of come drooling from your mouth on his finger and dragging it up to his mouth, licking it up."
	, dialog h $ if hasDick b
			then "Maybe next time you'll take a crack at my ass, huh?"
			else "Come back with a cock of your own, and I'll return the favor."
	, FauxChoice "yea sure"
	, dialog h "It's a date, then."
	]

sexSlitherApproach :: MarkedScene Index Var HamarTabal
sexSlitherApproach b h =
	[ Narration2 $ case clothes h of
			Overalls -> "He tugs the straps of his overalls, overalls nearly sliding down his hips just from that. But he snaps the first of the lines of buttons on his hips and then just legs them fall, stripping himself naked."
			Hazmat -> "He shrugs out of his jacket and then snaps the button of his pants, just a fractional tug enough to let them slide off his hips, the heavy fabric crumpling below."
			Welder -> "He snaps open the button of his pants, unzipping them and letting the heavy leather slide down his bare legs. He's not wearing anything under them."
			Skirt -> "He pulls at the wrap keeping his skirt fastened, and the entire thing unravels, baring his entire body as he tosses the hank of fabric aside."
		/ "He sits back, one hand tugs his half-hard cock, lifting his balls out of the way, the other digging into the meat of his ass. He pulls until his asshole is on display, surrounded by tight curls of dark hair. His tail, pressed tight along the curve of his ass, says this isn't the first time he's tried this."
		/ Paragraph / "You slither closer. He angles his legs higher, one knee pressed against his chest: cock lolling across his stomach, a shiny splotch of pre slowly spreading across his thick abs, and the pucker of his asshole a dark circle between his spread cheeks, twitching as you approach. He milks his cock, drags a finger across his hole, leaving it smeared with pre, shining dimly."
		/ Paragraph / "He shudders when you press against him, "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Protoplasm) -> "the not-quite-skin of your protoplasmic body neither rough nor smooth, sliding with minute friction up the underside of his thigh"
			Solid (FMat _ Scales) -> "scales sliding with a smooth, heavy pressure up the underside of his thigh"
			Solid (FMat _ Bone) -> "each curve of rib bone smooth as you slither up the underside of his thigh, and you have very many rib bones"
			_ -> "body sliding across his inner thighs"
		/ "."
	]

sexSlitherFullbody :: MarkedScene Index Var HamarTabal
sexSlitherFullbody b h =
	[ Narration2 $ "His hole clenches and opens in front of your face, the skin of his balls slowly furrowing. He shudders again when you press "
		/ case bodyMat_ Head b of
			Solid (FMat _ Bone) -> "the crest of your skull "
			_ -> "the tip of your snout "
		/ "against his hole, and moans loudly when you push inside. Inside it's just pressure and heat, his heartbeat a physical presence, in time with the eager, sucking muscles of his ass. But the thing about being a disembodied soul is that your eyes aren't, strictly speaking, in your head. Outside: you slither closer, wrapping in "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Bone) -> "rattling "
			_ -> "loose "
		/ "coils around his thigh, waist, tail, the long curve of your body not so much fucking him as simply sliding deeper and deeper inside. He's wrapped tight in your coils, loops around his waist and legs"
		/ case bodyMat_ Chest b of
			Solid (FMat _ Protoplasm) -> ", the tangle of protoplasmid soul-body like cords tied around him"
			Solid (FMat _ Bone) -> ", tied tight in your tangle of bone"
			Solid (FMat _ Scales) -> ", scales digging into his skin"
			_ -> "tying him tight"
		/ "."
		/ Paragraph / "He's jerking off, "
		/ case clothes h of
			Hazmat -> "breathing hard "
			_ -> "face flushed "
		/ "and head tipped back, one hand over his head braced against the ridge of the refinery he was working on before you interrupted him. Obscene squelches come from his cock, pre flooding his foreskin as he drags it up over the tip and burbling out down his shaft on each stroke. He catches some of it in his palm, cloudy grey where it pools thicker, and smears it along the arch of your "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Bone) -> "bones"
			_ -> "body"
		/ ", slimy as you push deeper inside him, "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Bone) -> "each crest of bone slurping inside him, the hollow of your body revealing just how deep you've tunneled into his gaping asshole"
			_ -> "your fat anaconda body plugging his hole solidly, asshole gaping wide"
		/ ". Your "
		/ case bodyMat_ Head b of
			Solid (FMat _ Bone) -> "skull"
			_ -> "head"
		/ "is deep inside, ramming against the end of his ass and slowly sinking into the tighter passage of his guts, following the winding curve higher inside him. The pressure of his body around you -- muscles clenching, heartbeat hammering -- a constant presence."
		/ Paragraph / "He comes with a shout, cock spraying his load past his head, up the wall behind him, gush after gush of cloudy grey come splattering "
		/ case clothes h of
			Hazmat -> "his mask and chest "
			_ -> "his face and chest "
		/ "and whatever part of your "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Bone) -> "spine is "
			_ -> "coils are "
		/ "squirming over him there, smearing the fluid across both of you. He groans, low:"
	, dialog h "Fuck -- no, keep going."
	, Narration
		[ "as you tense and slide minutely back, and so you plunge deeper to a renewed groan. He's so stuffed full your body fights against the muscles of his stomach, his belly stretched and starting to bulge. He tugs his cock, keeping it half-hard, smeared with come, already dribbling fresh pre."
		, "You work two more loads out of him before he says stop, and then one more -- wracked, shuddering, almost sobbing -- on the way out, leaving him sweaty and limp, streaked from crown to waist with his issue, skin flushed splotchy grey-purple when you finally emerge, his cock still stubbornly hard and oozing come in a constant stream."
		]
	, dialog h $
			"Fuckin' hell, it's been a while since I did that."
			/ Paragraph / "Hey, you wanna come back and do that again some time?"
	, Narration
		[ "Right after saying it he all but faceplants, twisting just enough to keep gasping, sweat still steadily trickling down his back."
		]
	, FauxChoice "yea sure"
	, Narration2 $ "He's too exhausted to do anything more than wave as you slither away"
		/ case clothes h of
			Hazmat -> ", panting under his mask"
			_ -> ", a crooked grin on his flushed face"
		/ "."
	]

sexSlitherNagaAnal :: MarkedScene Index Var HamarTabal
sexSlitherNagaAnal b h =
	[ Narration2 $ case locoplan b of
			Basic Naga -> "You curl around him, wrapping your lower body in coils around his legs, pinning him tight in your grip. You wrap your hands around his forearms, pinning them behind his back, chest pressing against him. "
			Basic Slithering -> "You wind your way up his body, coiling around his legs, twisting around his bicep and meaty chest, wrapping around and around until he's caught tight in your coils. "
			f -> bodyFail (Sex SlitherNagaAnal) f
		/ case dickLocation b of
			Just DickExternal -> "Your" / Cock^s / Drags^s / "up his thigh, leaving"
			Just DickSheathed -> "Your" / Cockhead^s / Drags^s / "along his thigh, swollen and hanging from your fat sheath." / "It leaves"^p "They leave"
			Just _ -> "Your vent drags up his thigh, flesh already parted. Your"
				/ case bodySpecies Cock b of
					Just Snake -> c $ "hemipene leaves"^p "hemipenes leave"
					_ -> c $ "cock leaves"^p "cocks leave"
			f -> bodyFail (Sex SlitherNagaAnal) f
		/ "behind a wet trail"
		/ case bodyMat_ Tail b of
			Solid (FMat _ x) -> ", slick over your" / matword x
			Trans _ _ -> mempty
		/ ". The wet flesh presses against the cleft of his ass, slowly drooling down his hairy crack, forming a patch of slickness as you slide back and forth, working your" / Cock^s / "deeper between his cheeks, until your" / Shaft^s / Scrapes^s / "against his pucker. He spreads himself open, ass gaping as he squirms in your coils, trying to grind himself back against your" / Cock^s / "."
		/ Paragraph / "You slide forward, fat" / Cocktip^s / "dragging against his hole before you ease" / "it"^p "one" / "inside"
		/ manyCocks ? ", grinding the second against his stretched hole until it parts, gaping in a lopsided oval as you work both inside, slowing sinking the both of them deeper"
		/". He shudders and groans, asshole clenching and sucking, eagerly swallowing you to the hilt."
		/ Paragraph / "He squirms again, trying to reach his cock, and you"
		/ case locoplan b of
			Basic Naga -> c "reach forward, stroking him with one hand"
			_ -> case bodyMat_ Chest b of
				Solid (FMat _ m) -> "slide your coils down, dragging across the length of his cock, sheening your" / matword m / "with his pre"
				f -> bodyFail "sexSlitherNagaAnal" f
		/ ". He groans, huffing as you take your time -- not so much fucking him as letting your body move around him, vent working back and forth against his hole, the ridges and spines of your" / Cock^s / "sliding against the furrow of his ass. "
		/ case locoplan b of
			Basic Naga -> "You"
			_ -> "Your coils"
		/ "stroke his cock as he groans and struggles, thumping against the ground. His cock drools steadily, slapping against his belly, and when you next roll up, dragging your" / Cock^s / "inside him, he comes with a prolonged groan, come welling up and drooling down the shiny dome of his cockhead in a dozen pulses over the next minute."
	, dialog h $ "Fuck, keep going."
	] <> case ballProduction b of
		Just bp | cumflates bp ->
			[ Narration2 $ "You oblige, twining tighter around him, focusing more and more on the wet drag of his ass, your" / Cock^s / "steadily drooling watery slime inside him, making each slow thrust slicker as you get closer and closer to coming. Your balls shudder,"
				/ hasExternalBalls
					? "sluggishly pulling up against the base of your shaft, grinding against his sodden ass"
					?: ("clenching"
						/ case bodyMat_ Tail b of
							Solid (FMat _ Scales) -> "under your scales"
							_ -> "inside you"
						/ ", throbbing increasing as you get closer and closer to coming")
				/ ". You twist tight around him,"
				/ hasLocotype Slithering ? "coils bending him back" ?: "pinning his shoulders back"
				/ ", body in a taut arch, the swell of your" / Cock^s / "visible across his hollowed stomach. You" / groan / "as you erupt,"
				/ "your cock" ^p "both cocks"
				/ "gushing into his ass."
				/ Paragraph / "He moans, raggedly, hand pressing against his stomach, skin fluttering up and down with each throb: the gush bulging his stomach, receding to build up in a heavy, sloshing wet lower in his guts. You keep fucking him,"
				/ case dickLocation b of
					Just DickExternal -> ", rolling the very root of your" / Cock^s / "against his stretched hole"
					Just DickSheathed -> c ", smearing your wrinkled sheath against his stretched hole in an obscene kiss"
					Just _ -> c ", pressing your oozing vent against his stretched hole in an obscene kiss"
					f -> bodyFail "sexSlitherNagaAnal" f
				/ ". Beads of slime drool from his stretched hole, first sluggishly and then, as his stomach bloats and bulges, squirting with each thrust, a messy splatter gushing out across your underbelly each time you sheath your" / Cock^s / "fully inside him."
				/ case locoplan b of
					Basic Slithering -> "Your coils are wrapped all across his chest and stomach, and as his gut floods you automatically tighten your grip against the pressure, forcing out a sloppy eruption of come from his wrecked hole. He sobs, groaning, and you slide your coils around: one loop up, another down. His gut sags out with a muffled gurgle, audibly sloshing as it settles into a broad, swollen span."
					Basic Naga -> "His muscles spasm and clench against the growing weight until with a sobbing groan he relaxes, letting them go slack, and his gut bloats out in a sudden rush. Come audibly sloshes and gurgles inside him as his gut sags, settling into a bottom-heavy arch as you keep shallowly rutting back and forth inside him, filling him up more."
					f -> bodyFail "sexSlitherNagaAnal" f
				/ Paragraph / "His skin is drawn taut, each new spurt of come making his flesh resonate like a drumhead, and he whines and moans, hole still spasming around your" / Shaft^s / "as his gut sags out before him. The pressure grows, bloating him more and more, gut growing into a taut keg-like swell, and then in a rush thin stripes of shredded-raw skin tear across his stomach, each one letting his gut sag out that much further. They grow, crawling up across his belly and chest, giving him messy rows of stretch marks, spreading into wide, purple-red blotches, slowly spotting with lymph."
				/ Paragraph / "Even with that, there's a continual waterfall of come pouring from his wrecked ass, slurping out around your" / Shaft^s / ", smearing between your body in grimy strings. You thrust in, punctuated by a slobbery, gulping" / em "squelch" / ", " / Cock^s / "gushing another"
				/ case cockCount b of
					1 -> "spurt"
					2 -> "twinned spurt"
					_ -> "floodlike eruption"
				/ ", and then drag him halfway off your" / Cock^s / "with a hollow sucking noise."
				/ case cockCount b of
					1 -> c "His"
					x -> "His hole is absolutely cratered, stretched gaping from your"
						/ (if x == 2 then "twin cocks" else "cocks") / ", and his"
				/ "ass lips drag out into a rumpled, furled swell, clinging tight to the" / partAdjective Shaft / " surface of your" / Shaft^s / "." -- {ridged/gnarled/etc} surface
				/ Paragraph / "You pull out -- practically having to" / hasLocotype Naga ? "shove" ?: "roll" / "him off your" / Cock^s / "-- with another set of obscene sounds, dumping him down on all fours, his bloated gut filling the space under him, pressing against the ground. He shudders, shredded muscles across his stomach spasming, and his wrecked hole erupts with a gush of come, spraying in a fire-hose squirt back across your still-oozing" / Cock^s /". He slumps down on his side, practically anchored to the ground by the weight of his gut, and reaches down, huffing and whining, pressing a hand to his enormously-swollen stomach, hissing when his fingers drag over the oozing stripes of his new stretch marks."
				/ Paragraph / "Your" / Cock^s / Smears^s / "against his side as you circle around him, drooling out the dregs -- or maybe just letting the mess splattered all across" / "it"^p "them" / "drain -- all across his shoulders and back, painting him entirely in your load."
			] <> analCumflateCloser b h
		_ ->
			[ Narration2 $ "You oblige, twining tighter around him, focusing more and more on the wet drag of his ass, your" / Cock^s / "steadily drooling watery slime inside him, making each slow thrust slicker as you get closer and closer to coming. You" / groan / ", body twisting tight around him, coils bending him back as you come, gushing into his ass. Beads of slime drool from his stretched hole, first sluggishly and then squirting with each thrust as you fill him up, until thick lines of come"
				/ case bodyMat_ Chest b of
					Solid (FMat _ Scales) -> "drool down your scales"
					_ -> "drool down across your body"
				/ ", smearing all across his thighs. You keep fucking him"
				/ case dickLocation b of
					Just DickExternal -> ", rolling the very root of your" / Cock^s / "against his stretched hole"
					Just DickSheathed -> c ", smearing your wrinkled sheath against his stretched hole in an obscene kiss"
					Just _ -> c ", pressing your oozing vent against his stretched hole in an obscene kiss"
					f -> bodyFail (Sex SlitherNagaAnal) f
				/ "."
				/ Paragraph / "You pull out with a wet slurp, his worked hole gushing your load in a miniature waterfall as you slide off him. He groans and twists,"
				/ case clothes h of
					Hazmat -> "breath huffing through the gasmask, eyes hidden behind its welding-glass gleam. He jerks himself off to a second orgasm in as many minutes, this time painting his chest with the spurts, each pulse in time with a rattling gasp from inside his mask."
					_ -> "tongue lapping under your chin as he grabs his dick, jerking himself off to a second orgasm in as many minutes, this time painting his chest with the spurts, mouth open as your tongue flits inside, tasting his flesh."
				/ "He collapses to the ground, hand reaching down to cup your spent" / Cock^s / ", fingers milking out the wet dregs, oozing down his fingers."
				/ Paragraph / "He lies there in a heap, breathing hard, grey skin shining with his load as he idly strokes both you and himself, hands splattered with your mixed loads."
			, dialog h $ "Fuck, you did good. You up to do it again?" -- TODO: dialog?? ???
			]
{- -- the version including some weird & maybe incorrect size markup
{case bodytype of
	Snake -> You wind your way up his body, coiling around his legs, twisting around his bicep and meaty chest, wrapping around and around until he's caught tight in your coils.
	Naga -> You curl around him, wrapping your lower body in coils around his legs, pinning him tight in your grip. You wrap your hands around his forearms, pinning them behind his back, chest pressing against him.
} Your vent drags up his thigh, flesh already parted. Your hemipenes leave behind a wet trail, slick over your {scales}. The wet flesh presses against the cleft of his ass, slowly drooling down his hairy crack, forming a patch of slickness as you slide back and forth, working your cocks deeper between his cheeks, until your shafts are scraping against his pucker. He spreads himself open, ass gaping as he squirms in your coils, trying to grind himself back against your cocks.

You slide forward, {
	Size 0 -> cocktips playing against his hole before you slide inside, slowly sinking to the hilt in a single relaxed thrust.
	Size 1 -> fat cocktips dragging against his hole before you ease one inside, grinding the second against his stretched hole until it parts, gaping in a lopsided oval as you work both inside, slowing sinking the both of them deeper.
	Size 2 -> your immense cocks smearing against his cheeks, coating his hairy ass in slimy snake pre. With your vent pressed against his muscled cheeks, the upturned tips drool against the small of his back, and he shudders and grinds back against the base, hole winking open.
		You ease back, a single tip pressed against his hole, pushing inside until he flowers open, hungry hole stretched wide around the broad tip. Your second cock knocks against his cheek, squirting pre in a messy flow all across his stretched hole, piling up in cloudy pools around your shaft, sunk inside him.
	Size 3 -> your immense cocks dragging back and forth over his body, nearly spanning from his ass to head -- the tips drool pre across his scalp, and he twists around to lap it from the air, slathering his face in slimy snake pre. Your body kinks and shifts, dragging your cocks back until they're aimed at his hole, each spurt of pre gushing into his crack, soaking his hairy ass in slime. You work a single tip between his cheeks, the other knocking against his hip, letting it flood his crack until you're sliding through piles of cloudy pre, pushing your broad cockhead back and forth over his hole. He shudders and grinds back, hole winking open, nowhere large enough to take even the barest tip of your cock. You slink forward, cockhead kissing his hole, and push down. He tenses, asshole clenching and spreading, over and over as he grunts and groans, until with a hiss you breach inside, his asshole gaping, flesh stretched and red, sinking half of your cockhead inside.
		He shudders again, caught fast in your coils, and you slowly sink deeper, easing the rest of your cockhead inside. Each gush of pre audibly floods him, gurgling up his guts and drooling out around the spongy frill of your cock, squirting as you rut deeper, his belly growing swollen.

	Size 4 -> cocks rutting against his cheeks, spurts of slime drooling over the sides of his hips. Even one of your twinned cocks would split him asunder, but with the way he's squirming -- you grind down, forcing one huge shaft between his cheeks, the tip erupting gushes of pre. Slime gurgles and slurps as he opens himself, asshole forming a wet mouth suckling on the tip, swallowing as you bear down, forcing the barest fraction of the spread tip into his ass.
} He shudders and groans, asshole clenching and sucking, {
	Size 0 -> eagerly swallowing you to the hilt.
	Size 1 -> eagerly swallowing you to the hilt.
	Size 2 -> gaping around your shaft. You spurt cloudy pre against his stretched ring, working the tip of your second cock against his already overstuffed hole. His back bends in an arch as you stuff the tip inside, stretching his hole into a wide oval. He's slick, flesh velvety soft against your spiny cocks. Each flutter of your cocks pulls a groan from him, pre drooling out between your shafts as you flood his ass.
	Size 3 -> gaping around your shaft. The barest span of one cockhead shoves inside him, and he wheezes. He's slick, flesh velvety soft against your spiny cock, and the muscles of his stomach strain against your cockhead, forming a hard barrier. With his back arched you can see -- and feel -- your cock press against his muscled stomach, forming a round bulge that swells into a broad line as you work more cock into him, slowly slithering deeper, pulling back fractionally to shove more of your gigantic length into him. Your other cock shows just how much you've got inside him, knocking against his hip, straining and flaring in unison with the length impaling him, spilling gush after gush of pre across his sides.
	Size 4 -> gaping around your cockhead. His hole is stretched, purple skin drawn so tight it's gone pale, muscle constantly fluttering around your cockhead like a wet mouth. Each fresh shot of pre floods his ass, audibly gurgling as you pulse and pulse. The tremors running through your cock jerk his body back and forth, practically impaled on the tip of your dick. He groans, stomach hollowing as his back bends in an arch, and the bloated swell of your cockhead is clearly visible, growing larger as you shove more of your length inside. A single squirt of pre from your other cock hoses him down, splattering in runny globs across his skin and drooling down to coat your scales: the same volume is gushing inside him, trapped in his ass and slowly flooding up into his guts, pump after pump filling him to overflowing. You shift, cock sinking a fraction deeper, and a messy explosion of pre erupts around your length, painting the rest of your shaft in drooling strings of slime, webbing between his thighs and your pulsing cock.
} He squirms again, trying to reach his cock, and you {
	Snake -> slide your coils down, dragging across the length of his cock, sheening your scales with his pre
	Naga -> reach forward, stroking him with one hand
}. He groans, huffing as you take your time -- not so much fucking him as letting your body move around him, vent working back and forth against his hole, the ridges and spines of your // cock/s // sliding against the furrows of his ass. {Your coils//You} stroke his cock as he groans and struggles, thumping against the bottom of the boat. His cock drools steadily, slapping against his {
	Size 3 -> bloated
	Size 4 -> bloated
} belly, and when you next roll up, dragging your // cock/s // inside him, his comes with a prolonged groan, come welling up and drooling down the shiny dome of his cockhead in a dozen pulses over the next minute.

>Fuck, keep going.

You oblige, twining tighter around him, focusing more and more on the wet drag of his ass, your // cock/s // steadily {drooling//gushing} watery slime inside him, {
	Size 3+ -> all over him,
} making each slow thrust slicker as you get closer and closer to coming. You hiss, body pulling fast, coils bending him back as you come, {
	Size 1-2 -> gushing into his ass. Beads of slime drool from his stretched hole, first sluggishly and then squirting with each rocking thrust as you fill him up, until thick lines of come drool down your scales, smearing all across his thighs.
	Size 3 -> erupting into his ass, your other cock spraying your load all across his body in messy waves, pulse after pulse until your coils and his body alike are coated with your load. His guts gurgle as you flood his ass, pump ater pump trapped inside -- more and more squirting from his broken-wide hole, but still not enough to match what you're pumping inside him. His stomach swells, the lump of your cock becoming rounded, sloshing and gurgling with each pump, a messy flood of come bursting from his ass sluggish seconds after each pulse.
	Size 4 -> absolutely drenching him in your load. A single shot from your cock, dragging back and forth across his back, is enough to paint him head-to-toe in a thick layer of come, messy lines dribbling down his body and making an absolute mess of your coils; you're spraying just as much inside him, guts gurgling and sloshing as you absolutely flood him with your load. He groans brokenly, muscled stomach straining against the force and slowly losing, gut bloating with each pulse until his belly is straining, even the fat swell of your cock lost in the swamp of jizz gurgling deeper and deeper into his guts. His hole clenches and goes slack around your shaft, an explosion of come erupting out of him, but that's nowhere near enough to match what you're still pumping into him.
} You keep fucking him, rolling the very root of your // cock/s // against his stretched hole.

You pull out with a wet slurp, his {worked//gaping//wrecked} hole {
	dribbling your load
	gushing your load in a miniature waterfall
	erupting, ring broken into meaty slabs, an explosion of jizz spraying out of him and showing no signs of stopping, thick burst after burst slobbering out as his hole clenches and gapes
} as you slide off him. He groans and twists, tongue lapping under your chin as he grabs his dick, jerking himself off to a second orgasm in as many minutes, this time painting his chest with the spurts, mouth open as your tongue flits inside, tasting his flesh. He collapses on the bottom of the boat, hand reaching down to cup your spent cocks, fingers milking out the wet dregs, oozing down his fingers.
-}



sexQuadCentaurFrot :: MarkedScene Index Var HamarTabal
sexQuadCentaurFrot b h =
	[ dialog h $ "Sure, we can do that."
	, Narration2 $ case locoplan b of
			Basic Quadruped -> "He rolls you onto your back, "
				/ case bodySpecies Legs b of
					Nothing -> c "tapering amoeboid legs"
					Just _ -> c feet
				/ "in the air, "
			Basic Centaur -> "He lightly checks your shoulder, nearly bodily shoving you over, and you roll with it, splaying out on your backs, "
				/ (if legCount b > 4
					then "all your legs"
					else "legs")
				/ "in the air, cock lolling across your underbelly. He kneels down between your" / hind / "legs"
			f -> bodyFail (Sex QuadCentaurFrot) f
		/ case clothes h of
			Skirt -> c "and pulls off his skirt, tossing it aside"
			x -> "and tugs down his own" / case x of
				Overalls -> "overalls"
				Hazmat -> "pants"
				Welder -> "pants"
				Skirt -> error "unreachable"
		/ ", letting his hard cock loll out, digging into your rubbery flesh."
		/ case piercings h of
			IsPierced -> "His cockhead is pierced with a thick Prince Albert, matching his nipples: a thick U curve threaded out through the underside, metal shiny with pre."
			NotPierced -> mempty
		/ "He shoves his cock across your haunches, shockingly wet and hot, and slides it up"
		/ case bodySpecies Cock b of
			Nothing -> c "along the tight spar of your needle-like dick"
			Just _ ->  "your" / partAdjective Cock / "cock"
		/ ". His tail quirks around his thighs, snake head gazing quizzically at you. He rolls his hips, drooling pre over"
		/ case bodyMat_ (Waist Hind) b of
			Solid (FMat _ x) -> "your" / matword x
			Trans _ _ -> "your" / sides
		/ "."
	, dialog h $ case bodyMat_ Chest b of
		Solid (FMat _ Protoplasm) -> "You're still only half-formed."
			/ Paragraph / "You need a more... substance, before your soul can seem quite there,"
		_ ->
			c "Lemme see you come all over yourself,"
	, Narration2 $ "is what he says, tracing over"
		/ case bodyMat_ Chest b of
			Solid (FMat _ Protoplasm) -> "your soggy, protoplasmic sides"
			Solid (FMat _ Fur) -> "the shaggy fur of your underbelly"
			Solid (FMat _ Coat) -> "the sparse hair along your underbelly"
			_ -> "your sides"
		/ ", one huge hand wrapped around your cock, pumping slow. You buck and" / groan / ", hips hunching up into his grasp, and he presses his other hand against"
		/ case locoplan b of
			Basic Quadruped -> "the spar of your chest"
			Basic Centaur -> "the collarbone of your lower ribs"
			f -> bodyFail (Sex QuadCentaurFrot) f
		/ "to keep you from squirming."
		/ case bodySpecies Head b of
			Just Human -> mempty
			_ -> "Animal noises spill from your throat."
		/ "His callouses are rough on your skin, and increasingly sloppy with his pre, squelching through his fingers as he almost-painfully milks your cock, grip tight"
		/ case bodySpecies Cock b of
			Nothing -> c ", stroking from the faux-sheathed base to sharp tip"
			Just _ -> case dickLocation b of
				Just DickExternal -> c ", stroking from base to tip"
				Just DickSheathed -> ", stroking from the hairy sheath to the" / partAdjective Cockhead / "tip"
				Just _ -> ", stroking from your flushed lips to the" / partAdjective Cockhead / "tip"
				f -> bodyFail (Sex QuadCentaurFrot) f
		/ ". His hairy hips press against your haunches, his cock a hard solid weight, sandwiched along the groove of your hip, dribbling across your belly. He thrusts in time with his strokes, fucking his cock along yours, his knuckles bumping into your soft flesh"
		/ case piercings h of
			NotPierced -> mempty
			IsPierced -> ", thick-gauged piercing"
				/ case bodyMat_ Chest b of
					Solid (FMat _ Fur) -> "scraping over your fur"
					Solid (FMat _ Coat) -> "scraping through your coat"
					Solid (FMat _ Skin) -> "gliding over your skin"
					Solid (FMat _ Scales) -> "gliding over your scales"
					_ -> "sliding over your hip"
				/ ", tugging his cockhead with it"
		/ "."
		/ Paragraph / "Neither of you last long. It's not long before he groans, hand slipping off your chest to brace his weight on the ground, and his cock tenses, twitching sharply once before he comes, spraying a long line up across your underbelly, along his own pumping hand. You come almost in sympathy"
		/ case bodySpecies Chest b of
			Nothing -> c ", soul-body vainly trying to mimic the precise biology of the action; internal clenches and shudders deep inside you as you squirt a messy dribble of colorless fluid"
			Just _ -> "," / groaning / "and lurching,"
				/ hasExternalBalls
					? "balls tugging up in their sac, cock erupting with a messy squirt of come"
					?: "internal clenches and shudders moving deep imside you as you squirt a messy cord of come"
		/ ", thrusting up through his sloppy fist, wet" / em "paps" / "as you fuck his hand. He spills the rest of his load in a few more shots, cloudy grey come splattered starkly across your body"
		/ case bodyMat_ Chest b of
				Solid (FMat _ Protoplasm) -> ", almost soaking through your skin by osmosis"
				Solid (FMat _ Fur) -> ", beading in your shaggy fur"
				Solid (FMat _ Skin) -> mempty
				Solid (FMat _ Scales) -> ", dribbles sliding down between your scales"
				_ -> mempty
		/ "."
		/ Paragraph / "His cock is heavy as he slumps to the side, breathing quicker, pulling you onto your side too."
		/ case locoplan b of
			Basic Quadruped -> "He presses a quick kiss against your" / muzzle / ", tongue flitting over your" / partAdjective Teeth / teeth / "before he kneels up."
			Basic Centaur -> "He slides his hands up to your upper stomach and grabs your hands, pressing a wet raspberry-kiss against"
				/ case specNoun b of
					Just (SplitTaur _ _) -> "the junction of your upper and lower bodies"
					_ -> "your upper stomach"
				/ "before kneeling up, half-tugging you to rise up with him."
			f -> bodyFail (Sex QuadCentaurFrot) f
	] <> case bodySpecies Chest b of
		Nothing ->
			-- this is all quad/nothing dialog
			[ dialog h $ "If you're so interested in pretending to be a dog, this might be useful."
			, Narration2 $ c "He pulls an [[ORB]] from a pouch and presses it against your belly, just under where your ribs would be, if you properly had any ribs. It's almost painfully hot."
			, NodeGive $ CA Wolf
			, dialog h $ "Come back after using that, if you want to try out having a real body."
			, Narration2 $ c "He grins, toothy, and the weight of his cock stirs where it's pressed against your leg."
			]
		_ ->
			[ dialog h $
				"That good enough for now?"
				/ Paragraph / "Come back if you wanna fuck me, c'mon."
			]



sexOralBottom :: MarkedScene Index Var HamarTabal
sexOralBottom b h =
	case locoplan b of
		Basic Quadruped -> case clothes h of
			x | x `elem` [Hazmat, Welder] ->
				[ Narration2 $ "He settles down, legs spread, and pulls you between them. His clawed hands drag up your sides, like he's petting you hard"
					/ case bodyMat_ Neck b of
						Solid (FMat _ Protoplasm) -> c ", tugging against the edges of your protoplasmic body until he's patting your muzzle, reaching inside to feel across the spread of your jelly-like teeth"
						_ -> ", tugging at your shoulders, neck, behind your ears until he's"
							/ case mouthType b of
								Mouth -> c "sliding his fingers over your parted lips"
								_ -> "patting your" / muzzle
							/ ", reaching inside to feel across the spread of your" / teeth / ", making you drool down his fingers"
					/ "."
					/ Paragraph / "Then his hand curves around the back of your head, drawing you down to grind your" / muzzle / "against his fat bulge, cock shuddering and hot with only the thick material of his pants between you. His other hand snaps the button and tugs his zipper down, letting his cock loll out: thighs rocky grey and hairy, cock framed neatly by his open zipper, grey flushing dull purple, his fleshy foreskin a thick ring of skin halfway down his fat cockhead, "
					/ case piercings h of
						NotPierced -> "half-retracted"
						IsPierced -> "bulging out around his thick PA piercing"
					/ ". He tugs his balls out a second later, immense and fleshy drooped against the thick material of his pants. His snake tail loops around his waist, looking between you and him almost quizzically."
				, dialog h $ "Hey, get to work."
				]
			x ->
				[ Narration2 $ "He settles down, legs spread, and pulls you close"
					/ case bodySpecies Head b of
						Nothing -> c ", pressing his lips to your imitation-muzzle, his forked tongue flitting over your jelly-like teeth"
						Just _ -> ", pressing his lips to your" / muzzle / ", his forked tongue flitting over your" / partAdjective Teeth / teeth
					/ ". He kisses you, hand cupped along your head, your" / feet / "making a stutter-step motion as you move in, pressing your" / partAdjective Chest / "body against him. His heat billows around you, the hardening spar of his cock pressed up against your underbelly. He moans, parts his lips further, licking into your mouth for a long moment before he falls back with a thump, a strand of his spit trailing between you."
				, dialog h $ "Yeah, let's see how well your mouth works."
				, Narration2 $ case x of
						Skirt -> "He flips up the sodden fabric of his skirt:"
						Overalls -> "He pops a button on the back of his overalls, raising his hips, and shoves them down his legs, pooling on the ground:"
						f -> bodyFail "sexOralBottom" f
					/ "his hairy body exposed, thighs the same rocky grey, cock sticking up, grey flushing dull purple, his fleshy foreskin a thick ring of skin halfway down his fat cockhead, "
					/ case piercings h of
						NotPierced -> "half-retracted, "
						IsPierced -> "bulging out around his thick PA piercing, "
					/ "balls immense and fleshy drooped against the swell of his ass. His snake tail loops around his waist, looking between you and him almost quizzically."
				]
			<>
				[ Narration2 $ Paragraph / "His hand is on your head again, motioning you down, and you bow down, "
					/ case mouthType b of
						Mouth -> c "mouth open"
						_ -> muzzle / "parted"
					/ case bodySpecies Head b of
						Nothing -> ", stub of a tongue lashing as you take his cockhead into what mouth you have"
						_ -> mempty
					/ ". He groans, hips arching, cockhead sliding across"
					/ case bodyMat_ Head b of
						Solid (FMat _ Protoplasm) -> c "the rubbery membrane of your mouth, flesh bulging around it"
						_ -> "your" / muzzle
					/ ". Pre drools from his cock"
					/ case bodySpecies Head b of
						Nothing -> ", not-quite tasteless to you in your current state: overtones of bitter, salt, like your body is trying to get a hold of taste again. You swallow, and the liquid reveals a path deeper inside, maybe osmosing through your flesh directly"
						_ -> "bitter, salty, with a smouldering aftertaste. You swallow, and it burns on the way down"
					/ "."
					/ Paragraph / "You take him in deeper, taking his cock to the back of your mouth and then"
					/ case bodySpecies Head b of
						Nothing -> "pushing him into the deforming opening there, what passes for a throat"
						Just _ -> "deeper, down your tight throat"
					/ ". His broad hand curves along your skull, angling you right, and he thrusts up, sheathing all but the root of his cock in you, hot and pulsing with" / em "life" / ", his heartbeat slowly growing faster."
				]
		Basic x | x `elem` [Biped, Naga, Centaur] ->
			[ Narration2 $ "He stands up in front of you, still groping his cock through his clothes, and pushes you down"
			/ case x of
				Naga -> mempty
				Biped -> "onto your knees"
				Centaur -> "onto your knees, lower body settling to the ground"
				f -> bodyFail "sexOralBottom" f
			/ "so your face is pressed up against his stomach. You stoop down, his other hand across your shoulders, guiding you, and press your"
				/ case mouthType b of
					Mouth -> c "face"
					_ -> c muzzle
				/ "against his"
				/ case clothes h of
					Overalls -> "overalls, rough fabric"
						/ case bodyMat_ Head b of
							Solid (FMat _ Protoplasm) -> c "dimpling your protoplasm"
							Solid (FMat _ x)
								| x `elem` [Skin, Scales, Armor] -> "scraping across your" / matword x
								| x `elem` [Fur, Coat] -> "carding against your" / matword x
							_ -> c "pressing against your flesh"
					Hazmat -> "pants, rubbery material"
						/ case bodyMat_ Head b of
							Solid (FMat _ x)
								| x `elem` [Skin, Scales, Armor] -> "catching on your" / matword x
								| x `elem` [Fur, Coat] -> "dragging against your" / matword x
							_ -> c "catching against your flesh"
					Welder -> "pants, smooth leather"
						/ case bodyMat_ Head b of
							Solid (FMat _ Armor) -> c "dimpling against your armored form"
							Solid (FMat _ x) -> "slick against your" / matword x
							_ -> c "sliding over your flesh"
					Skirt -> c "skirt, sweat-soaked fabric clinging to his shaft, scraping across your lips"
				/ ". His cock throbs just under the surface, and he"
				/ case clothes h of
					Overalls -> "pops a button on his hips, letting his overalls sag down, and then fishes out his cock,"
					Skirt -> "pulls the fabric up, his cock lolling out to smack across your face:"
					x -> "twists his thumb against the button, popping it open, and tugs the loose zipper down, letting his cock loll out in a weighty arch,"
				/ "heavy and hard, fleshy foreskin"
				/ case piercings h of
					NotPierced -> "half-retracted"
					IsPierced -> "warped around his thick PA piercing"
				/ ", revealing the flushed purple flesh of his fat cockhead."
				/ case clothes h of
					Skirt -> c "His cock is fat and heavy, a swath of sweat-soaked pubes plastered to his skin, with his balls hanging down low, draped over his hairy thighs, slowly churning."
					x -> "He shoves his"
						/ case x of
							Overalls -> "overalls"
							Hazmat -> "pants"
							Welder -> "pants"
							f -> bodyFail "sexOralBottom" f
						/ "down to his thighs, hefting his balls out too, immense and fleshy resting over his hairy thighs, slowly churning."
				/ "His cock twitches, purple cockhead glistening with pre."
			, dialog h $ "You wanted it,"
			, Narration2 $ "he says, gesturing at his dick, pointing it so that it's lined up with your" / muzzle / ", just an inch away."
			, dialog h $ "So go on, get it."
			, Narration2 $ "You open your mouth and lick along his cock, tasting it, salt and flesh. He groans, tugging your head to the side to let his cock spill into your mouth"
				/ case mouthType b of
					Muzzle -> ", landing across your tongue, spanning up along your muzzle"
					_ -> mempty
				/ ". Pre drools out, sluggishly, bitter and salty with a smouldering aftertaste. You swallow,"
				/ case piercings h of
					IsPierced -> "his PA clacking against your teeth,"
					NotPierced -> mempty
				/ "and it burns all the way down. You take him deeper, lips wrapping around his shaft, letting his cockhead press against the back of your mouth and then deeper. His broad hand curves around your skull, angling you, and he thrusts forward, sliding his cock down your throat, down to where scratchy hairs start to grow up along his shaft."
			]
		f -> bodyFail "sexOralBottom" f
	<>
		[ Narration2 $ "He groans, experimentally thrusting a few times -- dragging your head back and forth, fucking your throat. "
		/ case piercings h of
			NotPierced -> "He reaches up with his free hand, fingers pinching one of his fat nipples, twisting, "
			IsPierced -> "He reaches up with his free hand, fingers tugging on one of his heavy nipple rings, tugging and then twisting, "
		/ "and he tips his head back, groaning louder."
		/ Paragraph / case locoplan b of
			Basic Quadruped -> "He hunches up -- lying back, hips jerking up to sloppily fuck your face."
			Basic x | x `elem` [Biped, Naga, Centaur] -> "He tightens his grip, hips jerking up to sloppily fuck your face."
			f -> bodyFail "sexOralBottom" f
		/ case bodySpecies Head b of
			Nothing -> "Your jaw bows and bulges, opening wider, "
			Just _ -> "Your jaw opens wider, "
		/ "your teeth pressed against his muscled stomach, his balls coming to rest against your lower jaw, with his cock to the absolute root buried in your throat, his own pre oozing out around his pulsing cock."
		/ case bodySpecies Chest b of
			Nothing -> "It osmoses through your skin, soaking into you."
			_ -> mempty
		/ "Pre gushes down his shaft, the" / em "shlop" / "of his thrusts getting wetter and wetter, jamming your head down on his cock faster and faster as he groans and grunts, until -- not long -- he gasps sharper, shaft swelling, cockhead flaring minutely outward, and he makes three short sharp thrusts in, come spraying hot and shockingly liquid, slowly drooling from your throat in messy lines down his shaft"
		/ case bodyMat_ Head b of
			Solid (FMat _ Protoplasm) -> ", smearing with a stark contrast cloudy grey over your colorless muzzle"
			Solid (FMat _ Fur) -> ", smearing in sloppy lines through your disheveled fur"
			Solid (FMat _ Coat) -> ", smearing in sloppy lines over your sodden coat"
			_ -> mempty
		/ "."
		/ Paragraph / "He pulls out with a gurgling squelch,"
		/ case locoplan b of
			Basic Quadruped -> "his load pouring in dollops across his crotch, splattering across his meaty hips."
			Basic x | x `elem` [Centaur, Biped, Naga] -> "his load puring over your lips in stringy strands, splattering down in the space between you."
			f -> bodyFail "sexOralBottom" f
		/ "You whine, and he grins,"
		/ hasDick
			? (case locoplan b of
				Basic x | x `elem` [Biped, Naga] -> "pressing his" / case clothes h of
						Hazmat -> "boot"
						Welder -> "boot"
						_ -> "foot"
					/ "against your crotch, pinning your" / partAdjective Cock / "dick to your stomach."
				Basic Centaur -> c "looking down your body to where your drooling cock is pinned under your weight."
				Basic Quadruped -> case bodySpecies Cock b of
					Nothing -> c "tugging at the sharp spar of your almost needle-like dick:"
					Just _ -> c "stroking your cock, smearing your pre up and down your aching length:"
				f -> bodyFail "sexOralBottom" f)
			?: (case locoplan b of
				Basic x | x `elem` [Biped, Naga] -> "pressing his" / case clothes h of
						Hazmat -> "boot"
						_ -> "foot"
					/ "against your crotch, grinding against the sensitive flesh there:"
				Basic Centaur -> c "reaching around your body to press some fingers to the unadorned flesh below your taint, dragging up and down over the sensitive flesh there:"
				Basic Quadruped -> c "feeling between your hind legs, cupping nothing:"
				f -> bodyFail "sexOralBottom" f)
	] <>
	if hasDick b
		then
			[ dialog h $ "You sure about only wanting to suck my dick?"
			-- TODO: intro blocking for him blowing you, instead of just jumping over maybe?
			, Choices $ catMaybes
				-- FIXME: write bj top scene for bipeds and naga!
				[ case locoplan b of
					-- Basic Slithering -> pure ("yeah c'mon suck me off", Sex SlitherOral)
					Basic x | x `elem` [Centaur, Quadruped] -> pure ("yeah c'mon suck me off", Sex QuadCentaurOral)
					_ -> Nothing
				, pure ("nah leave it", Sex RejectBlowjob)
				]
			]
		else
			[ dialog h $ "Come back when you've got something to play with and I'll return the favor."
			]

{-
TODO: is there no oral receiving scene for bipeds/nagas?

	SlitherOral -> sexSlitherOral -- this is an oral GIVING scene
	QuadCentaurOral -> sexQuadCentaurOral
-}


sexRejectBlowjob :: MarkedScene Index Var HamarTabal
sexRejectBlowjob b h =
	[ Narration ["He sighs."]
	, dialog h $ "Your loss, I guess."
		/ Paragraph / "Well, see you around."
	]

sexQuadProtoplasmAnal :: MarkedScene Index Var HamarTabal
sexQuadProtoplasmAnal b h =
	[ Narration2 $ Paragraph / "He settles down at your haunches, calloused palm dragging over your haunch"
		/ hasTail ? (case bodySpecies Tail b of
				Nothing -> ", under the triangle-flap of your stumpy tail"
				Just _ -> "and under your tail")
		/ "."
		/ case bodySpecies Legs b of
			Nothing -> "His thumb presses against what would be your asshole; a vague divot in your membrane-skin that stretches as he works his claw inside. "
			Just Unicorn -> "His thumb presses against the plush lip of your ass, spreading your hole easily. "
			_ -> "His thumb presses against your hole, digging in as he works a single clawed finger inside."
		/ case clothes h of
			Hazmat -> "There's a scrape as he shoves his gas mask up a fraction: just over his mouth. He's got huge ogreish teeth, and more importantly as it lolls out and drags up to your"
				/ case bodyMat_ Legs b of
					Solid (FMat _ Protoplasm) -> "imitation-asshole"
					_ -> "asshole"
				/ ", a thick tongue with a forked tip. He kisses your hole, intentionally wet, drooling and spitting as he pushes his tongue into your ass,"
				/ case bodySpecies Legs b of
					Nothing -> "amoeboid membrane stretching wider"
					Just _ -> "hungrily licking deeper"
				/ "."
			_ -> "He leans in, breath humid over your skin, tongue wet as he laps down, fingers and tongue playing around your"
				/ case bodyMat_ Legs b of
					Solid (FMat _ Protoplasm) -> "imitation-asshole"
					_ -> "asshole"
				/ ". He kisses it, intentionally wet, drooling and spitting as he pushes his forked tongue into your ass, "
				/ case bodySpecies Legs b of
					Nothing -> "amoeboid membrane stretching wider"
					Just _ -> "hungrily licking deeper"
				/ "."
		/ "He pulls back with a final lap, spit drooling down the backs of your legs, "
		/ case clothes h of
			Skirt -> c "and unwraps the fold of his skirt, tossing it aside, leaving his hairy body fully exposed:"
			x -> case x of
					Overalls -> "and pops a button on the side of his overalls, "
					Hazmat -> "and opens at the zipper of his pants, "
					Welder -> "and opens at the zipper of his pants, "
					f -> bodyFail "sexQuadProtoplasmAnal" f
				/ "shoving them down his legs. They fall to the deck: his hairy body exposed,"
		/ "thighs the same rocky grey, cock sticking up, grey flushing dull purple, his fleshy foreskin a thick ring of skin halfway down his fat cockhead, "
		/ case piercings h of
			NotPierced -> "half-retracted, "
			IsPierced -> "bulging out around his thick PA piercing, "
		/ "balls immense and fleshy drooped against the swell of his ass. He kneels up, hands on your back maneuvering you down, front paws low and hind up, ass on display"
		/ hasTail ? (", your" / partAdjective Tail / "tail raised high")
		/ "."
		/ Paragraph / "His cock smears through lines of spit, dimpling your skin before it slides home, pressed against your tight pucker. His hands clench your sides, all but dragging you bodily backwards, spearing you on his cock with a low groan. You whine, the stress and pressure of penetration new -- his heartbeat throbbing inside you"
		/ case bodyMat_ Legs b of
			Solid (FMat _ Protoplasm) -> ", his pre filling and then overflowing the shallow divot of your asshole, osmosing through your skin with a strange heat"
			_ -> "his pre flooding into your ass, a thin dribble spilling out around your clenching hole"
		/ ". He thrusts in experimentally, cock stretching your body, heavy balls meeting the backs of your haunches with a wet" / em "plap" / ", streamers of spit and pre"
		/ case bodyMat_ Legs b of
			Solid (FMat _ Skin) -> c "sticking them to your skin"
			Solid (FMat _ Scales) -> c "sticking them to your scales"
			Solid (FMat _ Fur) -> c "grinding into your fur"
			Solid (FMat _ Coat) -> c "matting down your coat"
			_ -> "spilling down your" / hips
		/ "."
		/ Paragraph / "He thrusts again, building up a rhythm, the crack of impact becoming wetter and wetter as his gushing pre drools from your ass, painting a shining smear down the backs of your legs. He clutches your sides, rutting into you, cock twitching. His pace shudders, breath catching in his throat -- he thrusts with three sharp, hard snaps, his load a flooding gush, spraying hard against the inside of your body and instantly overflowing, splattering out against his hairy crotch as he rides out the rest of his orgasm, hot gush after gush painting your insides. He fucks your sloppy hole until he's half-hard, weighty cock elastic and turgid, finally withdrawing with a low groan and a wet slurp, leaving your"
		/ case bodyMat_ Legs b of
			Solid (FMat _ Protoplasm) -> "imitation-asshole"
			_ -> "asshole"
		/ "ridged and swollen, gaping as the mess of his load pours out, "
		/ case bodyMat_ Legs b of
			Solid (FMat co x) -> case co of
				Nil -> c "a cloudy grey sharply highlighted against your colorless skin"
				_ -> case x of
					x | x `elem` [Fur, Coat] -> "cloudy grey soaking your" / matword x
					_ -> "cloudy grey spilling down your" / matword x
			f -> bodyFail (Sex QuadCentaurAnalBottom) f
		/ "."
		/ Paragraph / "He wipes his fingers up the back of one leg, feeding his load right back inside, sliding two fingers back and forth into your hole, finally settling back. "
		/ hasDick
			? ("He leers down, slimy fingers tugging"
				/ case bodySpecies Cock b of
					Nothing -> c "at the sharp spar of your almost needle-like dick"
					Just Goat -> c "at the squirming tip of your goat dick"
					Just Bull -> c "at the gnarled tip of your bull dick"
					Just Unicorn -> c "at the ridge of your flat cockhead"
					Just Human -> c "on your cock"
					Just Snake -> c "over the spiky ridges of your swollen hemipenes"
					Just x -> "on your" / animalName x / "dick"
				/ ".")
			?: (c "He leers down, slimy fingers reaching between your haunches, cupping nothing.")
	-- TODO: see also, if you got a dick he should reask if you wanna fuck him?
	, dialog h $
		if hasDick b
			then "Come back when you wanna fuck me and I'll return the favor."
			else "Come back when you've got something to play with and I'll return the favor."
	]
{-
-- son of hamar-tabal blowing you

-- if you got a dick since last time
He rolls you onto your back, {
	Protoplasm -> tapering amoeboid legs
	_ -> paws
} in the air, and he whistles low at the sight of your cock, {
	NONE -> a sharp spar standing out straight from your haunches and almost needle-like at the tip
	Wolf -> fat and tapered at the tip, already stabbing out from your furry sheath
}.

>This is new,

he says, and then his mouth is on you,
-- otherwise
-- (not written)
-- recombine point
forked tongue slipping up the length of your cock to toy with the tip, both hands planted on your hips, pinning you in place as he sloppily blows you. {
	NONE -> A dizzy bolt of pleasure formulates its way through your body, half-remembered or maybe just half-fantasized sensations racing along your skin, like a heartbeat pulsing through your body, focusing on the length of your cock.
	_ -> A dizzy bolt of pleasure shocks through your body, sensations racing along your skin, focusing on the length of your cock.
} He swallows, {sharp//fat} cocktip in the back of his throat, and then swallows again, guiding {the protoplasmic//your wolf} cock down his throat, throat muscles squeezing tight as he takes the entire thing down to the root, brutish face buried between your haunches, slurping and gurgling on your cock.

You fight against his implacable hands, only working a scant inch back and forth, yipping and growling, but he takes mercy -- he draws back, one hand wiping his own drool from his cheek, the other wrapping around {
	Wolf -> your already-developing knot
	_ -> the base of your cock
} -- and you flip over, your legs splayed around his head as you press him back against the bench, cock pressing up across his face before he sucks it down again. You mount his face, thrusting down his throat eagerly, all but baying as you ruthlessly fuck his face, his moans rumbling up through your body. He's jerking himself off, the wet sound of his foreskin squelching over his cockhead loud even over your yipping animal sounds.

Your cock plunges root-deep, underbelly meeting his messy face with a wet _plap_, {
	None -> the pseudopod of your cock curving as you fuck right down his throat.
	_ -> your cockhead hammering against the back of his throat before he gags and swallows, sucking you down to the base.
} A pleasure {
	None -> almost
} cracks to life inside you, sharp and aching, and you ride it fast, hammering into his eager throat as {
	None -> your body tries to work out the biology of coming
	_ -> your balls tense, pulling up hard to mash against his face with each thrust
}. You come in a rush down his throat, enough he has to gulp, and then he's moaning into your underbelly, throat sucking hard around your shaft, body shuddering as he sprays hard, load painting in dollops across his stomach and your back, hot and liquid.

{
	Wolf -> Your knot lodges in his mouth, bulging his cheeks, and he groans around it, lips kissing your sheath. You spray your load down his throat, pulse after pulse of acrid wolf seed, and he swallows each time, slurping on your knot. He strokes himself leasurely, working his load into his skin, his other hand heavy on your haunches.

	You dismount his face, dragging him backward as you twist around, and he slides his free hand back, twisting around your cock so it's pressing against his teeth, spit slowly bubbling from his stretched lips, face contorted around your swollen knot. You keep coming, practically pissing out a constant flow, crackling wetly in his throat for minutes, until your knot finally starts to soften.
}

{
	Wolf -> You finally dismount with a messy slurp
	_ -> You pull back
} and he groans, thickly-humped neck straining forward to keep your cock captured in his throat, all but nursing on it as you dribble the last drops into his mouth, spilling {
	None -> colorless
	_ -> cloudy white
} over his swollen lips. He catches you looking down, watching him, and quirks his lips, eyes dark. He licks his lips showily, spit and come making his fangs shine.

-}






{-
Narration
		[ "The son of Hamar-Tabal spots you while you're still on the shore and rows up to the jetty. The planks groan under your hooves as you step out onto it."
		]
	, Dialog "/static/img/icon.png" "Son of Hamar-Tabal"
		-- obv. this line would be set to trigger only after generic-quadruped sex
		[ "Look at you. I hardly recognized you. Not a wolf after all, huh?"
		-- this line is more "line used when fucking a big animal-type" {THOUGH IT'S ALSO NO LONGER SETTING-ACCURATE :V}
		, "I think you'd capsize the boat if I tried to let you in."
		]
-}

sexQuadCentaurOral :: MarkedScene Index Var HamarTabal
sexQuadCentaurOral b h =
	[ Narration2 $ (case clothes h of
			Hazmat -> "He reaches up, thumb digging into the underside of his gas mask, and shoves it up, just over his mouth. He's got huge ogreish teeth, and when he licks across your cockhead his tongue is thick, with a groove down the middle that splits at the tip. He's all but drooling, blind now, as he rubs his hands against your flanks, practically crawling under you."
				/ case dickLocation b of
					Just DickSheathed -> "Your cock unsheaths across his face"
					Just DickExternal -> "Your cock slaps across his face"
					Just _ -> "Your cock spills from your vent"
					f -> bodyFail (Sex QuadCentaurOral) f
				/ ", smearing first the rubber of his mask and then his face with slime."
			_ -> "He practically crawls under you, face pressed against your underbelly, "
				/ case dickLocation b of
					Just DickSheathed -> "your shaft unsheathing across his face, smearing it with slime"
					Just DickExternal -> "your cock hanging low between your haunches and smearing his face with slime"
					Just _ -> "your shaft spilling out from your vent, smearing his face with slime"
					f -> bodyFail (Sex QuadCentaurOral) f
				/ ".")
		/ "He gulps it down: mouth open wide as he takes the first inches in, lips sealing around the shaft, tongue smearing the length with his drool. You" / groan / "," / feet / "stamping the ground with loud crashes, and his only response is to shift himself fully underneath you on his knees, back pressed against your underbelly, head buried in your crotch. His mouth is hot and slick around your cock"
		/ case bodySpecies Cock b of
			Just x | ridgedCockhead x -> ", lips wrapped around your fat cockhead"
			_ -> ", throat milking the sharp tip"
		/ case dickLocation b of
			Just DickExternal -> mempty
			Just _ -> ", tongue scraping off the slime that coats your still-unsheathing length"
			_ -> mempty
		/ "."
		/ Paragraph / "You" / groan / "and thrust forward; his throat milks your shaft as it plunges deeper; his groan is silent, just rumbling around your cock."
		/ case locoplan b of
			Basic Centaur -> "You reach down, his ass between your front legs, his snake tail curling around his hip to latch onto his cock. You rub your fingers along his crack, his puckering hole practically sucking them in. He groans, jerking back and forth, fucking himself on your fingers as he dives back onto your cock, back and forth."
			_ -> mempty
		/ hasDickAttr Medial
			? (Paragraph / "Your medial ring bashes against his face, bruising his lips and stopping his descent. You rut against him a few times, smacking the bloated, rubbery ring against his face, each time making him gag and retch, coughing a mess of slime back up across your cock, before his hands grip tighter around your" / hips / "and you drive in, forcing his lips to spread around the fat ring, popping it into his mouth with an obscene" / em "slurp" / "and driving all the rest of your shaft down to"
				/ case dickLocation b of
					Just DickExternal -> c "the root"
					Just _ -> "your" / sheath
					f -> bodyFail (Sex QuadCentaurOral) f
				/ "in a single plunge, impaling him on the full length of your cock.")
		/ hasExternalBalls ? "Your balls swing forward, smacking his neck with a solid thump; the impact coaxes a blast of pre that races down your length and erupts straight into his stomach."
		/ Paragraph / case dickLocation b of
			Just DickSheathed -> "His lips meet the saggy flesh of your sheath, dimpling out in a grotesque kiss that leaves his lips smeared and frothy with slime, a wet" / em "smack" / "each time you hilt in his throat."
			Just DickExternal -> "His lips press against the root of your cock, tongue milking the base of your shaft. A gush of frothy slime erupts past his lips with a wet" / em "crack" / "every time you hilt in his throat."
			Just _ -> "His lips meet the swollen flesh of your spread vent in an obscene kiss, tongue and teeth nipping at your flushed lips, even as he gags and drools frothy slime into your cloaca. Each thrust hits his face with a" / em "smack" / ", making him cough up slick, slobbery messes of pre each time you hilt in his throat."
			f -> bodyFail (Sex QuadCentaurOral) f
		/ "His throat muscles spasm erratically with each twitch of your cock, sheathing your shaft in a slick, silky passage, clenching and spreading. Burbles of slime continually work their way up his throat, drooling from his bruised lips and oozing from his nose, face pinned tight against your underbelly, hidden under your own bulk."
		/ hasExternalBalls ? "He tugs your balls, fist-sized and asymmetrical, grunting and moaning as his tongue lashes the underside of your length."
		/ Paragraph / "Your bucking thrusts drive against him"
		/ case dickLocation b of
			Just DickSheathed -> ", grinding his face against your sheath with each one"
			Just DickExternal -> ", sinking your shaft down to the root"
			Just _ -> ", grinding his face against your puffy vent with each one"
			f -> bodyFail (Sex QuadCentaurOral) f
		/ "and letting him gurgle around your fat cock. He blows you, sloppily, cords of spit and slime pouring from his mouth, providing an open hole for you to fuck as you jerk forward, ramming hard into his broken-open throat."
		/ Paragraph
		/ case ballProduction b of
			Just p | cumflates p -> "Your balls shudder, clenching,"
				/ hasExternalBalls
					? "the flesh of your sac furrowing, trying vainly to pull them up tighter against the underside of your cock, and only making your weighty sac grind against his face."
					?: "squeezing inside you as you come closer."
			_ -> mempty
		/ "Your entire body shudders, heat tangling in your gut, hot pleasure buzzing along your shaft: from the base, the son of Hamar-Tabal's lips spread wide around it, all the way down to the tip, sunk down into his stomach, grinding against his inner walls. You thrust, short and sharp, smacking his face against your crotch as you get close, until with a bellow" / hasClimaxAttr Flaring ? "your flare snaps wide and" / "you erupt."
		/ case firstOf [Twisting, Flaring] climaxAttrs b of
			Just Twisting -> "Your cock twitches to the left and then twists, the flesh spiraling in his throat as you erupt."
			Just Flaring -> "Your flare pulls at his internal walls, its gristly rim digging into the underside of his collarbone and warping his flesh. It's visible through his stomach, its outline softened by his flesh and muscle into a round bulge jutting out just below his ribs."
			_ -> mempty
	] <> case ballProduction b of
		Just p | cumflates p ->
			[ Narration2 $
				"Your balls pump hard, internal passageways spreading open with a perceptible stretch, sending an enormous gush of come rocketing up your shaft and straight into his stomach. His muscles tense from the shot, impacting inside him, sloshing around, slurping over your shaft. You groan, rutting against him as you erupt, cock making obscene slurps and squelches as you pump the final few inches back and forth over his bruised, bloated lips. He's gagging continuously, a sloppy mess of phlegm and come gurgling up his throat and"
				/ hasExternalBalls
					? "spilling down your weighty balls"
					?: "splattering back against your haunches"
				/ ", slathering his face in slime and then winding down the rest of his body, but that's a fraction compared to what you're emptying inside him."
				/ Paragraph / "Each twitch of your cock sprays a rope of come into his stomach, filling him up, immersing your cock in a sea of swampy heat that churns with each addition, currents forming in the sloppy mess as you keep unloading. His stomach ripples, spreading further and further, his muscular abs going slack as they're pushed from within, skin stretching to try to accommodate the sheer volume of your load. His gut sways, hanging heavy, pinning his own hard cock down between his thighs."
				/ Paragraph / "Through all of it, the sounds don't stop: the smack and slosh of each squirt splattering inside him, the wet, gagging gurgle as he coughs up come, the squelch from your thrusts, smacking"
				/ case dickLocation b of
					Just DickExternal -> c "the root"
					Just _ -> "your" / sheath
					f -> bodyFail (Sex QuadCentaurOral) f
				/ "against his lips. he gags, face covered in froth, the junction of your crotch a mess of hanging cords of sludge, jiggling with each motion and beating wetly across his face, thick planes of slime drawn out between you, pouring sluggishly down his body, over his bloated, pregnant-looking gut."
				/ Paragraph / "His skin's stretched taut like a drumskin, and it stretches more in juddering bursts: thick stretch marks, raw purple-red, open across his sides and belly, each one relieving a fraction of the pressure."
				/ Paragraph / "You take a step backward, just dragging him with you"
				/ hasClimaxAttr Flaring ? ", flare still spread, locked in his stomach"
				/ ", and then pull again, harder. your shaft slurps its way up his throat, halfway, emerging so thickly-coated with come that all form and shape is lost in a sludgy cocoon of come. He's vomiting up come in earnest now, throat less blocked, and you yank your cock out with a rubbery" / em "pop" / ", his jaw hanging too-low, askew. You rut your still-spurting cock against his face, smearing him more thickly with your load."
				/ Paragraph / "He hunches over, on all fours, gagging on the mess flooding his throat, gargling, come pouring from his mouth before he heaves and vomits, splattering the ground with thick, clotted cords of come, a hand shoving into his mouth to grab ahold of thicker slime and physically drag it out, piles of come rippling his his spasming throat, gut shuddering and swaying."
				/ Paragraph / "He gags and heaves, drawing in a rattling breath, coughing and wheezing. He dimly tries to go through some motions: coughing, swallowing, wiping his mouth with the back of his hand, but he gags and heaves midway through, puking up another mouthful of come, drooling from his slack mouth. He tries to say something, probably, just gurgling as he coughs up more come."
			, dialog h $ "Fuck, that was a lot." / hasExternalBalls ? "Guess I knew what I was getting into, though, huh?" ?: "You pent up, or that just regular?"
			, Narration2 $ c "His voice is watery and hoarse, and he ends with another gag, come drooling down his chest, over the pregnant-looking bulge of his swollen gut. He's still feeling over it with one hand, hissing when his fingers drag over the oozing stretch marks. He tips his head to the side, half-spitting, half-vomiting more come, ending with a gurgling groan."
			, dialog h $ "Well, you know where I'm at if you wanna have another go later."
			]
		_ ->
			[ Narration2 $
				"He gags, throat spasming around your cock as he coughs, sputtering what little of your load works its way up his throat across your underbelly, painting it and his face alike in"
				/ case fromMaybe Come $ cumtype b of
						Come -> "messy clots of grimy, off-white slime"
						Lava -> "molten lava, burning incandescence slowly fading as it forms wrinkled black streams down his face, pouring to the ground in sheets"
						Ferrofluid -> "your reflective mercury-like come, already separating from his spit as it churns and warps on its own, rippling down his cheeks in sloppy, asymmetrically-marred patterns of spikes and domes"
						Ichor -> "tarry black ooze, jaw chewing through the chunky mess. Fat worms drool from his gaping mouth, slowly slithering down his chin as he swallows mouthful after mouthful of rotten ichor"
						Milk -> "streaming rivers of sweet milk"
						Drool -> "rivers of drool, face completely sheened in clear slime, slurping past his lips as he tries to swallow"
						Sap -> "thick syrupy dollops of brilliant green sap, scent sharp in the air"
						GlowingBlack -> "slick black ooze. It streams down his face in sloppy drops, leaving behind slimy trails of glowing slime"
				/ "."
				/ Paragraph / "You step back once you've spent your load, revealing his disheveled body -- his pants dropped to the ground at some point, and his snake tail is twisted between his thighs, sucking him off; his body sheened in sweat, hair matted to his skin; his face covered in"
				/ case fromMaybe Come $ cumtype b of
					Come -> "slime and froth"
					Lava -> "drooling lava"
					Ferrofluid -> "serrated waves of your metallic come"
					Ichor -> "black ooze"
					Milk -> "a sheen of watery milk"
					Drool -> "slime and froth"
					Sap -> "thick, resiny sap"
					GlowingBlack -> "rivulets of glowing slime"
				/ ","
				/ case clothes h of
					Hazmat -> "gas mask soaked and partly flooded with your load, the black glass washed from the inside with "
						/ case fromMaybe Come $ cumtype b of
							Come -> "white come"
							Lava -> "glassy streams of cooling rock"
							Ferrofluid -> "metallically-reflective splotches of ferrofluid"
							Ichor -> "chunky black ichor"
							Milk -> "white milk"
							Drool -> "shiny spit"
							Sap -> "bright green sap"
							GlowingBlack -> "black slime"
						/ "."
					_ -> "eyes watering, "
						/ case fromMaybe Come $ cumtype b of
							Come -> "come"
							Lava -> "glassy streams of cooling rock"
							Ferrofluid -> "metallic ferrofluid"
							Ichor -> "ichor"
							Milk -> "milk"
							Drool -> "your spit"
							Sap -> "bright green sap"
							GlowingBlack -> "more black slime"
						/ "drooling from his mouth and nose."
				/ "He's grunting, huffing, thrusting into his tail's snake-mouth, head almost pillowed on his arms. He comes with a groan, eyes fixed solidly on the" / partAdjective Cock / "length of your cock, drooling the dregs of its load on the ground before him."
				/ Paragraph / "His voice is hoarse when he speaks; he gulps between words, drinking down the messy slurry you left in his mouth:"
			, dialog h $ "You gotta make this a regular thing, yeah?"
			]

sexQuadCentaurAnal :: MarkedScene Index Var HamarTabal
sexQuadCentaurAnal b h =
	[ Narration2 $ case clothes h of
			Overalls -> "He presents himself eagerly, snapping the clasps on his hips and shoving his pants just under his fat ass cheeks."
			Skirt -> "He presents himself eagerly, just tearing his wrapped skirt off in a single motion, leaving him naked, fat ass on display."
			x -> "He presents himself eagerly, snapping the button on his pants and shoving them down, just under his fat ass cheeks."
		/ "He's grey-black and hairy, and the muscle of his asshole is already twitching, spreading itself in anticipation. You slap your cock against your underbelly, the sharp" / em "crack" / "sending a surge of pre splattering forward, just barely pattering across his "
		/ case clothes h of
			Hazmat -> "boots"
			Welder -> "boots"
			_ -> "bare feet"
		/ ". Rocky gravel crunches under your" / feet / "as you step forward, the gushing flow of your pre splattering up his thighs, squirting up his back just before your cockhead makes contact, a sudden sharp pressure as you slide up the side of his cheek. You draw back, aim your cock at his hole, and thrust forward hard, cockhead crashing against his skin and sliding up past his asshole, sandwiching your shaft between his cheeks as you dribble another gush of pre across his back. You both groan, mixed frustration and anticipation, and his pucker throbs against the side of your shaft, sucking like a mouth. You roll back, cock slurping as it pulls free to hang down just before his ass, spurting pre all across his ass and thighs. He leans forward, tail wrapping around your shaft, and holds it steady, letting him sit back and guide the gushing tip to his hungry hole."
		/ Paragraph / "The lips of his ass spread around your" / partAdjective Cockhead / "cockhead, sucking you in, and he groans, tail going slack around your shaft. He's hot inside, asshole plush, the walls of his ass rippling and clenching around your cock. You" / groan / "and slam inside, jerking forward as he pushes back; the both of you sending your cock plunging inside him with an obscene squelch and a spray of pre"
		/ case firstOf [Medial] dickAttrs b of
			Just Medial -> ", your medial ring smacking against his hole with a wet" / em "crack" / ", pulling back webbed with your own goopy pre before you thrust in again," / groaning / "as his gaping hole spreads wider around its rubbery ridge."
			_ -> ", squirting back across your" / hips / "."
		/ "His hole swallows up nearly your entire shaft"
		/ case firstOf [Knotted] dickAttrs b of
			Just Knotted -> ", your half-engorged knot smacking against his rim,"
			_ -> ", almost hilted inside him,"
		/ "and he bellows, tail lashing, asshole clenching tight. You snort and hunch forward, sliding it in"
		/ case dickLocation b of
			Just DickExternal -> "to the very base"
			Just DickSheathed -> "until your leathery sheath presses against the burning ring of his stretched asshole"
			Just _ -> "until your splayed lips press against the burning ring of his stretched asshole"
			f -> bodyFail "sexQuadCentaurAnal" f
		/ hasExternalBalls ? ("; a half-second later your" / partAdjective Balls / "balls slap against his skin, sending droplets of pre splattering in all directions")
		/ ". He's already leaking, his inner muscles convulsing, squirting your endless flood of pre out around your shaft. Wet dribbles at first, each withdrawal leaving your shaft streaked and dripping with pre, more slurping inside him and winding its way down to ooze out around your shaft. Your cock shudders, heat curling inside your gut, and you gush a sloppy mess of pre inside him, more and more as you buck forward again, hilting this time with a splatter of pre, displaced from his already-full ass."
		/ Paragraph / "You buck forward," / feet / "stamping down,"
		/ hasLocotype Centaur ? (hands / "reaching down to clasp his shoulders,")
		/ "driving your cock into him with brutal force, again and again, as he just takes it and moans, shoving himself back into the bulk of your body."
	] <> case ballProduction b of
		Just p | cumflates p ->
			[ Narration2 $
				Paragraph / "You let out a" / groan / ", his milking hole bringing you off -- balls tensing, "
				/ hasExternalBalls
					? "your mammoth sack slapping against his skin and settling there, wetly grinding up and down as you thrust sharp and shallow"
					?: "pulsing and squeezing inside you, internal passages spasming as fluid ripples inside you"
				/ "."
				/ case firstOf [Flaring, Twisting] climaxAttrs b of
					Just Flaring -> "Your flare shudders, scraping tighter against the warped and stretched walls of his guts, and then it snaps outward with a sudden tug, making him wail beneath you."
					Just Twisting -> "Your cockhead lurches, clenching at the tip, and it skews to the side and then furls over itself, twisting itself into a gnarled lump."
					_ -> mempty
				/ "There's a hard throbbing below the base of your cock, internal muscles spasming, pumping, and you bellow as the first shot erupts inside him, sharp enough that it knocks the breath from his lungs with a" / em "whoof" / ", leaving him gasping as you dump your load inside him"
				/ hasClimaxAttr Twisting ? ", each shot spraying in a different direction from your squirming, corkscrewed-up cockhead"
				/ ". You keep thrusting as you come"
				/ hasClimaxAttr Flaring
					? ", each movement dragging his guts with it, tightly-stretched around your broad flare, and incidentally trapping the full volume of your load inside his already-bloating gut"
					?: ", come already squirting out around your shaft, his muscular stomach already starting to bloat and deform from the sheer volume"
				/ ". He groans, a wet gurgle coming from his throat, and he sinks lower to press one hand against his stomach, the pressure of his palm felt dimly against your cock as it trembles and spurts inside him."
				/ Paragraph / "You dump rope after rope of come inside him, flooding his guts with the heavy, liquid weight of your load. Your cock keeps twitching, and you keep bucking inside him"
				/ hasExternalBalls
					? (", balls mashing against his ass, grinding down"
						/ (not . hasClimaxAttr Flaring) ? "drenched in the sloppy squirting overflow spraying out of his flooded ass with each new shot")
				/ ", flooding him until his belly is a wobbling, sloshing mess, flesh rippling with each new pulse churning the mass of come in his stretched-out guts."
				/ Paragraph / "You hunch forward, grinding the root of your cock against his blown-out asshole, driving that much more of your cock inside him, and he just gurgles."
				/ hasClimaxAttr Flaring
					? "Your flare shudders, the pressure of your entire load bearing down on it: you can feel a wet dribble of come squirt out around it, his guts the weak point, warping and bloating in asymmetrical lumps just before your flare as he starts to leak. He's properly bloated now,"
					?: "Even with the flood pouring out of him he's growing more and more bloated,"
				/ "gut hugely round, taut and shuddering, swaying beneath him as he shudders and writhes. Dark lines of new stretch marks seam open over his sides and chest, his flesh stretching wider in jerks and bursts. His gut catches against the ground, scraping through the grit, leaving coarse pebbles stuck to his sweaty skin, and through the rippling, resonating chamber of come that his blown-out ass has become you can feel his gut catch, pinned between your underbelly and the ground."
				/ Paragraph / hasClimaxAttr Flaring
					? ("That's where the pressure is finally too much for your flare, or his guts, or both. There's a rippling shudder as his guts warp again, bulging out around your flare, and a mess of come sprays down along your shaft in a pressurized wave, erupting out across" / hasExternalBalls ? "your balls" ?: "your haunches" / "in an explosion of thick, grimy come. He wails, come pouring across his ass and thighs, covering the stripy mess of his bloated belly in a thick layer of come: coated inside and out, come puddling beneath him as the barest fraction of the churning mess inside him spills out.")
					?: ("There's a rippling shudder as his guts warp, spread so wide by the mess of come that they're hardly touching your shaft -- like thrusting into a churning lake -- and a mess of come spills down along your shaft, adding to the constant spill pouring from his wrecked asshole" / hasExternalBalls ? "and drooling down your heavy balls" ?: "and squirting back across your haunches" / ". He groans, body shuddering, maybe coming again, as come winds its way down his thighs, smearing over his sides, puddling beneath him.")
				/ "You're still coming, thrusting into his wrecked, sloppy ass, a gaping trench now, adding further spurts to the sucking, squelching ocean inside him. You draw back -- a" / foot / "on his back to keep him in place, instead of dragging him with you -- and your cock spills out with a series of slurps"
				/ hasDickAttr Medial
					? ", medial ring catching on his slack asshole and yanking the entire thing inside-out"
					?: ", his yawning asshole spread so wide it flutters and then folds back on itself"
				/ ", guts prolapsing out of his body, clinging to your shaft as you pull out, until with a final" / em "slurp" / "you pry your cockhead out, leaving him with a wrecked mound of an asshole, blossoming out between his cheeks, allowing you a view of his inner ass: completely flooded by your load, a sloppy reservoir of grimy come, churning and gurgling as he tries to clench his bloated stomach, forcing some small fraction of the mess out in hosing eruptions that subside to only a constant waterfall pouring out of him."
				/ Paragraph / "You step back, thick cords of come still tethered to your cock, stretching out from him like a sloppy tail. He's so drenched in come it's hard to make out his features: just the purple-red flesh of his prolapsed asshole; hair hidden under thick layers of come, thick muscles rounded by slime and froth, come pouring down his ass and thighs in clumpy layers."
				/ Paragraph / "He shudders and slumps to the side, breathing raggedly. His gut sloshes, gurgling, and sways behind the movement, smacking against the ground a half-second later, the impact spewing another gush of come from his cratered ass."
				/ Paragraph / "Yeah, you think you did a good job here."
			] <> analCumflateCloser b h 
		_ ->
			[ Narration2 $
				Paragraph / "You let out a" / groan / ", his milking hole bringing you off"
				/ hasBalls ? (" -- balls tensing,"
					/ hasExternalBalls
						? "their asymmetrical bulk slapping again and again over his skin"
						?: "throbbing painfully inside as your ejaculation milks them again and again")
					/ ". You erupt inside him, each thrust punctuated by a heavy gush of come, flooding his guts until it starts to squirt from his overfilled ass, splattering across your" / sides / "and dripping down, making loud cracks as thick dollops of your load splatter the ground. He slumps forward, asshole squeezing higher and higher until his hole is clenched right under your cockhead."
					/ Paragraph / "You draw back, cockhead pulling out with a slurp that leaves him gaping, asshole unfurled into a meaty bud of purplish flesh, shuddering and trembling as he clenches. You're still coming, spurting across his back and ruined asshole, painting his skin with grimy, off-white slime. Ooze piles up and slowly drools into his gaping hole, winking open and closed as he shudders below you. He's balanced on one forearm, other hand furiously stroking his own cock, and as your still-drooling length drags against his back he comes with an almost pained moan, entire body shuddering from the force of his orgasm, spilling his load in ribbons against the deck."
					/ Paragraph / "You step back once you've spent your load, revealing his disheveled body -- his body sheened in sweat; hair matted to his skin; lower body painted in slime and froth, messy clumps drooling down his legs."
			] <> sexQuadCentaurClose b h {-++
	case locoplan b of
		Basic Centaur ->
			[ Choices
				[ ("fist him", Sex CentaurFist) -- slash fist him again?
				, ("nah we're done here", Sex QuadCentaurClose)
				]
			]
		_ -> sexQuadCentaurClose b h-}

analCumflateCloser :: MarkedScene Index Var HamarTabal
analCumflateCloser b h =
	[ Narration2 $ c "He groans, hands slowly feeling across his bloated stomach, pressing down against the heavy, liquid weight roiling inside him. Then he reaches back -- the stretch pulling at his already-shredded skin and making him groan -- and presses a hand against his blossoming, gaping asshole, fingers catching on his rim and shoving inside, nearly fisting himself and hardly doing anything to stem the flow of come."
	, dialog h $ "Fuck, you really broke me open."
	, Narration2 $ c "He pants hoarsely while he plays with his ass, hissing as he twists his fingers around, tugging his swollen flesh around into a lumpy, asymmetrical spiral."
	, dialog h $ "Gonna take a while to recover from that, huh?"
			/ Paragraph / "But you know where to find me if you wanna try that again."
	]

sexQuadCentaurClose :: MarkedScene Index Var HamarTabal
sexQuadCentaurClose b h =
	[ Narration
		[ "His voice is raspy when he speaks, broken from his moaning:"
		]
	, dialog h $ "You gotta make this a regular thing, yeah?"
	]

sexFist :: MarkedScene Index Var HamarTabal
sexFist b h =
	[ dialog h $ "Fisting, huh."
	, Narration2 $ c "The son of Hamar-Tabal tugs at the waist of his overalls, shoving them down just a fraction lower. He twists back, stomach flexing, and digs a hand in between his thick, fat ass cheeks, arching up to groan as he, presumably, jabs a finger or two into his ass."
	, dialog h $ "Yeahhh, you can do that."
	, Narration2 $ "He rolls back and forth on his feel for a second, finger-fucking himself, and you"
		/ case locoplan b of
			Basic Naga -> "slither"
			_ -> "take a step"
		/ "closer. He's pliant when you bend him over a waist-high factory outcropping; he twists to, regretfully, pull his hand away from his ass. His huge, thickly-muscled cheeks are relaxed and heavy, flesh digging against his overalls. His tail quirks up, snake head lazily twisting back, watching you as you hook your" / fingers / "under the waist of his overalls and tug them down to his thighs. His ass all but springs out, and you spread his cheeks, revealing the purple-grey flesh of his not-so-tight asshole. You run your fingers over his skin and he shudders, a moan bursting from his throat as he slumps forward, ass in the air, grinding back against your" / hand / "."
		/ Paragraph / case dickLocation b of
			Just DickCloaca -> "You shove your fingers into your drooling cloaca"
			Just _ -> "You stroke your dick, smearing slimy pre over your fingers"
			Nothing -> if hasCloaca b
				then "You shove your fingers into your drooling cloaca"
				else if hasHead b
					then "You drool on your hand"
					else "You shove your fingers in his mouth"
		/ ", getting them nice and wet before you press your now-slick" / fingers / "against his puckered asshole, one sliding in effortlessly and two only meeting a fraction of resistance; his asshole is like an immense, thick rubber band: tight and always clamping down, but easily stretching as you slide three and then four" / fingers / "inside"
		/ when (handType b == Claw)
			(", careful to keep your sharp" / fingers / "from slicing his inner flesh.")
		/ Paragraph / "His asshole all but sucks your" / fingers / "inside, and so you press down further, grinding the crest of your knuckles against his broken rim, wiggling it back and forth, slowly bearing down harder, until, with a soft" / em "slurp" / ", you shove it inside. You slide your" / thumb / "up along his crack, his fat cheeks still clamping around your wrist, his asshole clenching and relaxing as you slowly twist your" / hand / "around, sending his cheeks jiggling. Your" / thumb / "notches in your palm," / fingernail / "digging into his asshole, and you slowly slide it in alongside, letting his asshole swallow your entire hand. The son of Hamar-Tabal's head hits the ground with a thump; his voice is muffled when he groans."
		/ Paragraph / "You ease deeper, fingers sliding over the flesh of his inner ass. Inside he's hot and tight and slick, his flesh dragging minutely as you slowly ease your fist back and forth."
		/ case dickLocation b of
			Just _ -> "You tug on your cock with your other hand, gushing a spurt of watery pre all over his ass, and then use your other hand to shove the mess of slime into his ass too."
			-- FIXME: BUT WHAT IF YR HEADLESS??
			Nothing -> "You lean in and spit across his ass, using your other hand to smear it in."
		/ "With the fresh lube it goes smoother, wet" / em "slops" / "sounding when you tug your fist entirely out, letting his blown-open hole slowly clench back together before you notch your fist against it and shove back in. You start slow and pick up speed, until you're punch-fucking him, slamming your fist into his gaping hole and watching his entire body shudder, his half-hard cock continually drooling come as you ravage his limp body, dribbling out in little spurts every time you ram your fist back inside."
		/ Paragraph / "You pull out with a slurp, his asshole blown and bulging out from his body, gaping so wide you can see up inside him, rich purple flesh slimy with"
			-- see above
		/ case dickLocation b of
			Just _ -> "pre"
			_ -> "spit"
		/ ", internal muscles sending the sheets of muscle rippling. You shove your fist back inside, nearly all the way to your elbow, and he comes, cock firing lines into the ground below, his wail trailing off into a ragged groan. You keep working over his ass, and he keeps coming: not in spurts but in a steady drool, a messy mixture of pre and come oozing from his still-hooded cock, in pulses that you can feel firing up inside him."
	, Choices $ catMaybes
		[ guardC (hasDick b) ("NOW fuck him", sexPostFistFuck b)
		--, when (hasDick b) ("jerk off into his ass", ...)
		--, pure ("keep going until he prolapses", ...)
		, pure ("nah i think we're done here", Sex QuadCentaurClose)
		]
	]

-- TODO: these would all need post-fisting flags to change their initial blocking + the state of his asshole
sexPostFistFuck :: BodyGlob -> Index
sexPostFistFuck b = case locoplan b of
	Basic Naga -> Sex SlitherNagaAnal
	Basic Biped -> Sex $ BipedAnal FromFist
	Basic Centaur -> Sex QuadCentaurAnal
	f -> bodyFail (Sex Fist) f

-- not sure if this would need a total rewrite to 1. fit bipeds+nagas too and 2. to get a lot more obscene b/c yr potentially doing this after fisting him already
-- FIXME: this is currently completely unreachable due to the above issues (replicated elsewhere; bodytype-specific)
sexCentaurFist :: MarkedScene Index Var HamarTabal
sexCentaurFist b h =
	[ Narration
		[ "You stoop down, legs folding on the ground, cock pinned under your lower body, still slowly leaking the dregs of your load, and feel across his ass. His cheeks are spread, hairy pucker blown into a bloated lump of meat, hole blossoming out, pulsing like a second heart, unevenly clenching and letting out squirts of come, splattering down his thighs. You run your fingers over his skin and he shudders, a broken moan cracking from his throat as he slumps forward, ass in the air. His blown asshole is slick and slippery, flesh sucking on your fingers, and your fingers slip into his hole with almost no effort, displacing another gush of come as you sink the crest of your hand inside."
		, "His head hits the ground with a thump, voice muffled when he groans, and you ease deeper, fingers sliding over the bruised flesh of his inner ass, hand slick with your own load as it continually squirts and drools out, dripping in lines down your arm. You work your hand back and forth, slowly and then faster as his wheezing moans pick up, until you're punch-fucking him, slamming your fist into his gaping hole and watching his entire body shudder, his half-hard cock continually drooling come as you ravage his limp body, dribbling out in little spurts every time you ram your fist back inside."
		, "You pull out with a slurp, his asshole blown and hanging from his body, gaping so wide you can see up inside him, rich purple flesh coated and drooling come, internal muscles sending the sheets of muscle rippling. You shove your fist back inside, all the way to the forearm, and he comes again, abused cock firing lines into the ground below, wail trailing off into a whimper as his eyes roll back into his head and he passes out."
		, "You at least shove his asshole back into his body, flesh pulpy and soft, your fingers sinking into it as you fold his flesh back over itself, asshole inverting with a soggy slurp as his unconcious body pulls it back inside. It's still so bloated it sticks out between his cheeks, a line of flesh bulging between his cheeks when you flip him over."
		, "He's only out for a minute, coming to still dazed, hips jerking each time his asshole drags across the ground."
		]
	, dialog h $ "Fuck, that was more than I've taken in a while."
	, Narration
		[ "He grins, lopsided, reaching down to milk his dick -- foreskin swollen from the abuse, a smooth bulb of too-hot flesh covering the tip."
		]
	, dialog h $ "How about next time you try your whole arm, huh?"
	, SetFlag (Local InvitedShoulderDeepFisting) 1
	, FauxChoice "yeah definitely"
	, dialog h $ "Well good."
	, Narration
		[ "He collapses to the side, breathing hard, gingerly feeling across his broken ass as you leave."
		]
	]
