module Utility.Monoid
	( guardC
	, guardA
	) where

import Control.Applicative
import Control.Monad

-- for choices
guardC :: MonadPlus m => Bool -> a -> m a
guardC True m = return m
guardC False _ = mzero

guardA :: Alternative f => Bool -> f a -> f a
guardA True = id
guardA False = const empty
