var Item = (function (undefined) {
	var items = new Enum
		( "DUMMY"

		, "LODESTONE"
		, "ORRERY_MECHANISM"

		, "RIVER_WATER"
		, "ETERNAL_FLAME"
		, "SCINTILLATING_CRYSTAL"
		, "MACHINE_PART"

		, "ASH_BLOSSOM"
		, "GNARLED_ROOT"
		, "BUDDING_BRANCH"

		, "SOUL_SKIN"

		, "SOULSTONE_ORE"
		, "RAW_FLAMECRYSTAL"
		, "DEMONS_BONE"
		, "GRAVEN_TABLET"
		, "ACCRETION_DISC"
		, "SUN_STONE"
		, "MOON_STONE"
		, "CHAOS_CRYSTAL"
		, "GLOW_CRYSTAL"
		, "LIONS_MANE"
		, "MANDRAKE"
		, "GOATSBEARD"
		, "ADDERS_FORK"
		, "OX_EYE"
		, "CATTAIL"
		, "HARTS_TONGUE"
		, "TONGUE_OF_DOG"
		, "HORSE_HOOF"
		, "PIGS_TAIL"
		, "ASH"
		, "RUST"

		, "OLD_STONE"
		, "HOWLING_BOTTLE"
		, "BLACK_GOO"
		, "SHIMMERING_MIRROR"
		, "SPINE_POD"
		);

	var names =
		[ ["dummy",
				"whoops"]

		, ["Lodestone",
				"Heavy ore. Continually strains towards the center of the world."]
		, ["Orrery Mechanism",
				"From a device that maps the heavens. Makes sweeping motions."]

		, ["River Water",
				"Black and oily. Has an iridescent sheen."]
		, ["Eternal Flame",
				"Refined from the water of the river hubur. Can burn even underwater."]
		, ["Scintillating Crystal",
				"Refined from the water of the river hubur. Has many shining facets, but actually lit from within."]
		, ["Machine Part",
				"Broken off one of the refinery machines. Made from a pale alloy. Etched with acidic holes near the breakage."]

		, ["Ash Blossom",
				"A burnt husk, curled in on itself like a flower."]
		, ["Gnarled Root",
				"Crooked and bent in on itself, but green with new growth."]
		, ["Budding Branch",
				"The limb of a tree, growing on its own. Its buds are purplish and tightly-furled."]

		, ["Soul Skin",
				"The shed skin of a lost soul. Damp and colorless."]

		, ["Soulstone Ore",
				"Named for its dull, colorless shine and magical potential."]
		, ["Raw Flamecrystal",
				"Liquid fire churns within the hollow crystal's chambers."]

		, ["Demon's Bone",
				"Glassy and black, like obsidian, and carved in intricate patterns."]

		, ["Graven Tablet",
				"An ancient stone tablet, engraved in a lost language."]
		, ["Accretion Disc",
				"A whirling spiral of energy, feeding a consuming core."]
		, ["Sun Stone",
				"A miniature sun. Intensely bright, but no heat."]
		, ["Moon Stone",
				"A miniature moon. Could be an egg."]
		, ["Chaos Crystal",
				"Ringing with fell power, from beyond the edge of the world."]
		, ["Glow Crystal",
				"Waxy to the touch. Gives off a pulsing, pearlescent glow."]

		, ["Lion's Mane",
				"A fuzzy and golden tangle."] // [LION]
		, ["Mandrake",
				"Root in the shape of a human. The limbs taper to fibrous points. Screams constantly."] // [HUMAN]
		, ["Goatsbeard",
				"Like half-spun thread. Tufts out in all directions."] // [GOAT]
		, ["Adder's Fork",
				"An ingredient in stews. Diced and fried. From unknown providence."] // [SNAKE]
		, ["Ox Eye",
				"Always looking around in new directions."] // [BULL]
		, ["Cattail",
				"Bristly and furred. Highly flexible."] // [TIGER]
		, ["Hart's Tongue",
				"Thin and hot. Oozes fluid."] // [DEER]
		, ["Tongue of Dog",
				"A blobby round shape. Pinkish. Wet and pulpy."] // [WOLF]
		, ["Horse Hoof",
				"A half-circle of hard material. Covered with innumerable scratches."] // [UNICORN]
		, ["Pig's Tail",
				"Yellow and pink, and tightly curled."] // [BOAR]

		, ["Ash",
				"Ash."]
		, ["Rust",
				"Rust."]

		, ["Old Stone", "A worn pebble of some strange, ancient rock."]
		, ["Howling Bottle", "A bottle with a churning fog inside. Sometimes the bottle vibrates."]
		, ["Black Goo", "A dark viscous substance. At the edges light seeps through red."]
		, ["Shimmering Mirror", "Light plays strangely across the surface of this mirror."]
		, ["Spine Pod", "The dense, spike-covered seed of some strange plant."]
		];

/*

data Item
	= DragonsTear | OgreJawbone | VampireFang | Ectoplasm | DemonsBone | BottledHowl | DryBones | AngelFeather | FossilizedHorn | CoeurlTentacle
	| Mandrake | Cattail | TongueOfDog | HorseHoof | Goatsbeard | HartsTongue | OxEye | CrowsFoot | AddersFork | WoolOfBat | LizardsLeg | SharkFin | InsectClaw | WaspEgg

	| Lodestone
	| CrazedPattern | GnarledRoot | HolyWater
	| TremblingShard | ShockingShard | FulminatingShard | ProteanShard | SnowflakeCrystal | BurningBrooch | AncientJade | HowlingGem
	| GravenTablet | AccretionDisc | ChaosCrystal
	| AquaRegia | AquaFortis | Sulphur | Mercury | Salt | Spirits
	| Ash | Rust
	deriving (Show, Read, Eq, Ord, Enum, Bounded, Data, Typeable)
{-
	RavenFeather -> "Raven Feather"
	UnicornHorn -> "Unicorn Horn"
	LionsMane -> "Lion's Mane"
-}

{-
Sheep			LambsEar
Chicken		RoosterComb
Fox			FoxTail
Frog			ToeOfFrog
Spider		SpidersSilk
Squid
Lion			LionsTail
Tiger
Unicorn
Gryphon
Phoenix		PhoenixPalm
Wolf			WolfFang

Fish			YellowTail
Whale			Ambergris
Bear			BearSinews
-}
blurb :: Item -> String
blurb i = case i of
	DragonsTear -> "A common gem, but famed for its iridescence."
	OgreJawbone -> "Thick and blunt; might be a rock."
	VampireFang -> "Sharp and serrated; might be a rock."
	Ectoplasm -> "From a ghost; green and runny."
	DemonsBone -> "Glassy and black, like obsidian, and carved in intricate patterns."
	DryBones -> "Left exposed to the elements for a century. Brittle and flaking."
	AngelFeather -> "From a fallen spirit. Shiny and metallic, with a solid rachis."
	FossilizedHorn -> "Petrified; from some prehistoric beast."
	CoeurlTentacle -> "Made of many filaments, woven together. Still twitching."

	{-
	RavenFeather -> "A single black feather."
	UnicornHorn -> "A metre long and wickedly sharp. Spiraled like a seashell. Translucent at the edges."
	-}
	LionsMane -> "A fuzzy and golden tangle." -- [LION]
	Mandrake -> "Root in the shape of a human. The limbs taper to fibrous points. Screams constantly." -- [HUMAN]
	Goatsbeard -> "Like half-spun thread. Tufts out in all directions." -- [GOAT]
	AddersFork -> "An ingredient in stews. Diced and fried. From unknown providence." -- [SNAKE]
	OxEye -> "Always looking around in new directions." -- [BULL]
	Cattail -> "Bristly and furred. Highly flexible." -- [TIGER]
	HartsTongue -> "Thin and hot. Oozes fluid." -- [DEER]
	TongueOfDog -> "A blobby round shape. Pinkish. Wet and pulpy." -- [WOLF]
	HorseHoof -> "A half-circle of hard material. Covered with innumerable scratches." -- [UNICORN]
	PigsTail -> "Yellow and pink, and tightly curled." -- [BOAR]

	CrowsFoot -> "Splayed out in all directions like tines on a broken fork."
	
	WoolOfBat -> "Fuzzy and furry. Brown-black."
	LizardsLeg -> "Still twitching."
	SharkFin -> "A pale blue-white. Curved to a sharp point. Ragged where it was torn off."
	InsectClaw -> "Brittle and translucent, but sharp at the tips."
	WaspEgg -> "A buzzing cluster of yellowish eggs."

	Lodestone -> "Heavy ore. Spins slowly on its end. Overpowers gravity."

	CrazedPattern -> "Two-toned, like broken glaze, radiating outward in shattered lines."
	GnarledRoot -> "Crooked and bent in on itself, but green with new growth."
	HolyWater -> "Dew of the divine tree."

	GravenTablet -> "An ancient stone tablet, engraved in a lost language. For the concentration of powers."
	AccretionDisc -> "A whirling spiral of energy, feeding a consuming core. For growth."
	ChaosCrystal -> "Ringing with fell power, from beyond the edge of the world. For uncontrolled change."

	TremblingShard -> "Constantly in motion. Kept in a box."
	ShockingShard -> "Crackles when touched. Kept insulated."
	FulminatingShard -> "Gives off plumes of acrid smoke. Kept submerged."
	ProteanShard -> "Constantly pushing out new roots. Kept over high flame."
	SnowflakeCrystal -> "Grown in a fairy garden. Bitterly cold."
	BurningBrooch -> "Finery from the caverns beneath the world. Glowing hot."
	AncientJade -> "Mined from a primeval forest, eons ago. Still rough-edged."
	HowlingGem -> "A cut piece of glass. Holes on the surface whistle constantly."

	AquaRegia -> "For the testing of mettle."
	AquaFortis -> "For the dissolution of unwanted attachments."

	Ash -> ""
	Rust -> ""

		, ["Sulphur",
				"Essence of action. Full of divine breath."]
		, ["Mercury",
				"Essence of potentiality. Full of divine knowledge."]
		, ["Salt",
				"Essence of substance. Impure, but can be refined."]

    OgreJawbone -> "Thick and blunt. Might be a rock."
    VampireFang -> "Sharp and serrated. Might be a rock."
    Ectoplasm -> "From a ghost. Green and runny."
    RavenFeather -> "A single black feather."
    TremblingShard -> "Constantly in motion. Kept in a box."
    ShockingShard -> "Crackles when you touch it. Kept insulated."
    SnowflakeCrystal -> "Grown in a fairy garden. Bitterly cold."
    BurningBrooch -> "Finery from the caverns beneath the world. Glowing hot."
    AncientJade -> "Mined from a primeval forest, eons ago. Still rough-edged."
    GlassGem -> "Faceted like a cut gem, but hollow inside."
    AccretionDisc -> "A whirling spiral of energy, feeding a consuming core. For growth."
    Ash -> "Ash."
    Rust -> "Rust."
    AquaRegia -> "For the testing of mettle."
    AquaFortis -> "For the dissolution of unwanted attachments."
    Spirits -> "For waking the dead."

		SHED_SKIN
			"Rough to the touch, but still glossy. Judging by the size, from something extremely large."
		UNICORN_HORN
			"A metre long and wickedly sharp. Spiraled like a seashell. Translucent at the edges."
		GOATSBEARD
			"Like half-spun thread. Tufts out in all directions."
		OXEYE
			"Always looking around in new directions."

*/

	function Item (type, count) {
		this.item = type;
		this.count = count;
	}
	Item.prototype =
		// generate a DOM representation of an item (not in an li)
		{ dom: function (detailed) {
				var c, icon;
				c = document.createElement (detailed ? "div" : "span");
				c.classList.add ("item");
				icon = document.createElement ("img");
				icon.classList.add ("itemicon");
				icon.classList.add ("i" + this.item);
				icon.src = ""; // b/c we don't have item icons yet but we still want to render the place where it should go for layout purposes
				c.appendChild (icon);
				//console.log ("item: " + this.item);
				c.appendChild (spanLabel ("iLabel", names[this.item][0]));
				c.appendChild (spanLabel ("iCount", this.count));
				if (detailed) {
					c.appendChild (spanLabel ("iDesc", names[this.item][1], "div"));
				}
				return c;
			}
		}
	function Inventory (starter) {
		this.inv = starter;
	}
	Inventory.prototype =
		{ giveItem: function (item, count) {
				var i;
				for (i = 0; i < this.inv.length; i++) {
					if (this.inv[i].item === item) {
						this.inv[i].count += count;
						if (this.inv[i].count <= 0) {
							this.inv.splice (i, 1);
						}
						return;
					}
				}
				if (count <= 0) {
					return;
				} else {
					this.inv.push (new Item (item, count));
				}
			}
		, takeItem: function (item, count) {
				this.giveItem (item, -count);
			}
		, hasItem: function (item, count) {
				var i;
				for (i = 0; i < this.inv.length; i++) {
					if (this.inv[i].item === item) {
						if (this.inv[i].count >= count) {
							return true;
						}
						return false;
					}
				}
				return false;
			}
		// create a complete DOM representation of the inventory items
		, dom: function () {
				var ul = document.createElement ("ul");
				ul.classList.add ("ilist");
				_.map (this.inv, function (i) {
					var li = document.createElement ("li");
					li.appendChild (i.dom (true));
					ul.appendChild (li);
				});
				return ul;
			}
		};
	
	return (
		{ i: items
		, Item: Item
		, Inventory: Inventory
		});
}());
